﻿//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/map-rtl.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, gmAPI, gmMap,
  gmOverlaysMarker, gmOverlaysInfoWindow, gmEvents, HTMLObjects;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
    {$IFNDEF USE_ANONYMOUS_METHODS}
    procedure MarkerClick(Sender: TObject; Event: TEvent);
    {$ENDIF}
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap,'ar');
end;

procedure TForm1.InitMap(Sender: TObject);
var
  InfoWindow: TInfoWindow;
  Map: TMap;
  Marker: TMarker;
  MarkerOptions: TMarkerOptions;
  MyOptions: TMapOptions;
begin
  with TScript(Sender) do
  begin
    Document.Body.Style.Direction:='rtl';
    MyOptions:=TMapOptions.Create;
    with MyOptions do
    begin
      Zoom:=10;
      Center:=New(Google.Maps.LatLng(30.064742,31.249509));
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
    end;
    Map:=New(Google.Maps.Map(MyOptions));
    MarkerOptions:=TMarkerOptions.Create;
    MarkerOptions.Map:=Map;
    MarkerOptions.Position:=Map.GetCenter;
    Marker:=New(Google.Maps.Marker(MarkerOptions));
    {$IFDEF USE_ANONYMOUS_METHODS}
    Marker.OnClick:=
      procedure(Sender: TObject; Event: TEvent)
      begin
        InfoWindow.Open(Map,Marker);
      end;
    {$ELSE}
    Marker.OnClick:=MarkerClick;
    {$ENDIF}
    InfoWindow:=New(Google.Maps.InfoWindow);
    InfoWindow.SetContent('<b>القاهرة</b>');
  end;
end;

{$IFNDEF USE_ANONYMOUS_METHODS}
procedure TForm1.MarkerClick(Sender: TObject; Event: TEvent);
begin
  with Script do
    InfoWindows[0].Open(Maps[0],Markers[0]);
end;
{$ENDIF}

end.
