//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/control-custom.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, HTMLObjects,
  JScriptObjects, gmAPI, gmMap, gmBase;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//------------------------------------------------------------------------------
//THomeControl

type
  THomeControl = class(TJScriptObject)
  private
    {$IFNDEF USE_ANONYMOUS_METHODS}
    FChicago: TLatLng;
    FMap: TMap;
    procedure Click;
    {$ENDIF}
  public
    constructor Create(ControlDiv: TNode; Map: TMap; Chicago: TLatLng);
  end;

//The HomeControl adds a control to the map that simply returns the user to
//Chicago. This constructor takes the control DIV as an argument.
constructor THomeControl.Create(ControlDiv: TNode; Map: TMap; Chicago: TLatLng);
var
  ControlUI, ControlText: TNode;
begin
  inherited Create;
  with TScript(Script) do
  begin
    //Set CSS styles for the DIV containing the control
    //Setting padding to 5 px will offset the control from the edge of the map
    ControlDiv.Style.Padding:='5px';
    //Set CSS for the control border
    ControlUI:=Document.CreateDivNode;
    with ControlUI do
    begin
      with Style do
      begin
        BackgroundColor:=clWhite;
        BorderStyle:='solid';
        BorderWidth:='2px';
        Cursor:='pointer';
        TextAlign:='center';
      end;
      Title:='Click to set the map to Home';
    end;
    ControlDiv.AppendChild(ControlUI);
    //Set CSS for the control interior
    ControlText:=Document.CreateDivNode;
    with ControlText do
    begin
      with Style do
      begin
        FontFamily:='Arial,sans-serif';
        FontSize:='12px';
        PaddingLeft:='4px';
        PaddingRight:='4px';
      end;
      InnerHTML:='<b>Home</b>';
    end;
    ControlUI.AppendChild(ControlText);
    //Setup the click event listeners: simply set the map to Chicago
    {$IFDEF USE_ANONYMOUS_METHODS}
    Google.Maps.Event.AddDomListener(ControlUI,'click',NewFunction(
      procedure
      begin
        Map.SetCenter(Chicago);
      end));
    {$ELSE}
    FChicago:=Chicago;
    FMap:=Map;
    Google.Maps.Event.AddDomListener(ControlUI,'click',NewFunction(Click));
    {$ENDIF}
  end;
end;

{$IFNDEF USE_ANONYMOUS_METHODS}
procedure THomeControl.Click;
begin
  FMap.SetCenter(FChicago);
end;
{$ENDIF}

//------------------------------------------------------------------------------
//TForm1

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  Chicago: TLatLng;
  HomeControlDiv: TNode;
  Map: TMap;
  MyOptions: TMapOptions;
begin
  with TScript(Sender) do
  begin
    Chicago:=New(Google.Maps.LatLng(41.850033,-87.6500523));
    MyOptions:=TMapOptions.Create;
    with MyOptions do
    begin
      Zoom:=12;
      Center:=Chicago;
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
    end;
    Map:=New(Google.Maps.Map(MyOptions));
    HomeControlDiv:=Document.CreateDivNode;
    THomeControl.Create(HomeControlDiv,Map,Chicago);
    Map.Controls[Google.Maps.ControlPosition.TopRight].Push(HomeControlDiv);
  end;
end;

end.
