//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/control-positioning.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, gmAPI, gmMap;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  MyOptions: TMapOptions;
begin
  with TScript(Sender) do
  begin
    MyOptions:=TMapOptions.Create;
    with MyOptions do
    begin
      Zoom:=12;
      Center:=New(Google.Maps.LatLng(-28.643387,153.612224));
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
      MapTypeControl:=true;
      with MapTypeControlOptions do
      begin
        Style:=Google.Maps.MapTypeControlStyle.HorizontalBar;
        Position:=Google.Maps.ControlPosition.BottomCenter;
      end;
      PanControl:=true;
      PanControlOptions.Position:=Google.Maps.ControlPosition.TopRight;
      ZoomControl:=true;
      with ZoomControlOptions do
      begin
        Style:=Google.Maps.ZoomControlStyle.Large;
        Position:=Google.Maps.ControlPosition.LeftCenter;
      end;
      ScaleControl:=true;
      ScaleControlOptions.Position:=Google.Maps.ControlPosition.TopLeft;
      StreetViewControl:=true;
      StreetViewControlOptions.Position:=Google.Maps.ControlPosition.LeftTop;
    end;
    New(Google.Maps.Map(MyOptions));
  end;
end;

end.
