//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/event-arguments.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, gmAPI, gmMap,
  gmOverlaysMarker, gmEvents;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
    {$IFNDEF USE_ANONYMOUS_METHODS}
    procedure MapClick(Sender: TObject; Event: TMouseEvent);
    {$ENDIF}
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  Map: TMap;
  MyOptions: TMapOptions;
begin
  with TScript(Sender) do
  begin
    MyOptions:=TMapOptions.Create;
    with MyOptions do
    begin
      Zoom:=4;
      Center:=New(Google.Maps.LatLng(-25.363882,131.044922));
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
    end;
    Map:=New(Google.Maps.Map(MyOptions));
    {$IFDEF USE_ANONYMOUS_METHODS}
    Map.OnClick:=
      procedure(Sender: TObject; Event: TMouseEvent)
      var
        MarkerOptions: TMarkerOptions;
      begin
        MarkerOptions:=TMarkerOptions.Create;
        MarkerOptions.Position:=Event.LatLng;
        MarkerOptions.Map:=Map;
        New(Google.Maps.Marker(MarkerOptions));
        Map.PanTo(Event.LatLng);
      end;
    {$ELSE}
    Map.OnClick:=MapClick;
    {$ENDIF}
  end;
end;

{$IFNDEF USE_ANONYMOUS_METHODS}
procedure TForm1.MapClick(Sender: TObject; Event: TMouseEvent);
var
  MarkerOptions: TMarkerOptions;
begin
  with Script do
  begin
    MarkerOptions:=TMarkerOptions.Create;
    MarkerOptions.Position:=Event.LatLng;
    MarkerOptions.Map:=Maps[0];
    New(Google.Maps.Marker(MarkerOptions));
    Maps[0].PanTo(Event.LatLng);
  end;
end;
{$ENDIF}

end.
