//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/event-closure.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, gmAPI, gmMap,
  gmBase, gmOverlaysMarker, gmOverlaysInfoWindow, gmEvents, HTMLObjects;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
    {$IFNDEF USE_ANONYMOUS_METHODS}
    procedure MarkerClick(Sender: TObject; Event: TEvent);
    {$ENDIF}
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

procedure TForm1.InitMap(Sender: TObject);
const
  Message: array[0..4] of String = ('This','is','the','secret','message');
  //The five markers show a secret message when clicked but that message is not
  //within the marker's instance data
  procedure AttachSecretMessage(Marker: TMarker; Num: Integer);
  var
    {$IFDEF USE_ANONYMOUS_METHODS}
    InfoWindow: TInfoWindow;
    {$ENDIF}
    InfoWindowOptions: TInfoWindowOptions;
  begin
    with Script do
    begin
      InfoWindowOptions:=TInfoWindowOptions.Create;
      InfoWindowOptions.Content:=Message[Num];
      {$IFDEF USE_ANONYMOUS_METHODS}InfoWindow:={$ENDIF}
      New(Google.Maps.InfoWindow(InfoWindowOptions));
      {$IFDEF USE_ANONYMOUS_METHODS}
      Marker.OnClick:=
        procedure(Sender: TObject; Event: TEvent)
        begin
          InfoWindow.Open(Marker.GetMap,Marker);
        end;
      {$ELSE}
      Marker.OnClick:=MarkerClick;
      {$ENDIF}
    end;
  end;
var
  n: Integer;
  Bounds: TLatLngBounds;
  SouthWest, NorthEast, Position: TLatLng;
  LatSpan, LngSpan: Double;
  Map: TMap;
  MarkerOptions: TMarkerOptions;
  Marker: TMarker;
  MyOptions: TMapOptions;
begin
  with TScript(Sender) do
  begin
    MyOptions:=TMapOptions.Create;
    with MyOptions do
    begin
      Zoom:=4;
      Center:=New(Google.Maps.LatLng(-25.363882,131.044922));
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
    end;
    Map:=New(Google.Maps.Map(MyOptions));
    //Add 5 markers to the map at random locations
    SouthWest:=New(Google.Maps.LatLng(-31.203405,125.244141));
    NorthEast:=New(Google.Maps.LatLng(-25.363882,131.044922));
    Bounds:=New(Google.Maps.LatLngBounds(SouthWest,NorthEast));
    Map.FitBounds(Bounds);
    LatSpan:=NorthEast.Lat-SouthWest.Lat;
    LngSpan:=NorthEast.Lng-SouthWest.Lng;
    for n:=0 to 4 do
    begin
      Position:=New(Google.Maps.LatLng(SouthWest.Lat+LatSpan*Random,
                                       SouthWest.Lng+LngSpan*Random));
      MarkerOptions:=TMarkerOptions.Create;
      MarkerOptions.Position:=Position;
      MarkerOptions.Map:=Map;
      Marker:=New(Google.Maps.Marker(MarkerOptions));
      Marker.SetTitle(IntToStr(n+1));
      AttachSecretMessage(Marker,n);
    end;
  end;
end;

{$IFNDEF USE_ANONYMOUS_METHODS}
procedure TForm1.MarkerClick(Sender: TObject; Event: TEvent);
begin
  //Closures are only available with anonymous methods.
  with Script do
   InfoWindows[Markers.IndexOf(Sender)].Open(TMarker(Sender).GetMap,TMarker(Sender));
end;
{$ENDIF}

end.
