//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/event-domListener.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw,
  JScriptObjects, gmAPI, gmMap;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
    {$IFNDEF USE_ANONYMOUS_METHODS}
    procedure DIVClick;
    {$ENDIF}
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  Map: TMap;
  MyOptions: TMapOptions;
begin
  with TScript(Sender) do
  begin
    MyOptions:=TMapOptions.Create;
    with MyOptions do
    begin
      Zoom:=8;
      Center:=New(Google.Maps.LatLng(-34.397,150.644));
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
    end;
    Map:=New(Google.Maps.Map(MyOptions));
    //We add a DOM event here to show an alert if the DIV containing the
    //map is clicked. Note that we do this within the intialize function
    //since the document object isn't loaded until after the window.load
    //event.
    {$IFDEF USE_ANONYMOUS_METHODS}
    Google.Maps.Event.AddDomListener(Map.Container,'click',NewFunction(
      procedure(Sender: TObject)
      var
        Event: TJScriptObject;
      begin
        //'Sender' is the TJScriptObject that was created with 'NewFunction()'
        //The 'click' event has one parameter - a object with the x and y
        //position of the click.
        Event:=TJScriptObject(CreateObjectWrapper(Script,TJScriptObject,
                                                  TJScriptFunction(Sender).Arguments[0]));
        ShowMessage('DIV clicked'+', ('+
                    'x: '+IntToStr(Event.Properties['x'])+', '+
                    'y: '+IntToStr(Event.Properties['y'])+')');
      end));
    {$ELSE}
    Google.Maps.Event.AddDomListener(Map.Container,'click',NewFunction(DIVClick));
    {$ENDIF}
  end;
end;

{$IFNDEF USE_ANONYMOUS_METHODS}
procedure TForm1.DIVClick;
begin
  ShowMessage('DIV clicked');
end;
{$ENDIF}

end.
