//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/event-properties.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, gmAPI, gmMap,
  gmBase, gmOverlaysInfoWindow, gmEvents;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    {$IFNDEF USE_ANONYMOUS_METHODS}
    FMyLatLng: TLatLng;
    procedure ZoomChanged(Sender: TObject);
    {$ENDIF}
    procedure InitMap(Sender: TObject);
  public
    {$IFNDEF USE_ANONYMOUS_METHODS}
    property MyLatLng: TLatLng read FMyLatLng write FMyLatLng;
    {$ENDIF}
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  InfoWindow: TInfoWindow;
  InfoWindowOptions: TInfoWindowOptions;
  Map: TMap;
  {$IFDEF USE_ANONYMOUS_METHODS}
  MyLatLng: TLatLng;
  {$ENDIF}
  MyOptions: TMapOptions;
begin
  with TScript(Sender) do
  begin
    MyLatLng:=New(Google.Maps.LatLng(-25.363882,131.044922));
    MyOptions:=TMapOptions.Create;
    with MyOptions do
    begin
      Zoom:=4;
      Center:=MyLatLng;
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
    end;
    Map:=New(Google.Maps.Map(MyOptions));
    InfoWindowOptions:=TInfoWindowOptions.Create;
    with InfoWindowOptions do
    begin
      Content:='Change the zoom level';
      Position:=MyLatLng;
    end;
    InfoWindow:=New(Google.Maps.InfoWindow(InfoWindowOptions));
    InfoWindow.Open(Map);
    {$IFDEF USE_ANONYMOUS_METHODS}
    Map.OnZoomChanged:=
      procedure(Sender: TObject)
      var
        ZoomLevel: Integer;
      begin
        ZoomLevel:=Map.GetZoom;
        Map.SetCenter(MyLatLng);
        InfoWindow.SetContent('Zoom: '+IntToStr(ZoomLevel));
      end;
    {$ELSE}
    Map.OnZoomChanged:=ZoomChanged;
    {$ENDIF}
  end;
end;

{$IFNDEF USE_ANONYMOUS_METHODS}
procedure TForm1.ZoomChanged(Sender: TObject);
var
  ZoomLevel: Integer;
begin
  with Script do
  begin
    ZoomLevel:=Maps[0].GetZoom;
    Maps[0].SetCenter(MyLatLng);
    InfoWindows[0].SetContent('Zoom: '+IntToStr(ZoomLevel));
  end;
end;
{$ENDIF}

end.
