//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/layer-bicycling.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, gmAPI, gmMap,
  gmBase, gmLayers;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  BikeLayer: TBicyclingLayer;
  Map: TMap;
  MyLatLng: TLatLng;
  MyOptions: TMapOptions;
begin
  with TScript(Sender) do
  begin
    MyLatLng:=New(Google.Maps.LatLng(42.3726399,-71.1096528));
    MyOptions:=TMapOptions.Create;
    with MyOptions do
    begin
      Zoom:=14;
      Center:=MyLatLng;
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
    end;
    Map:=New(Google.Maps.Map(MyOptions));
    BikeLayer:=New(Google.Maps.BicyclingLayer);
    BikeLayer.SetMap(Map);
  end;
end;

end.
