//http://code.google.com/apis/maps/documentation/javascript/overlays.html#FusionTables
//http://code.google.com/apis/maps/documentation/javascript/examples/layer-fusiontables-heatmap.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, OleCtrls, SHDocVw, gmAPI, gmMap, gmLayers;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  Layer: TFusionTablesLayer;
  LayerOptions: TFusionTablesLayerOptions;
  Map: TMap;
  MapOptions: TMapOptions;
begin
  with TScript(Sender) do
  begin
    MapOptions:=TMapOptions.Create;
    with MapOptions do
    begin
      Center:=New(Google.Maps.LatLng(10,-140));
      Zoom:=2;
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
    end;
    Map:=New(Google.Maps.Map(MapOptions));
    LayerOptions:=TFusionTablesLayerOptions.Create;
    with LayerOptions do
    begin
      Query.Select:='location';
      Query.From:='579510';
      Heatmap.Enabled:=true;
    end;
    Layer:=New(Google.Maps.FusionTablesLayer(LayerOptions));
    Layer.SetMap(Map);
  end;
end;

end.
