//http://code.google.com/apis/maps/documentation/javascript/overlays.html#FusionTables
//http://code.google.com/apis/maps/documentation/javascript/examples/layer-fusiontables-styling.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, OleCtrls, SHDocVw, gmAPI, gmMap, gmBase,
  gmLayers;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  Australia: TLatLng;
  Map: TMap;
  MapOptions: TMapOptions;
  Layer: TFusionTablesLayer;
  LayerOptions: TFusionTablesLayerOptions;
begin
  with TScript(Sender) do
  begin
    Australia:=New(Google.Maps.LatLng(-25,133));
    MapOptions:=TMapOptions.Create;
    with MapOptions do
    begin
      Center:=Australia;
      Zoom:=3;
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
    end;
    Map:=New(Google.Maps.Map(MapOptions));
    LayerOptions:=TFusionTablesLayerOptions.Create;
    with LayerOptions do
    begin
      Query.Select:='geometry';
      Query.From:='815230';
      with Styles.AddStyle.PolygonOptions do
      begin
        FillColor:='#00FF00';
        FillOpacity:=0.3;
      end;
      with Styles.AddStyle do
      begin
        Where:='birds>300';
        with PolygonOptions do
        begin
          FillColor:='#0000FF';
          //FillOpacity:=0.3;
        end;
      end;
      with Styles.AddStyle do
      begin
        Where:='population>5';
        with PolygonOptions do
        begin
          //FillColor:='#0000FF';
          FillOpacity:=1;
        end;
      end;
    end;
    Layer:=New(Google.Maps.FusionTablesLayer(LayerOptions));
    Layer.SetMap(Map);
  end;
end;

end.
