//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/layer-georss.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, gmAPI, gmMap,
  gmBase, gmLayers;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  GeorssLayer: TKmlLayer;
  Map: TMap;
  MapOptions: TMapOptions;
  MyLatLng: TLatLng;
begin
  with TScript(Sender) do
  begin
    MyLatLng:=New(Google.Maps.LatLng(49.496675,-102.65625));

    MapOptions:=TMapOptions.Create;
    with MapOptions do
    begin
      Zoom:=4;
      Center:=MyLatLng;
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
    end;
    Map:=New(Google.Maps.Map(MapOptions));
    GeorssLayer:=New(Google.Maps.KmlLayer('http://api.flickr.com/services/feeds/geo/?'+
                                          'g=322338@N20&lang=en-us&format=feed-georss'));
    GeorssLayer.SetMap(Map);
  end;
end;

end.
