//http://code.google.com/apis/maps/documentation/javascript/examples/layer-kml-features.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, ExtCtrls,
  HTMLObjects, JScriptObjects, gmAPI, gmMap, gmBase, gmLayers;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    Splitter1: TSplitter;
    Panel1: TPanel;
    WebBrowser2: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    FContentWindow: TNode;
    procedure InitMap(Sender: TObject);
    {$IFNDEF USE_ANONYMOUS_METHODS}
    procedure MarkerClick(Sender: TObject; KmlMouseEvent: TKmlMouseEvent);
    {$ENDIF}
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if not assigned(Script(WebBrowser2)) then
    with TCustomScript.Create(WebBrowser2) do
    begin
      LoadEmptyPage;
      FContentWindow:=Document.CreateDivNode;
      Document.Body.AppendChild(FContentWindow);
    end;
  if not assigned(Script(WebBrowser1)) then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  MyLayerOptions: TKmlLayerOptions;
  MyLatLng: TLatLng;
  MyMap: TMap;
  MyOptions: TMapOptions;
  NYLayer: TKMLLayer;
  Script: TScript;
begin
  Script:=TScript(Sender);
  with Script do
  begin
    FContentWindow.InnerHTML:='';
    MyLatLng:=New(Google.Maps.LatLng(40.65,-73.95));
    MyOptions:=TMapOptions.Create(Script);
    with MyOptions do
    begin
      Zoom:=12;
      Center:=MyLatLng;
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
    end;
    MyMap:=New(Google.Maps.Map(MyOptions));
    MyLayerOptions:=TKmlLayerOptions.Create(Script);
    with MyLayerOptions do
    begin
      SuppressInfoWindows:=true;
      Map:=MyMap;
    end;
    NYLayer:=New(Google.Maps.KmlLayer('http://www.searcharoo.net/SearchKml/newyork.kml',
                                      MyLayerOptions));
    {$IFDEF USE_ANONYMOUS_METHODS}
    NYLayer.OnClick:=
      procedure(Sender: TObject; KmlMouseEvent: TKmlMouseEvent)
      var
        Text: String;
      begin
        Text:=KmlMouseEvent.FeatureData.Description;
        FContentWindow.InnerHTML:=Text;
      end;
    {$ELSE}
    NYLayer.OnClick:=MarkerClick;
    {$ENDIF}
  end;
end;

{$IFNDEF USE_ANONYMOUS_METHODS}
procedure TForm1.MarkerClick(Sender: TObject; KmlMouseEvent: TKmlMouseEvent);
var
  Text: String;
begin
  Text:=KmlMouseEvent.FeatureData.Description;
  FContentWindow.InnerHTML:=Text;
end;
{$ENDIF}

end.
