//http://code.google.com/apis/maps/documentation/javascript/geometry.html
//http://code.google.com/apis/maps/documentation/javascript/geometry.html#Encoding
//http://code.google.com/apis/maps/documentation/javascript/examples/geometry-encodings.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, ExtCtrls,
  gmAPI, gmMap, gmBase, gmOverlaysPolylinePolygon, gmEvents, gmMVC;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    Panel1: TPanel;
    Label1: TLabel;
    EncodedPolyline: TEdit;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    FPoly: TPolyline;
    procedure InitMap(Sender: TObject);
    procedure MapClick(Sender: TObject; MouseEvent: TMouseEvent);
  public
    property Poly: TPolyline read FPoly write FPoly;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap,[libGeometry]);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  Map: TMap;
  MapOptions: TMapOptions;
  Oxford: TLatLng;
  PolyOptions: TPolylineOptions;
begin
  EncodedPolyline.Text:='';
  with TScript(Sender) do
  begin
    Oxford:=New(Google.Maps.LatLng(34.3664951,-89.5192484));
    MapOptions:=TMapOptions.Create;
    with MapOptions do
    begin
      Zoom:=14;
      Center:=Oxford;
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
    end;
    Map:=New(Google.Maps.Map(MapOptions));
    Map.OnClick:=MapClick;
    PolyOptions:=TPolylineOptions.Create;
    with PolyOptions do
    begin
      StrokeColor:=$000000;
      StrokeOpacity:=1.0;
      StrokeWeight:=3;
    end;
    Poly:=New(Google.Maps.Polyline(PolyOptions));
    Poly.SetMap(Map);
  end;
end;

procedure TForm1.MapClick(Sender: TObject; MouseEvent: TMouseEvent);
var
  Path: TLatLngMVCArray;
  EncodeString: String;
begin
  Path:=Poly.GetPath;
  Path.Push(MouseEvent.LatLng);
  EncodeString:=Script.Google.Maps.Geometry.Encoding.EncodePath(Path);
  EncodedPolyline.Text:=EncodeString;
end;

end.
