//http://code.google.com/apis/maps/documentation/javascript/overlays.html#PanoramioLibrary
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, OleCtrls, SHDocVw, StdCtrls,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdHTTP, ExtCtrls,
  ShellAPI, JPEG, gmAPI, gmMap, gmLibrariesPanoramio;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    Panel1: TPanel;
    Image1: TImage;
    IdHTTP1: TIdHTTP;
    Label1: TLabel;
    Image2: TImage;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Image2Click(Sender: TObject);
  private
    FPanoramioURL: String;
    procedure InitMap(Sender: TObject);
    procedure PanoramioLayerClick(Sender: TObject; PanoramioMouseEvent: TPanoramioMouseEvent);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap,[libPanoramio]);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  MyMap: TMap;
  MapOptions: TMapOptions;
  PanoramioLayerOptions: TPanoramioLayerOptions;
  PanoramioLayer: TPanoramioLayer;
begin
  with TScript(Sender) do
  begin
    MapOptions:=TMapOptions.Create;
    with MapOptions do
    begin
      Zoom:=14;
      Center:=New(Google.Maps.LatLng(47.651743,-122.349243));
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
    end;
    MyMap:=New(Google.Maps.Map(MapOptions));
    PanoramioLayerOptions:=TPanoramioLayerOptions.Create;
    with PanoramioLayerOptions do
    begin
      Map:=MyMap;
      SuppressInfoWindows:=true;                           //hide info window
    end;
    PanoramioLayer:=New(Google.Maps.Panoramio.PanoramioLayer(PanoramioLayerOptions));
    PanoramioLayer.OnClick:=PanoramioLayerClick;
  end;
end;

procedure TForm1.PanoramioLayerClick(Sender: TObject; PanoramioMouseEvent: TPanoramioMouseEvent);
var
  n: Integer;
  Title, InfoWindowHTML, ImageURL: String;
  Stream: TMemoryStream;
  Image: TJPEGImage;
begin
  Title:=PanoramioMouseEvent.FeatureDetails.Title;
  if Label1.Canvas.TextWidth(Title)>Label1.Width then      //long title
  begin
    Label1.Hint:=Title;
    Title:=Title+'...';
    while (Length(Title)>0) and (Label1.Canvas.TextWidth(Title)>Label1.Width) do
      Delete(Title,Length(Title)-3,1);
  end else Label1.Hint:='';
  Label1.Caption:=Title;
  Label1.Visible:=Length(Label1.Caption)>0;
  FPanoramioURL:=PanoramioMouseEvent.FeatureDetails.URL;
  Image1.Hint:='';
  Image2.Visible:=Length(FPanoramioURL)>0;
  InfoWindowHTML:=PanoramioMouseEvent.InfoWindowHTML;
  ImageURL:='';
  n:=Pos('src="',InfoWindowHTML);
  if n>0 then
  begin
    Inc(n,5);
    while n<Length(InfoWindowHTML) do
    begin
      if InfoWindowHTML[n]<>'"' then
      begin
        ImageURL:=ImageURL+InfoWindowHTML[n];
        Inc(n);
      end else Break;
    end;
    if Length(ImageURL)>0 then
    begin
      Stream:=TMemoryStream.Create;
      try
        IdHTTP1.Get(ImageURL,Stream);
        if IdHTTP1.ResponseCode=200 then
        begin
          Stream.Seek(0,soFromBeginning);
          Image:=TJPEGImage.Create;
          try
            Image.LoadFromStream(Stream);
            Image1.Picture.Assign(Image);
            Image1.Hint:='Author: '+PanoramioMouseEvent.FeatureDetails.Author;
          finally
            Image.Free;
          end;
        end;
      finally
        Stream.Free;
      end;
    end;
  end;
end;

procedure TForm1.Image2Click(Sender: TObject);
begin
  if Length(FPanoramioURL)>0
    then ShellExecute(Handle,'open',
                      {$IFDEF DELPHI2009_UP}PWideChar{$ELSE}PChar{$ENDIF}(FPanoramioURL),
                      nil,nil,SW_SHOWNORMAL);
end;

end.
