//http://code.google.com/apis/maps/documentation/javascript/places.html#place_details
//http://code.google.com/apis/maps/documentation/javascript/examples/place-details.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, gmAPI, gmMap,
  gmBase, gmOverlaysMarker, gmOverlaysInfoWindow, gmEvents, gmLibrariesPlaces,
  HTMLObjects;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
    {$IFNDEF USE_ANONYMOUS_METHODS}
    procedure Callback(Sender: TObject; SearchResult: TPlaceResult; Status: String);
    procedure MarkerClick(Sender: TObject; Event: TEvent);
    {$ENDIF}
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap,[libPlaces]);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  Map: TMap;
  MapOptions: TMapOptions;
  Pyrmont: TLatLng;
  Request: TPlaceDetailsRequest;
  Service: TPlacesService;
  {$IFDEF USE_ANONYMOUS_METHODS}
  InfoWindow: TInfoWindow;
  {$ENDIF}
begin
  with TScript(Sender) do
  begin
    Pyrmont:=New(Google.Maps.LatLng(-33.8665433,151.1956316));
    MapOptions:=TMapOptions.Create;
    with MapOptions do
    begin
      Zoom:=15;
      Center:=Pyrmont;
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
    end;
    Map:=New(Google.Maps.Map(MapOptions));
    Request:=TPlaceDetailsRequest.Create;
    Request.Reference:='CnRkAAAAGnBVNFDeQoOQHzgdOpOqJNV7K9-c5IQrWFUYD9TNhUmz5-'+
                       'aHhfqyKH0zmAcUlkqVCrpaKcV8ZjGQKzB6GXxtzUYcP-muHafGsmW-'+
                       '1CwjTPBCmK43AZpAwW0FRtQDQADj3H2bzwwHVIXlQAiccm7r4xIQmj'+
                       't_Oqm2FejWpBxLWs3L_RoUbharABi5FMnKnzmRL2TGju6UA4k';
    Service:=New(Google.Maps.Places.PlacesService(Map));
    {$IFDEF USE_ANONYMOUS_METHODS}InfoWindow:={$ENDIF}New(Google.Maps.InfoWindow);
    {$IFDEF USE_ANONYMOUS_METHODS}
    Service.GetDetails(Request,
      procedure(Sender: TObject; SearchResult: TPlaceResult; Status: String)
      var
        Marker: TMarker;
        MarkerOptions: TMarkerOptions;
      begin
        if Status=Google.Maps.Places.PlacesServiceStatus.OK then
        begin
          MarkerOptions:=TMarkerOptions.Create;
          MarkerOptions.Map:=Map;
          MarkerOptions.Position:=SearchResult.Geometry.Location;
          Marker:=New(Google.Maps.Marker(MarkerOptions));
          Marker.OnClick:=
            procedure(Sender: TObject; Event: TEvent)
            begin
              Infowindow.SetContent(SearchResult.Name);
              Infowindow.Open(Map,Marker);
            end;
        end;
      end);
    {$ELSE}
    Service.GetDetails(Request,Callback);
    {$ENDIF}
  end;
end;

{$IFNDEF USE_ANONYMOUS_METHODS}
procedure TForm1.Callback(Sender: TObject; SearchResult: TPlaceResult; Status: String);
var
  Marker: TMarker;
  MarkerOptions: TMarkerOptions;
begin
  with Script do
  begin
    if Status=Google.Maps.Places.PlacesServiceStatus.OK then
    begin
      MarkerOptions:=TMarkerOptions.Create;
      with MarkerOptions do
      begin
        Map:=Maps[0];
        Position:=SearchResult.Geometry.Location;
      end;
      Marker:=New(Google.Maps.Marker(MarkerOptions));
      Marker.OnClick:=MarkerClick;
      Marker.Properties['PlaceName']:=SearchResult.Name;   //additional property
    end;
  end;
end;

procedure TForm1.MarkerClick(Sender: TObject; Event: TEvent);
var
  Marker: TMarker;
  Text: String;
begin
  with Script do
  begin
    Marker:=TMarker(Sender);
    Text:=Marker.Properties['PlaceName'];
    Infowindows[0].SetContent(Text);
    Infowindows[0].Open(Maps[0],Marker);
  end;
end;
{$ENDIF}

end.
