//http://code.google.com/apis/maps/documentation/javascript/examples/maptype-overlay.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, HTMLObjects,
  BrowserTools, gmAPI, gmMap, gmBase, gmMapTypes;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

type
  TCoordMapType = class(TMapType)
  public
    constructor Create(Size: TSize);
    procedure ReleaseTile(Tile: TNode); override;
    function GetTile(TileCoord: TPoint; Zoom: Integer; OwnerDocument: TDocument): TNode; override;
  end;

constructor TCoordMapType.Create(Size: TSize);
begin
  inherited Create;
  TileSize:=Size;
end;

function TCoordMapType.GetTile(TileCoord: TPoint; Zoom: Integer; OwnerDocument: TDocument): TNode;
begin
  Result:=OwnerDocument.CreateDivNode;
  with Result do
  begin
    InnerHTML:=TileCoord.ToLocaleString;
    with  Style do
    begin
      Width:=IntToStr(round(TileSize.Width))+'px';
      Height:=IntToStr(round(TileSize.Height))+'px';
      FontSize:='10';
      BorderStyle:='solid';
      BorderWidth:='1px';
      BorderColor:=WebColorStrToColor('#AAAAAA');
    end;
  end;
end;

procedure TCoordMapType.ReleaseTile(Tile: TNode);
begin
end;

//------------------------------------------------------------------------------
//TForm1

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  Chicago: TLatLng;
  Map: TMap;
  MapOptions: TMapOptions;
begin
  with TScript(Sender) do
  begin
    Chicago:=New(Google.Maps.LatLng(41.850033,-87.6500523));
    MapOptions:=TMapOptions.Create;
    with MapOptions do
    begin
      Zoom:=10;
      Center:=Chicago;
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
    end;
    Map:=New(Google.Maps.Map(MapOptions));
    //Insert this overlay map type as the first overlay map type at position 0.
    //Note that all overlay map types appear on top of their parent base map.
    Map.OverlayMapTypes.InsertAt(0,TCoordMapType.Create(New(Google.Maps.Size(256,256))));
  end;
end;

end.
