//http://code.google.com/apis/maps/documentation/javascript/examples/maptype-styled-complex.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, gmAPI, gmMap,
  gmBase, gmMapTypes;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  Chicago: TLatLng;
  Map: TMap;
  MapOptions: TMapOptions;
  RoadAtlasStyles: TMapTypeStyleArray;
  StyledMapOptions: TStyledMapTypeOptions;
  USRoadMapType: TStyledMapType;
begin
  with TScript(Sender) do
  begin
    Chicago:=New(Google.Maps.LatLng(41.850033,-87.650052));
    RoadAtlasStyles:=TMapTypeStyleArray.Create;
    with RoadAtlasStyles do
    begin
      with AddStyle do
      begin
        FeatureType:='road.highway';
        ElementType:='geometry';
        with Stylers.Add do
        begin
          AddStyler.Hue:='#ff0022';
          AddStyler.Saturation:=60;
          AddStyler.Lightness:=-20;
        end;
      end;
      with AddStyle do
      begin
        FeatureType:='road.arterial';
        ElementType:='all';
        with Stylers.Add do
        begin
          AddStyler.Hue:='#2200ff';
          AddStyler.Saturation:=30;
          AddStyler.Lightness:=-40;
          AddStyler.Visibility:='simplified';
        end;
      end;
      with AddStyle do
      begin
        FeatureType:='road.local';
        ElementType:='all';
        with Stylers.Add do
        begin
          AddStyler.Hue:='#f6ff00';
          AddStyler.Saturation:=50;
          AddStyler.Gamma:=0.7;
          AddStyler.Visibility:='simplified';
        end;
      end;
      with AddStyle do
      begin
        FeatureType:='water';
        ElementType:='geometry';
        with Stylers.Add do
        begin
          AddStyler.Saturation:=40;
          AddStyler.Lightness:=40;
        end;
      end;
      with AddStyle do
      begin
        FeatureType:='road.highway';
        ElementType:='labels';
        with Stylers.Add do
        begin
          AddStyler.Saturation:=98;
          AddStyler.Visibility:='on';
        end;
      end;
      with AddStyle do
      begin
        FeatureType:='administrative.locality';
        ElementType:='labels';
        with Stylers.Add do
        begin
          AddStyler.Hue:='#0022ff';
          AddStyler.Saturation:=50;
          AddStyler.Lightness:=-10;
          AddStyler.Gamma:=0.90;
        end;
      end;
      with AddStyle do
      begin
        FeatureType:='transit.line';
        ElementType:='geometry';
        with Stylers.Add do
        begin
          AddStyler.Hue:='#ff0000';
          AddStyler.Lightness:=-70;
          AddStyler.Visibility:='on';
        end;
      end;
    end;
    MapOptions:=TMapOptions.Create;
    with MapOptions do
    begin
      Zoom:=12;
      Center:=Chicago;
      MapTypeControlOptions.MapTypeIDs.Add([Google.Maps.MapTypeID.Roadmap,'usroadatlas']);
    end;
    Map:=New(Google.Maps.Map(MapOptions));
    StyledMapOptions:=TStyledMapTypeOptions.Create;
    StyledMapOptions.Name:='US Road Atlas';
    USRoadMapType:=New(Google.Maps.StyledMapType(RoadAtlasStyles,StyledMapOptions));
    Map.MapTypes.{$IFDEF AND_OP}&Set{$ELSE}Set_{$ENDIF}('usroadatlas',USRoadMapType);
    Map.SetMapTypeID('usroadatlas');
  end;
end;

end.
