//http://code.google.com/apis/maps/documentation/javascript/examples/maptype-styled-simple.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, gmAPI, gmMap,
  gmBase, gmMapTypes;

const
  MY_MAPTYPE_ID = 'hiphop';

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  Brooklyn: TLatLng;
  Map: TMap;
  MapOptions: TMapOptions;
  Styles: TMapTypeStyleArray;
  StyledMapOptions: TStyledMapTypeOptions;
  JayzMapType: TStyledMapType;
begin
  with TScript(Sender) do
  begin
    Styles:=TMapTypeStyleArray.Create;
    with Styles.AddStyle do
    begin
      FeatureType:='road';
      ElementType:='geometry';
      with Stylers.Add do
      begin
        AddStyler.Hue:='-45';
        AddStyler.Saturation:=100;
      end;
    end;
    with Styles.AddStyle do
    begin
      FeatureType:='landscape';
      ElementType:='geometry';
      with Stylers.Add do
      begin
        AddStyler.Hue:='#000000';
        AddStyler.Saturation:=75;
        AddStyler.Lightness:=-100;
      end;
    end;
    Brooklyn:=New(Google.Maps.LatLng(40.6743890,-73.9455));
    MapOptions:=TMapOptions.Create;
    with MapOptions do
    begin
      Zoom:=12;
      Center:=Brooklyn;
      MapTypeControlOptions.MapTypeIDs.Add([Google.Maps.MapTypeID.Roadmap,
                                            MY_MAPTYPE_ID]);
      MapTypeID:=MY_MAPTYPE_ID;
    end;
    Map:=New(Google.Maps.Map(MapOptions));
    StyledMapOptions:=TStyledMapTypeOptions.Create;
    StyledMapOptions.Name:='Hip-Hop';
    JayzMapType:=New(Google.Maps.StyledMapType(Styles,StyledMapOptions));
    Map.MapTypes.{$IFDEF AND_OP}&Set{$ELSE}Set_{$ENDIF}(MY_MAPTYPE_ID,JayzMapType);
  end;
end;

end.
