//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/circle-simple.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, BrowserTools,
  gmAPI, gmMap, gmBase, gmOverlaysBase;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

type
  TCity = record
    Name: String;
    Center: TLatLng;
    Population: Integer;
  end;

procedure TForm1.InitMap(Sender: TObject);
var
  n: Integer;
  CityCircle: TCircle;
  Citymap: array[0..2] of TCity;
  Map: TMap;
  MapOptions: TMapOptions;
  PopulationOptions: TCircleOptions;
begin
  with TScript(Sender) do
  begin
    with Citymap[0] do
    begin
      Name:='chicago';
      Center:=New(Google.Maps.LatLng(41.878113,-87.629798));
      Population:=2842518;
    end;
    with Citymap[1] do
    begin
      Name:='newyork';
      Center:=New(Google.Maps.LatLng(40.714352,-74.005973));
      Population:=8143197;
    end;
    with Citymap[2] do
    begin
      Name:='losangeles';
      Center:=New(Google.Maps.LatLng(34.052234,-118.243684));
      Population:=3844829;
    end;
    MapOptions:=TMapOptions.Create;
    with MapOptions do
    begin
      Zoom:=3;
      Center:=New(Google.Maps.LatLng(37.09024,-95.712891));
      MapTypeID:=Google.Maps.MapTypeID.Terrain;
    end;
    Map:=New(Google.Maps.Map(MapOptions));
    for n:=0 to Length(Citymap)-1 do
    begin
      //Construct the circle for each value in citymap. We scale population by 20.
      PopulationOptions:=TCircleOptions.Create;
      with PopulationOptions do
      begin
        StrokeColor:=WebColorStrToColor('#FF0000');
        StrokeOpacity:=0.8;
        StrokeWeight:=2;
        FillColor:=WebColorStrToColor('#FF0000');
        FillOpacity:=0.35;
        Center:=Citymap[n].Center;
        Radius:=Citymap[n].Population div 20;
      end;
      CityCircle:=New(Google.Maps.Circle(PopulationOptions));
      CityCircle.SetMap(Map);
    end;
  end;
end;

end.
