//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/groundoverlay-simple.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, gmAPI, gmMap,
  gmBase, gmOverlaysBase;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  ImageBounds: TLatLngBounds;
  Map: TMap;
  MapOptions: TMapOptions;
  Newark: TLatLng;
  OldMap: TGroundOverlay;
begin
  with TScript(Sender) do
  begin
    Newark:=New(Google.Maps.LatLng(40.740,-74.18));
    ImageBounds:=New(Google.Maps.LatLngBounds(
      New(Google.Maps.LatLng(40.712216,-74.22655)),
      New(Google.Maps.LatLng(40.773941,-74.12544))));
    MapOptions:=TMapOptions.Create;
    with MapOptions do
    begin
      Zoom:=12;
      Center:=Newark;
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
    end;
    Map:=New(Google.Maps.Map(MapOptions));
    OldMap:=New(Google.Maps.GroundOverlay(
      'http://www.lib.utexas.edu/maps/historical/newark_nj_1922.jpg',
      ImageBounds));
    OldMap.SetMap(Map);
  end;
end;

end.
