//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/icon-complex.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, gmAPI, gmMap,
  gmBase, gmOverlaysMarker;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

type
  TBeach = record
    Name: String;
    Lat: Double;
    Lng: Double;
    Index: Integer;
  end;

//Data for the markers consisting of a name, a LatLng and a zIndex for the
//order in which these markers should display on top of each other.
const
  Beaches: array[0..4] of TBeach = (
    (Name: 'Bondi Beach';    Lat: -33.890542; Lng: 151.274856; Index: 4),
    (Name: 'Coogee Beach';   Lat: -33.923036; Lng: 151.259052; Index: 5),
    (Name: 'Cronulla Beach'; Lat: -34.028249; Lng: 151.157507; Index: 3),
    (Name: 'Manly Beach';    Lat: -33.800101; Lng: 151.287478; Index: 2),
    (Name: 'Maroubra Beach'; Lat: -33.950198; Lng: 151.259302; Index: 1));

  MarkerURL    = 'http://code.google.com/apis/maps/documentation/javascript/'+
                 'examples/images/';
  MarkerImage  = 'beachflag.png';
  MarkerShadow = 'beachflag_shadow.png';

procedure TForm1.InitMap(Sender: TObject);
var
  n: Integer;
  Beach: TBeach;
  MyImage, MyShadow: TMarkerImage;
  MarkerOptions: TMarkerOptions;
  MyLatLng: TLatLng;
  MyMap: TMap;
  MyOptions: TMapOptions;
  MyShape: TMarkerShape;
begin
  with TScript(Sender) do
  begin
    MyOptions:=TMapOptions.Create;
    with MyOptions do
    begin
      Zoom:=10;
      Center:=New(Google.Maps.LatLng(-33.9,151.2));
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
    end;
    MyMap:=New(Google.Maps.Map(MyOptions));
    //Add markers to the map
    //Marker sizes are expressed as a Size of X,Y where the origin of the
    //image (0,0) is located in the top left of the image.
    //Origins, anchor positions and coordinates of the marker increase in the
    //X direction to the right and in the Y direction down.
    MyImage:=New(Google.Maps.MarkerImage(MarkerURL+MarkerImage,
      //This marker is 20 pixels wide by 32 pixels tall.
      New(Google.Maps.Size(20,32)),
      //The origin for this image is 0,0.
      New(Google.Maps.Point(0,0)),
      //The anchor for this image is the base of the flagpole at 0,32.
      New(Google.Maps.Point(0,32))));
    MyShadow:=New(Google.Maps.MarkerImage(MarkerURL+MarkerShadow,
      //The shadow image is larger in the horizontal dimension while the
      //position and offset are the same as for the main image.
      New(Google.Maps.Size(37,32)),
      New(Google.Maps.Point(0,0)),
      New(Google.Maps.Point(0,32))));
      //Shapes define the clickable region of the icon.
      //The type defines an HTML <area> element 'poly' which traces out
      //a polygon as a series of X,Y points. The final coordinate closes the
      //poly by connecting to the first coordinate.
    MyShape:=TMarkerShape.Create;
    with MyShape do
    begin
      Coord.Add([1,1,1,20,18,20,18,1]);
      {$IFDEF AND_OP}&Type{$ELSE}Type_{$ENDIF}:='poly';
    end;
    for n:=0 to Length(Beaches)-1 do
    begin
      Beach:=Beaches[n];
      MyLatLng:=New(Google.Maps.LatLng(Beach.Lat,Beach.Lng));
      MarkerOptions:=TMarkerOptions.Create;
      with MarkerOptions do
      begin
        Position:=MyLatLng;
        Map:=MyMap;
        ShadowImage:=MyShadow;
        IconImage:=MyImage;
        Shape:=MyShape;
        Title:=Beach.Name;
        zIndex:=Beach.Index;
      end;
      New(Google.Maps.Marker(MarkerOptions));
    end;
  end;
end;

end.
