//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/infowindow-simple-max.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, gmAPI, gmMap,
  gmBase, gmOverlaysInfoWindow, gmOverlaysMarker, gmEvents, HTMLObjects;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
    {$IFNDEF USE_ANONYMOUS_METHODS}
    procedure MarkerClick(Sender: TObject; Event: TEvent);
    {$ENDIF}
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

const
  ContentString =
    '<div id="content">'+
    '  <div id="siteNotice">'+
    '  </div>'+
    '  <h1 id="firstHeading" class="firstHeading">Uluru</h1>'+
    '  <div id="bodyContent">'+
    '    <p>'+
    '      <b>Uluru</b>, also referred to as <b>Ayers Rock</b>, is a large '+
    '      sandstone rock formation in the southern part of the '+
    '      Northern Territory, central Australia. It lies 335&#160;km (208&#160;mi) '+
    '      south west of the nearest large town, Alice Springs; 450&#160;km '+
    '      (280&#160;mi) by road. Kata Tjuta and Uluru are the two major '+
    '      features of the Uluru - Kata Tjuta National Park. Uluru is '+
    '      sacred to the Pitjantjatjara and Yankunytjatjara, the '+
    '      Aboriginal people of the area. It has many springs, waterholes, '+
    '      rock caves and ancient paintings. Uluru is listed as a World '+
    '      Heritage Site.'+
    '    </p>'+
    '    <p>'+
    '      Attribution: Uluru, <a href="http://en.wikipedia.org/w/index.php?title=Uluru&oldid=297882194">'+
    '      http://en.wikipedia.org/w/index.php?title=Uluru</a> '+
    '      (last visited June 22, 2009).'+
    '    </p>'+
    '  </div>'+
    '</div>';

procedure TForm1.InitMap(Sender: TObject);
var
  {$IFDEF USE_ANONYMOUS_METHODS}
  InfoWindow: TInfoWindow;
  {$ENDIF}
  InfoWindowOptions: TInfoWindowOptions;
  Marker: TMarker;
  MarkerOptions: TMarkerOptions;
  MyLatLng: TLatLng;
  MyMap: TMap;
  MyOptions: TMapOptions;
begin
  with TScript(Sender) do
  begin
    MyLatLng:=New(Google.Maps.LatLng(-25.363882,131.044922));
    MyOptions:=TMapOptions.Create;
    with MyOptions do
    begin
      Zoom:=4;
      Center:=MyLatLng;
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
    end;
    MyMap:=New(Google.Maps.Map(MyOptions));
    InfoWindowOptions:=TInfoWindowOptions.Create;
    with InfoWindowOptions do
    begin
      Content:=ContentString;
      MaxWidth:=200;
    end;
    {$IFDEF USE_ANONYMOUS_METHODS}InfoWindow:={$ENDIF}
    New(Google.Maps.InfoWindow(InfoWindowOptions));
    MarkerOptions:=TMarkerOptions.Create;
    with MarkerOptions do
    begin
      Position:=MyLatLng;
      Map:=MyMap;
      Title:='Uluru (Ayers Rock)';
    end;
    Marker:=New(Google.Maps.Marker(MarkerOptions));
    {$IFDEF USE_ANONYMOUS_METHODS}
    Marker.OnClick:=
      procedure(Sender: TObject; Event: TEvent)
      begin
        InfoWindow.Open(MyMap,Marker);
      end;
    {$ELSE}
    Marker.OnClick:=MarkerClick;
    {$ENDIF}
  end;
end;

{$IFNDEF USE_ANONYMOUS_METHODS}
procedure TForm1.MarkerClick(Sender: TObject; Event: TEvent);
begin
  with Script do
    InfoWindows[0].Open(Maps[0],Markers[0]);
end;
{$ENDIF}

end.
