//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/marker-animations-iteration.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, ExtCtrls,
  DispObject, gmAPI, gmMap, gmBase, gmOverlaysMarker, gmEvents;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    Panel1: TPanel;
    Button1: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    FIterator: Integer;
    FNeighborhoods: array[0..3] of TLatLng;
    procedure InitMap(Sender: TObject);
    {$IFNDEF USE_ANONYMOUS_METHODS}
    procedure AddMarker;
    procedure Drop(Sender: TObject);
    {$ENDIF}
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  {$IFDEF USE_ANONYMOUS_METHODS}
  ReleaseEvent(Button1.OnClick);
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  Berlin: TLatLng;
  {$IFDEF USE_ANONYMOUS_METHODS}
  MyMap: TMap;
  {$ENDIF}
  MyOptions: TMapOptions;
  Script: TScript;
begin
  Script:=TScript(Sender);
  with Script do
  begin
    Berlin:=New(Google.Maps.LatLng(52.520816,13.410186));
    FNeighborhoods[0]:=New(Google.Maps.LatLng(52.511467,13.447179));
    FNeighborhoods[1]:=New(Google.Maps.LatLng(52.549061,13.422975));
    FNeighborhoods[2]:=New(Google.Maps.LatLng(52.497622,13.396110));
    FNeighborhoods[3]:=New(Google.Maps.LatLng(52.517683,13.394393));
    MyOptions:=TMapOptions.Create;
    with MyOptions do
    begin
      Zoom:=11;
      Center:=Berlin;
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
    end;
    {$IFDEF USE_ANONYMOUS_METHODS}MyMap:={$ENDIF}New(Google.Maps.Map(MyOptions));
  end;
  {$IFDEF USE_ANONYMOUS_METHODS}
  ReleaseEvent(Button1.OnClick);
  Button1.OnClick:=MakeEvent(
    procedure(Sender: TObject)
    var
      n: Integer;
      Marker: TMarker;
    begin
      with Script do
      begin
        for Marker in Markers do
          Marker.Map:=nil;
        Markers.Clear;
        FIterator:=0;
        for n:=0 to Length(FNeighborhoods)-1 do
        begin
          SetTimeout(
            procedure
            var
              MarkerOptions: TMarkerOptions;
            begin
              MarkerOptions:=TMarkerOptions.Create;
              with MarkerOptions do
              begin
                Position:=FNeighborhoods[FIterator];
                Map:=MyMap;
                Draggable:=false;
                Animation:=Google.Maps.Animation.Drop;
              end;
              New(Google.Maps.Marker(MarkerOptions));
              Inc(FIterator);
            end,n*200);
        end;
      end;
    end);
  {$ELSE}
  Button1.OnClick:=Drop;
  {$ENDIF}
end;

{$IFNDEF USE_ANONYMOUS_METHODS}
procedure TForm1.AddMarker;
var
  MarkerOptions: TMarkerOptions;
begin
  with Script do
  begin
    MarkerOptions:=TMarkerOptions.Create;
    with MarkerOptions do
    begin
      Position:=FNeighborhoods[FIterator];
      Map:=Maps[0];
      Draggable:=false;
      Animation:=Google.Maps.Animation.Drop;
    end;
    New(Google.Maps.Marker(MarkerOptions));
    Inc(FIterator);
  end;
end;

procedure TForm1.Drop(Sender: TObject);
var
  n: Integer;
begin
  with Script do
  begin
    for n:=0 to Markers.Count-1 do
      Markers[n].Map:=nil;
    Markers.Clear;
    FIterator:=0;
    for n:=0 to Length(FNeighborhoods)-1 do
      SetTimeout(AddMarker,n*200);
  end;
end;
{$ENDIF}

end.
