//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/marker-animations.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, gmAPI, gmMap,
  gmBase, gmOverlaysMarker, gmEvents, HTMLObjects;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
    {$IFNDEF USE_ANONYMOUS_METHODS}
    procedure ToggleBounce(Sender: TObject; Event: TEvent);
    {$ENDIF}
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  Stockholm, Parliament: TLatLng;
  Marker: TMarker;
  MarkerOptions: TMarkerOptions;
  MyMap: TMap;
  MyOptions: TMapOptions;
begin
  with TScript(Sender) do
  begin
    Stockholm:=New(Google.Maps.LatLng(59.32522,18.07002));
    Parliament:=New(Google.Maps.LatLng(59.327383,18.06747));
    MyOptions:=TMapOptions.Create;
    with MyOptions do
    begin
      Zoom:=13;
      Center:=Stockholm;
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
    end;
    MyMap:=New(Google.Maps.Map(MyOptions));
    MarkerOptions:=TMarkerOptions.Create;
    with MarkerOptions do
    begin
      Map:=MyMap;
      Draggable:=true;
      Animation:=Google.Maps.Animation.Drop;
      Position:=Parliament;
    end;
    Marker:=New(Google.Maps.Marker(MarkerOptions));
    {$IFDEF USE_ANONYMOUS_METHODS}
    Marker.OnClick:=
      procedure(Sender: TObject; Event: TEvent)
      begin
        if Marker.GetAnimation>0
          then Marker.SetAnimation(0)
          else Marker.SetAnimation(Google.Maps.Animation.Bounce);
      end;
    {$ELSE}
    Marker.OnClick:=ToggleBounce;
    {$ENDIF}
  end;
end;

{$IFNDEF USE_ANONYMOUS_METHODS}
procedure TForm1.ToggleBounce(Sender: TObject; Event: TEvent);
begin
  with Script do
  begin
    if Markers[0].GetAnimation>0
      then Markers[0].SetAnimation(0)
      else Markers[0].SetAnimation(Google.Maps.Animation.Bounce);
  end;
end;
{$ENDIF}

end.
