//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/overlay-remove.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, ExtCtrls,
  DispObject, gmAPI, gmMap, gmBase, gmOverlaysMarker, gmEvents;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    Panel1: TPanel;
    ClearOverlays: TButton;
    ShowAllOverlays: TButton;
    DeleteOverlays: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ClearOverlaysClick(Sender: TObject);
    procedure ShowAllOverlaysClick(Sender: TObject);
    procedure DeleteOverlaysClick(Sender: TObject);
  private
    {$IFNDEF USE_ANONYMOUS_METHODS}
    procedure AddMarker(Sender: TObject; Event: TMouseEvent);
    {$ENDIF}
    procedure InitMap(Sender: TObject);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  HaightAshbury: TLatLng;
  Map: TMap;
  MapOptions: TMapOptions;
begin
  with TScript(Sender) do
  begin
    HaightAshbury:=New(Google.Maps.LatLng(37.7699298,-122.4469157));
    MapOptions:=TMapOptions.Create;
    with MapOptions do
    begin
      Zoom:=12;
      Center:=HaightAshbury;
      MapTypeID:=Google.Maps.MapTypeID.Terrain;
    end;
    Map:=New(Google.Maps.Map(MapOptions));
    {$IFDEF USE_ANONYMOUS_METHODS}
    Map.OnClick:=
      procedure(Sender: TObject; Event: TMouseEvent)
      var
        Marker: TMarker;
        MarkerOptions: TMarkerOptions;
      begin
        MarkerOptions:=TMarkerOptions.Create(Event.LatLng);
        Marker:=New(Google.Maps.Marker(MarkerOptions));
        Marker.SetMap(Map);
      end;
    {$ELSE}
    Map.OnClick:=AddMarker;
    {$ENDIF}
  end;
end;

{$IFNDEF USE_ANONYMOUS_METHODS}
procedure TForm1.AddMarker(Sender: TObject; Event: TMouseEvent);
var
  Marker: TMarker;
  MarkerOptions: TMarkerOptions;
begin
  with Script do
  begin
    MarkerOptions:=TMarkerOptions.Create(Event.LatLng);
    Marker:=New(Google.Maps.Marker(MarkerOptions));
    Marker.SetMap(Maps[0]);
  end;
end;
{$ENDIF}

{$IFDEF DELPHI2005_UP}
procedure TForm1.ClearOverlaysClick(Sender: TObject);
var
  Marker: TMarker;
begin
  //Removes the overlays from the map, but keeps them in the array
  with Script do
    for Marker in Markers do
      Marker.Map:=nil;
end;

procedure TForm1.ShowAllOverlaysClick(Sender: TObject);
var
  Marker: TMarker;
begin
  //Shows any overlays currently in the array
  with Script do
    for Marker in Markers do
      Marker.Map:=Maps[0];
end;

procedure TForm1.DeleteOverlaysClick(Sender: TObject);
var
  Marker: TMarker;
begin
  //Deletes all markers in the array by removing references to them
  with Script do
  begin
    for Marker in Markers do
      Marker.Map:=nil;
    Markers.Clear;
  end;
end;
{$ELSE}
procedure TForm1.ClearOverlaysClick(Sender: TObject);
var
  n: Integer;
begin
  //Removes the overlays from the map, but keeps them in the array
  with Script do
    for n:=0 to Markers.Count-1 do
      Markers[n].Map:=nil;
end;

procedure TForm1.ShowAllOverlaysClick(Sender: TObject);
var
  n: Integer;
begin
  //Shows any overlays currently in the array
  with Script do
    for n:=0 to Markers.Count-1 do
      Markers[n].Map:=Maps[0];
end;

procedure TForm1.DeleteOverlaysClick(Sender: TObject);
var
  n: Integer;
begin
  //Deletes all markers in the array by removing references to them
  with Script do
  begin
    for n:=0 to Markers.Count-1 do
      Markers[n].Map:=nil;
    Markers.Clear;
  end;
end;
{$ENDIF}

end.
