//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/polygon-arrays.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}
{.$UNDEF USE_ANONYMOUS_METHODS}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, BrowserTools,
  gmAPI, gmMap, gmMVC, gmBase, gmOverlaysPolylinePolygon, gmOverlaysInfoWindow,
  gmEvents;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
    {$IFNDEF USE_ANONYMOUS_METHODS}
    procedure ShowArrays(Sender: TObject; Event: TMouseEvent);
    {$ENDIF}
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  {$IFDEF USE_ANONYMOUS_METHODS}
  InfoWindow: TInfoWindow;
  {$ENDIF}
  BermudaTriangle: TPolygon;
  BermudaTriangleOpts: TPolygonOptions;
  Map: TMap;
  MapOptions: TMapOptions;
begin
  with TScript(Sender) do
  begin
    MapOptions:=TMapOptions.Create;
    with MapOptions do
    begin
      Zoom:=4;
      Center:=New(Google.Maps.LatLng(24.886436490787712,-70.2685546875));
      MapTypeID:=Google.Maps.MapTypeID.Terrain;
    end;
    Map:=New(Google.Maps.Map(MapOptions));
    BermudaTriangleOpts:=TPolygonOptions.Create;
    with BermudaTriangleOpts do
    begin
      with Paths.Add do
      begin
        Push(New(Google.Maps.LatLng(25.774252,-80.190262)));
        Push(New(Google.Maps.LatLng(18.466465,-66.118292)));
        Push(New(Google.Maps.LatLng(32.321384,-64.75737)));
      end;
      StrokeColor:=WebColorStrToColor('#FF0000');
      StrokeOpacity:=0.8;
      StrokeWeight:=3;
      FillColor:=WebColorStrToColor('#FF0000');
      FillOpacity:=0.35;
    end;
    {$IFDEF USE_ANONYMOUS_METHODS}InfoWindow:={$ENDIF}New(Google.Maps.InfoWindow);
    BermudaTriangle:=New(Google.Maps.Polygon(BermudaTriangleOpts));
    BermudaTriangle.SetMap(Map);
    {$IFDEF USE_ANONYMOUS_METHODS}
    BermudaTriangle.OnClick:=
      procedure(Sender: TObject; Event: TMouseEvent)
      var
        n: Integer;
        XY: TLatLng;
        ContentString: String;
        Vertices: TLatLngMVCArray;
      begin
        //Since this Polygon only has one path, we can call GetPath to return
        //the MVCArray of LatLngs
        Vertices:=BermudaTriangle.GetPath;
        ContentString:='<b>Bermuda Triangle Polygon</b><br/>';
        ContentString:=ContentString+'Clicked Location: <br/>'+
                       FloatToStr(Event.LatLng.Lat,'.')+', '+
                       FloatToStr(Event.LatLng.Lng,'.')+'<br/>';
        //Iterate over the vertices.
        for n:=0 to Vertices.Count-1 do
        begin
          XY:=Vertices.GetAt(n);
          ContentString:=ContentString+'<br/>'+'Coordinate: '+IntToStr(n)+'<br/>'+
                         FloatToStr(XY.Lat,'.')+', '+FloatToStr(XY.Lng,'.');
        end;
        //Replace our Info Window's content and position
        InfoWindow.SetContent(ContentString);
        InfoWindow.SetPosition(Event.LatLng);
        InfoWindow.Open(Map);
      end;
    {$ELSE}
    BermudaTriangle.OnClick:=ShowArrays;
    {$ENDIF}
  end;
end;

{$IFNDEF USE_ANONYMOUS_METHODS}
procedure TForm1.ShowArrays(Sender: TObject; Event: TMouseEvent);
var
  n: Integer;
  XY: TLatLng;
  ContentString: String;
  Vertices: TLatLngMVCArray;
begin
  with Script do
  begin
    //Since this Polygon only has one path, we can call GetPath to return
    //the MVCArray of LatLngs
    Vertices:=Polygones[0].GetPath;
    ContentString:='<b>Bermuda Triangle Polygon</b><br/>';
    ContentString:=ContentString+'Clicked Location: <br/>'+
                   FloatToStr(Event.LatLng.Lat,'.')+', '+
                   FloatToStr(Event.LatLng.Lng,'.')+'<br/>';
    //Iterate over the vertices.
    for n:=0 to Vertices.Count-1 do
    begin
      XY:=Vertices.GetAt(n);
      ContentString:=ContentString+'<br/>'+'Coordinate: '+IntToStr(n)+'<br/>'+
                     FloatToStr(XY.Lat,'.')+', '+FloatToStr(XY.Lng,'.');
    end;
    //Replace our Info Window's content and position
    InfoWindows[0].SetContent(ContentString);
    InfoWindows[0].SetPosition(Event.LatLng);
    InfoWindows[0].Open(Maps[0]);
  end;
end;
{$ENDIF}

end.
