//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/polygon-simple.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, BrowserTools,
  gmAPI, gmMap, gmOverlaysPolylinePolygon;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  BermudaTriangle: TPolygonOptions;
  Map: TMap;
  MapOptions: TMapOptions;
begin
  with TScript(Sender) do
  begin
    MapOptions:=TMapOptions.Create;
    with MapOptions do
    begin
      Zoom:=4;
      Center:=New(Google.Maps.LatLng(24.886436490787712,-70.2685546875));
      MapTypeID:=Google.Maps.MapTypeID.Terrain;
    end;
    Map:=New(Google.Maps.Map(MapOptions));
    BermudaTriangle:=TPolygonOptions.Create;
    with BermudaTriangle do
    begin
      with Paths.Add do
      begin
        Push(New(Google.Maps.LatLng(25.774252,-80.190262)));
        Push(New(Google.Maps.LatLng(18.466465,-66.118292)));
        Push(New(Google.Maps.LatLng(32.321384,-64.75737)));
        Push(New(Google.Maps.LatLng(25.774252,-80.190262)));
      end;
      StrokeColor:=WebColorStrToColor('#FF0000');
      StrokeOpacity:=0.8;
      StrokeWeight:=2;
      FillColor:=WebColorStrToColor('#FF0000');
      FillOpacity:=0.35;
    end;
    //Construct the polygon
    New(Google.Maps.Polygon(BermudaTriangle)).SetMap(Map);
  end;
end;

end.
