//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/polyline-complex.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, gmAPI, gmMap,
  gmBase, gmMVC, gmOverlaysMarker, gmOverlaysPolylinePolygon, gmEvents;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    {$IFNDEF USE_ANONYMOUS_METHODS}
    procedure AddLatLng(Sender: TObject; Event: TMouseEvent);
    {$ENDIF}
    procedure InitMap(Sender: TObject);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  Chicago: TLatLng;
  Map: TMap;
  MapOptions: TMapOptions;
  Poly: TPolyline;
  PolyOptions: TPolylineOptions;
begin
  with TScript(Sender) do
  begin
    Chicago:=New(Google.Maps.LatLng(41.879535,-87.624333));
    MapOptions:=TMapOptions.Create;
    with MapOptions do
    begin
      Zoom:=7;
      Center:=Chicago;
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
    end;
    Map:=New(Google.Maps.Map(MapOptions));
    PolyOptions:=TPolylineOptions.Create;
    with PolyOptions do
    begin
      StrokeColor:=clBlack;
      StrokeOpacity:=1.0;
      StrokeWeight:=3;
    end;
    Poly:=New(Google.Maps.Polyline(PolyOptions));
    Poly.SetMap(Map);
    //Add a listener for the click event
    {$IFDEF USE_ANONYMOUS_METHODS}
    Map.OnClick:=
      procedure(Sender: TObject; Event: TMouseEvent)
      var
        Marker: TMarker;
        MarkerOptions: TMarkerOptions;
        Path: TLatLngMVCArray;
      begin
        Path:=Poly.GetPath;
        //Because path is an MVCArray, we can simply append a new coordinate
        //and it will automatically appear
        Path.Push(Event.LatLng);
        // Add a new marker at the new plotted point on the polyline.
        MarkerOptions:=TMarkerOptions.Create;
        with MarkerOptions do
        begin
          Position:=Event.LatLng;
          Title:='#'+IntToStr(Path.GetLength);
        end;
        Marker:=New(Google.Maps.Marker(MarkerOptions));
        Marker.SetMap(Map);
      end;
    {$ELSE}
    Map.OnClick:=AddLatLng;
    {$ENDIF}
  end;
end;

{$IFNDEF USE_ANONYMOUS_METHODS}
procedure TForm1.AddLatLng(Sender: TObject; Event: TMouseEvent);
var
  Marker: TMarker;
  MarkerOptions: TMarkerOptions;
  Path: TLatLngMVCArray;
begin
  with Script do
  begin
    Path:=Polylines[0].GetPath;
    //Because path is an MVCArray, we can simply append a new coordinate
    //and it will automatically appear
    Path.Push(Event.LatLng);
    // Add a new marker at the new plotted point on the polyline.
    MarkerOptions:=TMarkerOptions.Create;
    with MarkerOptions do
    begin
      Position:=Event.LatLng;
      Title:='#'+IntToStr(Path.GetLength);
    end;
    Marker:=New(Google.Maps.Marker(MarkerOptions));
    Marker.SetMap(Maps[0]);
  end;
end;
{$ENDIF}

end.
