//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/polyline-simple.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, BrowserTools,
  gmAPI, gmMap, gmOverlaysPolylinePolygon;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  FlightPlan: TPolylineOptions;
  Map: TMap;
  MapOptions: TMapOptions;
begin
  with TScript(Sender) do
  begin
    MapOptions:=TMapOptions.Create;
    with MapOptions do
    begin
      Zoom:=2;
      Center:=New(Google.Maps.LatLng(0,-180));
      MapTypeID:=Google.Maps.MapTypeID.Terrain;
    end;
    Map:=New(Google.Maps.Map(MapOptions));
    FlightPlan:=TPolylineOptions.Create;
    with FlightPlan do
    begin
      Path.Push(New(Google.Maps.LatLng(37.772323,-122.214897)));
      Path.Push(New(Google.Maps.LatLng(21.291982,-157.821856)));
      Path.Push(New(Google.Maps.LatLng(-18.142599,178.431)));
      Path.Push(New(Google.Maps.LatLng(-27.46758,153.027892)));
      StrokeColor:=WebColorStrToColor('#FF0000');
      StrokeOpacity:=1.0;
      StrokeWeight:=2;
      Geodesic:=true;
    end;
    New(Google.Maps.Polyline(FlightPlan)).SetMap(Map);
  end;
end;

end.
