//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/rectangle-simple.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, BrowserTools,
  gmAPI, gmMap, gmBase, gmOverlaysBase;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
    {$IFNDEF USE_ANONYMOUS_METHODS}
    procedure ZoomChanged(Sender: TObject);
    {$ENDIF}
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  {$IFDEF USE_ANONYMOUS_METHODS}
  Rectangle: TRectangle;
  {$ENDIF}
  Coachella: TLatLng;
  MyMap: TMap;
  MapOptions: TMapOptions;
begin
  with TScript(Sender) do
  begin
    Coachella:=New(Google.Maps.LatLng(33.6803003,-116.173894));
    MapOptions:=TMapOptions.Create;
    with MapOptions do
    begin
      Zoom:=11;
      Center:=Coachella;
      MapTypeID:=Google.Maps.MapTypeID.Terrain;
    end;
    MyMap:=New(Google.Maps.Map(MapOptions));
    {$IFDEF USE_ANONYMOUS_METHODS}Rectangle:={$ENDIF}New(Google.Maps.Rectangle);
    {$IFDEF USE_ANONYMOUS_METHODS}
    MyMap.OnZoomChanged:=
      procedure(Sender: TObject)
      var
        RectOptions: TRectangleOptions;
      begin
        //Get the current bounds, which reflect the bounds before the zoom.
        RectOptions:=TRectangleOptions.Create;
        with RectOptions do
        begin
          StrokeColor:=WebColorStrToColor('#FF0000');
          StrokeOpacity:=0.8;
          StrokeWeight:=2;
          FillColor:=WebColorStrToColor('#FF0000');
          FillOpacity:=0.35;
          Map:=MyMap;
          Bounds:=MyMap.GetBounds;
        end;
        Rectangle.SetOptions(RectOptions);
      end;
    {$ELSE}
    MyMap.OnZoomChanged:=ZoomChanged;
    {$ENDIF}
  end;
end;

{$IFNDEF USE_ANONYMOUS_METHODS}
procedure TForm1.ZoomChanged(Sender: TObject);
var
  RectOptions: TRectangleOptions;
begin
  with Script do
  begin
    //Get the current bounds, which reflect the bounds before the zoom.
    RectOptions:=TRectangleOptions.Create;
    with RectOptions do
    begin
      StrokeColor:=WebColorStrToColor('#FF0000');
      StrokeOpacity:=0.8;
      StrokeWeight:=2;
      FillColor:=WebColorStrToColor('#FF0000');
      FillOpacity:=0.35;
      Map:=Maps[0];
      Bounds:=Maps[0].GetBounds;
    end;
    Rectangles[0].SetOptions(RectOptions);
  end;
end;
{$ENDIF}

end.
