//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/directions-travel-modes.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, ExtCtrls,
  gmAPI, gmMap, gmBase, gmServicesDirections, gmServicesDirectionsRenderer,
  gmEvents;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    Panel1: TPanel;
    Label1: TLabel;
    TravelMode: TComboBox;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    {$IFNDEF USE_ANONYMOUS_METHODS}
    FHaight, FOceanBeach: TLatLng;
    procedure DirectionsCallback(Sender: TObject; Response: TDirectionsResult; Status: String);
    procedure TravelModeClick(Sender: TObject);
    {$ENDIF}
    procedure InitMap(Sender: TObject);
  public
    {$IFNDEF USE_ANONYMOUS_METHODS}
    property Haight: TLatLng read FHaight write FHaight;
    property OceanBeach: TLatLng read FOceanBeach write FOceanBeach;
    {$ENDIF}
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  {$IFDEF USE_ANONYMOUS_METHODS}
  ReleaseEvent(TravelMode.OnClick);
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  {$IFDEF USE_ANONYMOUS_METHODS}
  DirectionsService: TDirectionsService;
  Haight, OceanBeach: TLatLng;
  {$ENDIF}
  DirectionsDisplay: TDirectionsRenderer;
  Map: TMap;
  MyOptions: TMapOptions;
begin
  with TScript(Sender) do
  begin
    DirectionsDisplay:=New(Google.Maps.DirectionsRenderer);
    {$IFDEF USE_ANONYMOUS_METHODS}DirectionsService:={$ENDIF}
    New(Google.Maps.DirectionsService);
    Haight:=New(Google.Maps.LatLng(37.7699298,-122.4469157));
    OceanBeach:=New(Google.Maps.LatLng(37.7683909618184,-122.51089453697205));
    MyOptions:=TMapOptions.Create;
    with MyOptions do
    begin
      Zoom:=14;
      Center:=Haight;
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
    end;
    Map:=New(Google.Maps.Map(MyOptions));
    DirectionsDisplay.SetMap(Map);
    {$IFDEF USE_ANONYMOUS_METHODS}
    ReleaseEvent(TravelMode.OnClick);
    TravelMode.OnClick:=MakeEvent(
      procedure(Sender: TObject)
      var
        Request: TDirectionsRequest;
        SelectedMode: String;
      begin
        SelectedMode:=TravelMode.Text;
        Request:=TDirectionsRequest.Create;
        with Request do
        begin
          Origin:=Haight;
          Destination:=OceanBeach;
          //Note that Javascript allows us to access the constant
          //using square brackets and a string value as its
          //"property."
          //This framework also! ;-)
          TravelMode:=Google.Maps.DirectionsTravelMode[SelectedMode];
        end;
        DirectionsService.Route(Request,
          procedure(Sender: TObject; Response: TDirectionsResult; Status: String)
          begin
            if Status=Google.Maps.DirectionsStatus.OK
              then DirectionsDisplay.SetDirections(Response);
          end);
      end);
    {$ELSE}
    TravelMode.OnClick:=TravelModeClick;
    {$ENDIF}
  end;
end;

{$IFNDEF USE_ANONYMOUS_METHODS}
procedure TForm1.TravelModeClick(Sender: TObject);
var
  Request: TDirectionsRequest;
  SelectedMode: String;
begin
  with Script do
  begin
    SelectedMode:=TravelMode.Text;
    Request:=TDirectionsRequest.Create;
    with Request do
    begin
      Origin:=Haight;
      Destination:=OceanBeach;
      TravelMode:=Google.Maps.DirectionsTravelMode[SelectedMode];
    end;
    DirectionsServices[0].Route(Request,DirectionsCallback);
  end;
end;

procedure TForm1.DirectionsCallback(Sender: TObject; Response: TDirectionsResult; Status: String);
begin
  with Script do
  begin
    if Status=Google.Maps.DirectionsStatus.OK
      then DirectionsRenderer[0].SetDirections(Response);
  end;
end;
{$ENDIF}

end.
