//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/directions-waypoints.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, ExtCtrls,
  ComCtrls, gmAPI, gmMap, gmBase, gmServicesDirections,
  gmServicesDirectionsRenderer, gmEvents;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    Panel1: TPanel;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    StartPos: TComboBox;
    WayPoints: TListBox;
    EndPos: TComboBox;
    Label3: TLabel;
    CalcRoute: TButton;
    Panel3: TPanel;
    Routes: TListView;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Splitter1: TSplitter;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
    {$IFNDEF USE_ANONYMOUS_METHODS}
    procedure CalcRouteClick(Sender: TObject);
    procedure DirectionsCallback(Sender: TObject; Response: TDirectionsResult; Status: String);
    {$ENDIF}
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  {$IFDEF USE_ANONYMOUS_METHODS}
  ReleaseEvent(CalcRoute.OnClick);
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  {$IFDEF USE_ANONYMOUS_METHODS}
  DirectionsService: TDirectionsService;
  {$ENDIF}
  Chicago: TLatLng;
  DirectionsDisplay: TDirectionsRenderer;
  Map: TMap;
  MyOptions: TMapOptions;
begin
  with TScript(Sender) do
  begin
    Routes.Items.Clear;
    {$IFDEF USE_ANONYMOUS_METHODS}DirectionsService:={$ENDIF}
    New(Google.Maps.DirectionsService);
    DirectionsDisplay:=New(Google.Maps.DirectionsRenderer);
    Chicago:=New(Google.Maps.LatLng(41.850033,-87.6500523));
    MyOptions:=TMapOptions.Create;
    with MyOptions do
    begin
      Zoom:=6;
      Center:=Chicago;
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
    end;
    Map:=New(Google.Maps.Map(MyOptions));
    DirectionsDisplay.SetMap(Map);
    {$IFDEF USE_ANONYMOUS_METHODS}
    ReleaseEvent(CalcRoute.OnClick);
    CalcRoute.OnClick:=MakeEvent(
      procedure(Sender: TObject)
      var
        n: Integer;
        WayPoint: TDirectionsWaypoint;
        Request: TDirectionsRequest;
      begin
        Request:=TDirectionsRequest.Create;
        with Request do
        begin
          OriginAsString:=StartPos.Text;
          DestinationAsString:=EndPos.Text;
          OptimizeWaypoints:=true;
          TravelMode:=Google.Maps.DirectionsTravelMode.Driving;
        end;
        for n:=0 to WayPoints.Items.Count-1 do
        begin
          if WayPoints.Selected[n] then
          begin
            Waypoint:=TDirectionsWaypoint.Create;
            WayPoint.LocationAsString:=Waypoints.Items[n];
            WayPoint.StopOver:=true;
            Request.WayPoints.Add(WayPoint);
          end;
        end;
        DirectionsService.Route(Request,
          procedure(Sender: TObject; Response: TDirectionsResult; Status: String)
          var
            n: Integer;
            Route: TDirectionsRoute;
          begin
            if Status=Google.Maps.DirectionsStatus.OK then
            begin
              DirectionsDisplay.SetDirections(Response);
              Route:=Response.Routes[0];
              Routes.Items.Clear;
              //For each route, display summary information.
              for n:=0 to Route.Legs.Count-1 do
              begin
                with Routes.Items.Add do
                begin
                  Caption:=IntToStr(n+1);
                  SubItems.Add(Route.Legs[n].StartAddress);
                  SubItems.Add(Route.Legs[n].EndAddress);
                  SubItems.Add(Route.Legs[n].Distance.Text);
                end;
              end;
            end;
          end);
      end);
    {$ELSE}
    CalcRoute.OnClick:=CalcRouteClick;
    {$ENDIF}
  end;
end;

{$IFNDEF USE_ANONYMOUS_METHODS}
procedure TForm1.CalcRouteClick(Sender: TObject);
var
  n: Integer;
  WayPoint: TDirectionsWaypoint;
  Request: TDirectionsRequest;
begin
  with Script do
  begin
    Request:=TDirectionsRequest.Create;
    with Request do
    begin
      OriginAsString:=StartPos.Text;
      DestinationAsString:=EndPos.Text;
      OptimizeWaypoints:=true;
      TravelMode:=Google.Maps.DirectionsTravelMode.Driving;
    end;
    for n:=0 to WayPoints.Items.Count-1 do
    begin
      if WayPoints.Selected[n] then
      begin
        Waypoint:=TDirectionsWaypoint.Create;
        WayPoint.LocationAsString:=Waypoints.Items[n];
        WayPoint.StopOver:=true;
        Request.WayPoints.Add(WayPoint);
      end;
    end;
    DirectionsServices[0].Route(Request,DirectionsCallback);
  end;
end;

procedure TForm1.DirectionsCallback(Sender: TObject; Response: TDirectionsResult; Status: String);
var
  n: Integer;
  Route: TDirectionsRoute;
begin
  with Script do
  begin
    if Status=Google.Maps.DirectionsStatus.OK then
    begin
      DirectionsRenderer[0].SetDirections(Response);
      Route:=Response.Routes[0];
      Routes.Items.Clear;
      //For each route, display summary information.
      for n:=0 to Route.Legs.Count-1 do
      begin
        with Routes.Items.Add do
        begin
          Caption:=IntToStr(n+1);
          SubItems.Add(Route.Legs[n].StartAddress);
          SubItems.Add(Route.Legs[n].EndAddress);
          SubItems.Add(Route.Legs[n].Distance.Text);
        end;
      end;
    end;
  end;
end;
{$ENDIF}

end.
