//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/elevation-simple.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, gmAPI, gmMap,
  gmBase, gmServicesElevation, gmOverlaysInfoWindow, gmEvents;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
    {$IFNDEF USE_ANONYMOUS_METHODS}
    procedure ElevationCallback(Sender: TObject; Results: TElevationResultArray; Status: String);
    procedure MapClick(Sender: TObject; Event: TMouseEvent);
    {$ENDIF}
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  {$IFDEF USE_ANONYMOUS_METHODS}
  Elevator: TElevationService;
  InfoWindow: TInfoWindow;
  {$ENDIF}
  Denali: TLatLng;
  Map: TMap;
  MyOptions: TMapOptions;
begin
  with TScript(Sender) do
  begin
    {$IFDEF USE_ANONYMOUS_METHODS}InfoWindow:={$ENDIF}TInfoWindow.Create;
    Denali:=New(Google.Maps.LatLng(63.3333333,-150.5));
    MyOptions:=TMapOptions.Create;
    with MyOptions do
    begin
      Zoom:=8;
      Center:=Denali;
      MapTypeID:=Google.Maps.MapTypeID.Terrain;
    end;
    Map:=New(Google.Maps.Map(MyOptions));
    //Create an ElevationService
    {$IFDEF USE_ANONYMOUS_METHODS}Elevator:={$ENDIF}
    New(Google.Maps.ElevationService);
    //Add a listener for the click event and call getElevation on that location
    {$IFDEF USE_ANONYMOUS_METHODS}
    Map.OnClick:=
      procedure(Sender: TObject; Event: TMouseEvent)
      var
        ClickedLocation: TLatLng;
        PositionalRequest: TLocationElevationRequest;
      begin
        //Retrieve the clicked location
        ClickedLocation:=Event.LatLng;
        //Create a LocationElevationRequest object using the array's one value
        PositionalRequest:=TLocationElevationRequest.Create;
        PositionalRequest.Locations.Push(ClickedLocation);
        //Initiate the location request
        Elevator.GetElevationForLocations(PositionalRequest,
          procedure(Sender: TObject; Results: TElevationResultArray; Status: String)
          begin
            if Status=Google.Maps.ElevationStatus.OK then
            begin
              //Retrieve the first result
              if Results.Count>0 then
              begin
                //Open an info window indicating the elevation at the clicked
                //position
                InfoWindow.SetContent('The elevation at this point <br/>is '+
                                      FloatToStr(Results[0].Elevation)+' meters.');
                InfoWindow.SetPosition(ClickedLocation);
                InfoWindow.Open(Map);
              end else ShowMessage('No results found');
            end else ShowMessage('Elevation service failed due to: '+Status);
          end);
      end;
    {$ELSE}
    Map.OnClick:=MapClick;
    {$ENDIF}
  end;
end;

{$IFNDEF USE_ANONYMOUS_METHODS}
procedure TForm1.MapClick(Sender: TObject; Event: TMouseEvent);
var
  ClickedLocation: TLatLng;
  PositionalRequest: TLocationElevationRequest;
begin
  //Retrieve the clicked location
  ClickedLocation:=Event.LatLng;
  //Create a LocationElevationRequest object using the array's one value
  PositionalRequest:=TLocationElevationRequest.Create;
  PositionalRequest.Locations.Push(ClickedLocation);
  //Initiate the location request
  Script.ElevationServices[0].GetElevationForLocations(PositionalRequest,ElevationCallback);
end;

procedure TForm1.ElevationCallback(Sender: TObject; Results: TElevationResultArray; Status: String);
begin
  with Script do
  begin
    if Status=Google.Maps.ElevationStatus.OK then
    begin
      //Retrieve the first result
      if Results.Count>0 then
      begin
        //Open an info window indicating the elevation at the clicked
        //position
        InfoWindows[0].SetContent('The elevation at this point <br/>is '+
                                  FloatToStr(Results[0].Elevation,'.')+' meters.');
        InfoWindows[0].SetPosition(Results[0].Location);
        InfoWindows[0].Open(Maps[0]);
      end else ShowMessage('No results found');
    end else ShowMessage('Elevation service failed due to: '+Status);
  end;
end;
{$ENDIF}

end.
