//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/geocoding-region-es.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, gmAPI, gmMap,
  gmBase, gmOverlaysMarker, gmServicesGeocoder;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    {$IFNDEF USE_ANONYMOUS_METHODS}
    procedure GeocoderCallback(Sender: TObject; Results: TGeocoderResultArray; Status: String);
    {$ENDIF}
    procedure InitMap(Sender: TObject);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap,DefaultLanguage,'ES');          //Region Spain
end;

procedure TForm1.InitMap(Sender: TObject);
var
  {$IFDEF USE_ANONYMOUS_METHODS}
  Map: TMap;
  {$ENDIF}
  Geocoder: TGeocoder;
  MyOptions: TMapOptions;
begin
  with TScript(Sender) do
  begin
    MyOptions:=TMapOptions.Create;
    with MyOptions do
    begin
      Zoom:=8;
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
    end;
    {$IFDEF USE_ANONYMOUS_METHODS}Map:={$ENDIF}New(Google.Maps.Map(MyOptions));
    Geocoder:=TGeocoder.Create;
    {$IFDEF USE_ANONYMOUS_METHODS}
    Geocoder.Geocode(TGeocoderRequest.Create('Toledo'),
      procedure(Sender: TObject; Results: TGeocoderResultArray; Status: String)
      var
        MarkerOptions: TMarkerOptions;
      begin
        if Status=Google.Maps.GeocoderStatus.OK then
        begin
          Map.SetCenter(Results[0].Geometry.Location);
          MarkerOptions:=TMarkerOptions.Create;
          MarkerOptions.Map:=Map;
          MarkerOptions.Position:=Results[0].Geometry.Location;
          New(Google.Maps.Marker(MarkerOptions));
        end else ShowMessage('Geocode was not successful for the following reason: '+Status);
      end);
    {$ELSE}
    Geocoder.Geocode(TGeocoderRequest.Create('Toledo'),GeocoderCallback);
    {$ENDIF}
  end;
end;

{$IFNDEF USE_ANONYMOUS_METHODS}
procedure TForm1.GeocoderCallback(Sender: TObject; Results: TGeocoderResultArray; Status: String);
var
  MarkerOptions: TMarkerOptions;
begin
  with Script do
  begin
    if Status=Google.Maps.GeocoderStatus.OK then
    begin
      Maps[0].SetCenter(Results[0].Geometry.Location);
      MarkerOptions:=TMarkerOptions.Create;
      MarkerOptions.Map:=Maps[0];
      MarkerOptions.Position:=Results[0].Geometry.Location;
      New(Google.Maps.Marker(MarkerOptions));
    end else ShowMessage('Geocode was not successful for the following reason: '+Status);
  end;
end;
{$ENDIF}

end.
