//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/geocoding-reverse.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, ExtCtrls,
  gmAPI, gmMap, gmBase, gmServicesGeocoder, gmOverlaysMarker,
  gmOverlaysInfoWindow, gmEvents;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    Panel1: TPanel;
    Button1: TButton;
    Edit1: TEdit;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
    {$IFNDEF USE_ANONYMOUS_METHODS}
    procedure Button1Click(Sender: TObject);
    procedure GeocoderCallback(Sender: TObject; Results: TGeocoderResultArray; Status: String);
    {$ENDIF}
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  {$IFDEF USE_ANONYMOUS_METHODS}
  ReleaseEvent(Button1.OnClick);
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);
end;

procedure TForm1.InitMap(Sender: TObject);
var
  {$IFDEF USE_ANONYMOUS_METHODS}
  Geocoder: TGeocoder;
  InfoWindow: TInfoWindow;
  Map: TMap;
  {$ENDIF}
  LatLng: TLatLng;
  MyOptions: TMapOptions;
begin
  with TScript(Sender) do
  begin
    LatLng:=New(Google.Maps.LatLng(40.730885,-73.997383));
    MyOptions:=TMapOptions.Create;
    with MyOptions do
    begin
      Zoom:=8;
      Center:=LatLng;
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
    end;
    {$IFDEF USE_ANONYMOUS_METHODS}Map:={$ENDIF}New(Google.Maps.Map(MyOptions));
    {$IFDEF USE_ANONYMOUS_METHODS}Geocoder:={$ENDIF}New(Google.Maps.Geocoder);
    {$IFDEF USE_ANONYMOUS_METHODS}InfoWindow:={$ENDIF}New(Google.Maps.InfoWindow);
    {$IFDEF USE_ANONYMOUS_METHODS}
    ReleaseEvent(Button1.OnClick);
    Button1.OnClick:=MakeEvent(
      procedure(Sender: TObject)
      var
        n: Integer;
        LatLng: TLatLng;
        Lat, Lng: String;
        Request: TGeocoderRequest;
      begin
        Lat:='0';
        Lng:='0';
        n:=Pos(',',Edit1.Text);
        if n>=1 then
        begin
          Lat:=Copy(Edit1.Text,1,n-1);
          Lng:=Copy(Edit1.Text,n+1,Length(Edit1.Text)-n);
          LatLng:=Google.Maps.LatLng(StrToFloatDef(Lat,0,'.'),StrToFloatDef(Lng,0,'.'));
          Request:=TGeocoderRequest.Create;
          Request.Location:=LatLng;
          Geocoder.Geocode(Request,
            procedure(Sender: TObject; Results: TGeocoderResultArray; Status: String)
            var
              Marker: TMarker;
              MarkerOptions: TMarkerOptions;
            begin
              if Status=Google.Maps.GeocoderStatus.OK then
              begin
                if Results.Count>1 then
                begin
                  Map.SetZoom(11);
                  MarkerOptions:=TMarkerOptions.Create;
                  with MarkerOptions do
                  begin
                    Position:=LatLng;
                    Title:=Results[1].FormattedAddress;
                  end;
                  Marker:=New(Google.Maps.Marker(MarkerOptions));
                  Marker.SetMap(Map);
                  InfoWindow.SetContent(Results[1].FormattedAddress);
                  InfoWindow.Open(Map,Marker);
                end else ShowMessage('No results found');
              end else ShowMessage('Geocoder failed due to: '+Status);
            end);
        end;
      end);
    {$ELSE}
    Button1.OnClick:=Button1Click;
    {$ENDIF}
  end;
end;

{$IFNDEF USE_ANONYMOUS_METHODS}
procedure TForm1.Button1Click(Sender: TObject);
var
  n: Integer;
  LatLng: TLatLng;
  Lat, Lng: String;
  Request: TGeocoderRequest;
begin
  with Script do
  begin
    Lat:='0';
    Lng:='0';
    n:=Pos(',',Edit1.Text);
    if n>=1 then
    begin
      Lat:=Copy(Edit1.Text,1,n-1);
      Lng:=Copy(Edit1.Text,n+1,Length(Edit1.Text)-n);
      LatLng:=Google.Maps.LatLng(StrToFloatDef(Lat,0,'.'),
                                 StrToFloatDef(Lng,0,'.'));
      Request:=TGeocoderRequest.Create;
      Request.Location:=LatLng;
      Geocoders[0].Geocode(Request,GeocoderCallback);
    end;
  end;
end;

procedure TForm1.GeocoderCallback(Sender: TObject; Results: TGeocoderResultArray; Status: String);
var
  Marker: TMarker;
  MarkerOptions: TMarkerOptions;
begin
  with Script do
  begin
    if Status=Google.Maps.GeocoderStatus.OK then
    begin
      if Results.Count>1 then
      begin
        Maps[0].SetZoom(11);
        MarkerOptions:=TMarkerOptions.Create;
        with MarkerOptions do
        begin
          Position:=Results[1].Geometry.Location;
          Title:=Results[1].FormattedAddress;
        end;
        Marker:=New(Google.Maps.Marker(MarkerOptions));
        Marker.SetMap(Maps[0]);
        InfoWindows[0].SetContent(Results[1].FormattedAddress);
        InfoWindows[0].Open(Maps[0],Marker);
      end else ShowMessage('No results found');
    end else ShowMessage('Geocoder failed due to: '+Status);
  end;
end;
{$ENDIF}

end.
