//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/geocoding-simple.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, ExtCtrls,
  gmAPI, gmMap, gmBase, gmServicesGeocoder, gmOverlaysMarker;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    Panel1: TPanel;
    Address: TEdit;
    Geocode: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure GeocodeClick(Sender: TObject);
  private
    FGeocoder: TGeocoder;
    FMap: TMap;
    {$IFNDEF USE_ANONYMOUS_METHODS}
    procedure GeocoderCallback(Sender: TObject; Results: TGeocoderResultArray; Status: String);
    {$ENDIF}
    procedure InitMap(Sender: TObject);
  public
    property Geocoder: TGeocoder read FGeocoder write FGeocoder;
    property Map: TMap read FMap write FMap;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);                               //API load and create map
end;

procedure TForm1.InitMap(Sender: TObject);
var
  LatLng: TLatLng;
  MapOptions: TMapOptions;
begin
  with TScript(Sender) do
  begin
    Geocoder:=New(Google.Maps.Geocoder);
    LatLng:=New(Google.Maps.LatLng(-34.397,150.644));
    MapOptions:=TMapOptions.Create;
    with MapOptions do
    begin
      Zoom:=8;
      Center:=LatLng;
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
    end;
    Map:=New(Google.Maps.Map(MapOptions));
  end;
end;

procedure TForm1.GeocodeClick(Sender: TObject);
begin
  with Script do
  begin
    {$IFDEF USE_ANONYMOUS_METHODS}
    Geocoder.Geocode(TGeocoderRequest.Create(Address.Text),
      procedure(Sender: TObject; Results: TGeocoderResultArray; Status: String)
      var
        MarkerOptions: TMarkerOptions;
      begin
        if Status=Google.Maps.GeocoderStatus.OK then
        begin
          Map.SetCenter(Results[0].Geometry.Location);
          MarkerOptions:=TMarkerOptions.Create;
          with MarkerOptions do
          begin
            Map:=Self.Map;
            Position:=Results[0].Geometry.Location;
          end;
          New(Google.Maps.Marker(MarkerOptions));
        end else ShowMessage('Geocode was not successful for the following '+
                             'reason: '+Status);
      end);
    {$ELSE}
    Geocoder.Geocode(TGeocoderRequest.Create(Address.Text),GeocoderCallback);
    {$ENDIF}
  end;
end;

{$IFNDEF USE_ANONYMOUS_METHODS}
procedure TForm1.GeocoderCallback(Sender: TObject; Results: TGeocoderResultArray;
                                  Status: String);
var
  MarkerOptions: TMarkerOptions;
begin
  with Script do
  begin
    if Status=Google.Maps.GeocoderStatus.OK then
    begin
      Maps[0].SetCenter(Results[0].Geometry.Location);
      MarkerOptions:=TMarkerOptions.Create;
      with MarkerOptions do
      begin
        Map:=Self.Map;
        Position:=Results[0].Geometry.Location;
      end;
      New(Google.Maps.Marker(MarkerOptions));
    end else ShowMessage('Geocode was not successful for the following reason: '+Status);
  end;
end;
{$ENDIF}

end.
