//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/maxzoom-simple.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, gmAPI, gmMap,
  gmBase, gmEvents, gmServicesMaxZoom;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    {$IFNDEF USE_ANONYMOUS_METHODS}
    FLatLng: TLatLng;
    procedure MaxZoomCallback(Sender: TObject; Response: TMaxZoomResult);
    {$ENDIF}
    procedure InitMap(Sender: TObject);
    procedure ShowMaxZoom(Sender: TObject; MouseEvent: TMouseEvent);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);                               //API load and create map
end;

procedure TForm1.InitMap(Sender: TObject);
var
  Map: TMap;
  MapOptions: TMapOptions;
begin
  with TScript(Sender) do
  begin
    MapOptions:=TMapOptions.Create;
    with MapOptions do
    begin
      Zoom:=11;
      Center:=New(Google.Maps.LatLng(35.6894875,139.6917064));
      MapTypeID:=Google.Maps.MapTypeID.Hybrid;
    end;
    Map:=New(Google.Maps.Map(MapOptions));
    New(Google.Maps.MaxZoomService);
    Map.OnClick:=ShowMaxZoom;
  end;
end;

procedure TForm1.ShowMaxZoom(Sender: TObject; MouseEvent: TMouseEvent);
begin
  with Script do
  begin
    {$IFDEF USE_ANONYMOUS_METHODS}
    MaxZoomServices[0].GetMaxZoomAtLatLng(MouseEvent.LatLng,
      procedure(Sender: TObject; Response: TMaxZoomResult)
      begin
        if Response.Status<>Google.Maps.MaxZoomStatus.OK
          then ShowMessage('Error in MaxZoomService')
          else ShowMessage('The maximum zoom at this location is: '+IntToStr(Response.Zoom));
        Maps[0].PanTo(MouseEvent.LatLng);
      end);
    {$ELSE}
    MaxZoomServices[0].GetMaxZoomAtLatLng(MouseEvent.LatLng,MaxZoomCallback);
    FLatLng:=MouseEvent.LatLng;
    {$ENDIF}
  end;
end;

{$IFNDEF USE_ANONYMOUS_METHODS}
procedure TForm1.MaxZoomCallback(Sender: TObject; Response: TMaxZoomResult);
begin
  with Script do
  begin
    if Response.Status<>Google.Maps.MaxZoomStatus.OK
      then ShowMessage('Error in MaxZoomService')
      else ShowMessage('The maximum zoom at this location is: '+IntToStr(Response.Zoom));
    Maps[0].PanTo(FLatLng);
  end;
end;
{$ENDIF}

end.
