//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/streetview-custom-simple.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, gmAPI, gmMap,
  gmBase, gmStreetView;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
    function GetCustomPanorama(Sender: TObject; Pano: String): TStreetViewPanoramaData;
    function GetCustomPanoramaTileUrl(Sender: TObject; Pano: String; Zoom, TileX, TileY: Integer): String;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);                               //load API and create map
end;

procedure TForm1.InitMap(Sender: TObject);
var
  PanoOptions: TStreetViewPanoramaOptions;
begin
  with TScript(Sender) do
  begin
    //Set up Street View and initially set it visible. Register the
    //custom panorama provider function. Set the StreetView to display
    //the custom panorama 'reception' which we check for below.
    PanoOptions:=TStreetViewPanoramaOptions.Create;
    with PanoOptions do
    begin
      Pano:='reception';
      Visible:=true;
      PanoProvider:=GetCustomPanorama;                     //callback function
    end;
    New(Google.Maps.StreetViewPanorama(PanoOptions));
  end;
end;

function TForm1.GetCustomPanorama(Sender: TObject; Pano: String): TStreetViewPanoramaData;
begin
  Result:=nil;
  //Construct the appropriate StreetViewPanoramaData given
  //the passed pano IDs.
  if Pano='reception' then
  begin
    Result:=TStreetViewPanoramaData.Create;
    with Result do
    begin
      with Location do
      begin
        Pano:='reception';
        Description:='Google Sydney - Reception';
      end;
      //The text for the copyright control.
      Copyright:='Imagery (c) 2010 Google';
      //The definition of the tiles for this panorama.
      with Tiles do
      begin
        TileSize:=New(Script.Google.Maps.Size(1024,512));
        WorldSize:=New(Script.Google.Maps.Size(1024,512));
        //The heading in degrees at the origin of the panorama tile set.
        CenterHeading:=105;
        GetTileUrl:=GetCustomPanoramaTileUrl;              //callback function
      end;
    end;
  end;
end;

function TForm1.GetCustomPanoramaTileUrl(Sender: TObject; Pano: String; Zoom,
                                         TileX, TileY: Integer): String;
begin
  //Return a pano image given the panoID.
  //Note: robust custom panorama methods would require tiled pano data.
  //Here we're just using a single tile, set to the tile size and equal
  //to the pano "world" size.
  Result:='http://code.google.com/apis/maps/documentation/javascript/examples/'+
          'images/panoReception1024-0.jpg';
end;

end.
