//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/streetview-events.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, gmAPI,
  gmBase, gmStreetView, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    Panel1: TPanel;
    Label1: TLabel;
    Position: TLabel;
    Label3: TLabel;
    POVHeading: TLabel;
    Label5: TLabel;
    POVPitch: TLabel;
    Label7: TLabel;
    PanoID: TLabel;
    Label9: TLabel;
    Links: TListView;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    FPanorama: TStreetViewPanorama;
    procedure InitMap(Sender: TObject);
    procedure PanoChanged(Sender: TObject);
    procedure LinksChanged(Sender: TObject);
    procedure PositionChanged(Sender: TObject);
    procedure PovChanged(Sender: TObject);
  public
    property Panorama: TStreetViewPanorama read FPanorama write FPanorama;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);                               //API load and create map
end;

procedure TForm1.InitMap(Sender: TObject);
var
  Cafe: TLatLng;
  PanoramaOptions: TStreetViewPanoramaOptions;
begin
  with TScript(Sender) do
  begin
    Cafe:=New(Google.Maps.LatLng(37.869085,-122.254775));
    PanoramaOptions:=TStreetViewPanoramaOptions.Create;
    with PanoramaOptions do
    begin
      Position:=Cafe;
      with Pov do
      begin
        Heading:=270;
        Pitch:=0;
        Zoom:=1;
      end;
      Visible:=true;
    end;
    Panorama:=New(Google.Maps.StreetViewPanorama(PanoramaOptions));
    Panorama.OnPanoChanged:=PanoChanged;
    Panorama.OnLinksChanged:=LinksChanged;
    Panorama.OnPositionChanged:=PositionChanged;
    Panorama.OnPovChanged:=PovChanged;
    PovChanged(nil);
  end;
end;

procedure TForm1.PanoChanged(Sender: TObject);
begin
  PanoID.Caption:=Panorama.GetPano;
end;

procedure TForm1.LinksChanged(Sender: TObject);
var
  n: Integer;
begin
  Links.Items.Clear;
  with Panorama.GetLinks do
    for n:=0 to Count-1 do
      Links.Items.Add.Caption:=Items[n].Description;
end;

procedure TForm1.PositionChanged(Sender: TObject);
begin
  Position.Caption:=Panorama.GetPosition.ToUrlValue;
end;

procedure TForm1.PovChanged(Sender: TObject);
begin
  POVHeading.Caption:=FloatToStr(Panorama.GetPov.Heading,'.');
  POVPitch.Caption:=FloatToStr(Panorama.GetPov.Pitch,'.');
end;

end.
