//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/streetview-overlays.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, gmAPI,
  gmBase, gmMap, gmStreetView, gmOverlaysMarker, ExtCtrls;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    Panel1: TPanel;
    ToggleStreetView: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ToggleStreetViewClick(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
      LoadAPIAsync(InitMap);                               //API load and create map
end;

procedure TForm1.InitMap(Sender: TObject);
var
  MapOptions: TMapOptions;
  Panorama: TStreetViewPanorama;
  AstorPlace, BusStop, Cafe, Bank: TLatLng;
  Pov: TStreetViewPov;
  CafeMarkerImage, BankMarkerImage, BusMarkerImage: TMarkerImage;
  MarkerOptions: TMarkerOptions;
begin
  with TScript(Sender) do
  begin
    AstorPlace:=New(Google.Maps.LatLng(40.729884,-73.990988));
    BusStop:=New(Google.Maps.LatLng(40.729559678851025,-73.99074196815491));
    Cafe:=New(Google.Maps.LatLng(40.730031233910694,-73.99142861366272));
    Bank:=New(Google.Maps.LatLng(40.72968163306612,-73.9911389350891));
    MapOptions:=TMapOptions.Create;
    with MapOptions do
    begin
      Center:=AstorPlace;
      Zoom:=18;
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
      StreetViewControl:=false;
    end;
    New(Google.Maps.Map(MapOptions));
    CafeMarkerImage:=New(Google.Maps.MarkerImage(
      'http://chart.apis.google.com/chart?chst=d_map_pin_icon&chld=cafe|FFFF00'));
    MarkerOptions:=TMarkerOptions.Create;
    with MarkerOptions do
    begin
      Position:=Cafe;
      Map:=Maps[0];
      IconImage:=CafeMarkerImage;
      Title:='Cafe';
    end;
    New(Google.Maps.Marker(MarkerOptions));
    BankMarkerImage:=New(Google.Maps.MarkerImage(
      'http://chart.apis.google.com/chart?chst=d_map_pin_icon&chld=dollar|FFFF00'));
    MarkerOptions:=TMarkerOptions.Create;
    with MarkerOptions do
    begin
      Position:=Bank;
      Map:=Maps[0];
      IconImage:=BankMarkerImage;
      Title:='Bank';
    end;
    New(Google.Maps.Marker(MarkerOptions));
    BusMarkerImage:=New(Google.Maps.MarkerImage(
      'http://chart.apis.google.com/chart?chst=d_map_pin_icon&chld=bus|FFFF00'));
    MarkerOptions:=TMarkerOptions.Create;
    with MarkerOptions do
    begin
      Position:=BusStop;
      Map:=Maps[0];
      IconImage:=BusMarkerImage;
      Title:='Bus Stop';
    end;
    New(Google.Maps.Marker(MarkerOptions));
    Panorama:=Maps[0].GetStreetView;
    Panorama.SetPosition(AstorPlace);
    Pov:=TStreetViewPov.Create;
    with Pov do
    begin
      Heading:=265;
      Zoom:=1;
      Pitch:=0;
    end;
    Panorama.SetPov(Pov);
  end;
end;

procedure TForm1.ToggleStreetViewClick(Sender: TObject);
var
  Toggle: Boolean;
  Panorama: TStreetViewPanorama;
begin
  with Script do
  begin
    Panorama:=Maps[0].GetStreetView;
    Toggle:=Panorama.GetVisible;
    if not Toggle
      then Panorama.SetVisible(true)
      else Panorama.SetVisible(false);
  end;
end;

end.
