//http://code.google.com/apis/maps/documentation/javascript/examples/index.html
//http://code.google.com/apis/maps/documentation/javascript/examples/streetview-simple.html
unit Unit1;

interface

{$INCLUDE gmConfig.inc}

uses
  Windows, Messages, SysUtils, {$IFDEF DELPHI6_UP}Variants,{$ENDIF} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls, OleCtrls, SHDocVw, gmAPI, gmMap,
  gmBase, gmStreetView;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure InitMap(Sender: TObject);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DELPHI2006_UP}
  ReportMemoryLeaksOnShutdown:=true;
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Script=nil then
    with TScript.Create(WebBrowser1) do
    begin
      BackgroundColor:=Form1.Color;
      LoadAPIAsync(InitMap);                               //API load and create map
    end;
end;

procedure TForm1.InitMap(Sender: TObject);
var
  Fenway: TLatLng;
  Map: TMap;
  MapOptions: TMapOptions;
  Panorama: TStreetViewPanorama;
  PanoramaOptions: TStreetViewPanoramaOptions;
begin
  with TScript(Sender) do
  begin
    Fenway:=New(Google.Maps.LatLng(42.345573,-71.098326));
    MapOptions:=TMapOptions.Create;
    with MapOptions do
    begin
      Left:=8;
      Top:=8;
      Width:=300;
      Height:=250;
      Align:=alNone;
      Center:=Fenway;
      Zoom:=14;
      MapTypeID:=Google.Maps.MapTypeID.Roadmap;
    end;
    Map:=New(Google.Maps.Map(MapOptions));
    PanoramaOptions:=TStreetViewPanoramaOptions.Create;
    with PanoramaOptions do
    begin
      Left:=316;
      Top:=8;
      Width:=300;
      Height:=250;
      Align:=alNone;
      Position:=Fenway;
      with Pov do
      begin
        Heading:=34;
        Pitch:=10;
        Zoom:=1;
      end;
    end;
    Panorama:=New(Google.Maps.StreetViewPanorama(PanoramaOptions));
    Map.SetStreetView(Panorama);
  end;
end;

end.
