unit HTMLObjects;

interface

{$INCLUDE gmConfig.inc}

//ToDo: Elemente auf Objekte aus MSHTML umstellen

uses
  SysUtils, Controls, Graphics, MSHTML, {$IFDEF DELPHI6_UP}Variants,{$ENDIF}
  DispObject, BrowserTools;

const
  ELEMENT_NODE                          = 1;
  ATTRIBUTE_NODE                        = 2;
  TEXT_NODE                             = 3;
  CDATA_SECTION_NODE                    = 4;
  ENTITY_REFERENCE_NODE                 = 5;
  ENTITY_NODE                           = 6;
  PROCESSING_INSTRUCTION_NODE           = 7;
  COMMENT_NODE                          = 8;
  DOCUMENT_NODE                         = 9;
  DOCUMENT_TYPE_NODE                    = 10;
  DOCUMENT_FRAGMENT_NODE                = 11;
  NOTATION_NODE                         = 12;

  DocumentMethod_CreateElement          = 'createElement';

  DocumentMethod_CreateDocumentFragment = 'createDocumentFragment';
  DocumentMethod_GetElementByID         = 'getElementById';
  DocumentMethod_GetElementsByTagName   = 'getElementsByTagName';
  DocumentMethod_CreateTextNode         = 'createTextNode';
  DocumentProp_Body                     = 'body';

  DOMNodeMethod_AppendChild             = 'appendChild';
  DOMNodeMethod_CloneNode               = 'cloneNode';
  DOMNodeMethod_HasChildNodes           = 'hasChildNodes';
  DOMNodeMethod_InsertBefore            = 'insertBefore';
  DOMNodeMethod_RemoveChild             = 'removeChild';
  DOMNodeMethod_ReplaceChild            = 'replaceChild';
  DOMNodeProp_Attributes                = 'attributes';
  DOMNodeProp_ChildNodes                = 'childNodes';
  DOMNodeProp_FirstChild                = 'firstChild';
  DOMNodeProp_LastChild                 = 'lastChild';
  DOMNodeProp_NextSibling               = 'nextSibling';
  DOMNodeProp_NodeName                  = 'nodeName';
  DOMNodeProp_NodeType                  = 'nodeType';
  DOMNodeProp_NodeValue                 = 'nodeValue';
  DOMNodeProp_OwnerDocument             = 'ownerDocument';
  DOMNodeProp_ParentNode                = 'parentNode';
  DOMNodeProp_PreviousSibling           = 'previousSibling';

  EventProp_AltKey                      = 'altKey';
  EventProp_Button                      = 'button';
  EventProp_ClientX                     = 'clientX';
  EventProp_ClientY                     = 'clientY';
  EventProp_CtrlKey                     = 'ctrlKey';
  EventProp_KeyCode                     = 'keyCode';
  EventProp_OffsetX                     = 'offsetX';
  EventProp_OffsetY                     = 'offsetY';
  EventProp_ShiftKey                    = 'shiftKey';
  EventProp_X                           = 'x';
  EventProp_Y                           = 'y';

  HTMLInputElementProp_Accept           = 'accept';
  HTMLInputElementProp_AccessKey        = 'accessKey';
  HTMLInputElementProp_Align            = 'align';
  HTMLInputElementProp_Alt              = 'alt';
  HTMLInputElementProp_Checked          = 'checked';
  HTMLInputElementProp_DefaultChecked   = 'defaultChecked';
  HTMLInputElementProp_DefaultValue     = 'defaultValue';
  HTMLInputElementProp_Disabled         = 'disabled';
  HTMLInputElementProp_Form             = 'form';
  HTMLInputElementProp_MaxLength        = 'maxLength';
  HTMLInputElementProp_Name             = 'name';
  HTMLInputElementProp_OnChange         = 'onChange';
  HTMLInputElementProp_OnClick          = 'onClick';
  HTMLInputElementProp_Options          = 'options';
  HTMLInputElementProp_ReadOnly         = 'readOnly';
  HTMLInputElementProp_SelectedIndex    = 'selectedIndex';
  HTMLInputElementProp_Size             = 'size';
  HTMLInputElementProp_TabIndex         = 'tabIndex';
  HTMLInputElementProp_Type             = 'type';
  HTMLInputElementProp_UseMap           = 'useMap';
  HTMLInputElementProp_Value            = 'value';

  NavigatorProp_AppCodeName             = 'appCodeName';
  NavigatorProp_AppMinorVersion         = 'appMinorVersion';
  NavigatorProp_AppName                 = 'appName';
  NavigatorProp_AppVersion              = 'appVersion';
  NavigatorProp_CookieEnabled           = 'cookieEnabled';
  NavigatorProp_CPUClass                = 'cpuClass';
  NavigatorProp_Geolocation             = 'geolocation';
  NavigatorProp_MimeTypes               = 'mimeTypes';
  NavigatorProp_OnLine                  = 'onLine';
  NavigatorProp_OpsProfile              = 'opsProfile';
  NavigatorProp_Platform                = 'platform';
  NavigatorProp_Plugins                 = 'plugins';
  NavigatorProp_SystemLanguage          = 'systemLanguage';
  NavigatorProp_UserAgent               = 'userAgent';
  NavigatorProp_UserLanguage            = 'userLanguage';
  NavigatorProp_UserProfile             = 'userProfile';

  ScriptNodeProp_Charset                = 'charset';
  ScriptNodeProp_Defer                  = 'defer';
  ScriptNodeProp_Event                  = 'event';
  ScriptNodeProp_HTMLFor                = 'htmlFor';
  ScriptNodeProp_Src                    = 'src';
  ScriptNodeProp_Text                   = 'text';
  ScriptNodeProp_Type                   = 'type';

  StyleProp_Accelerator                 = 'accelerator';
  StyleProp_Background                  = 'background';
  StyleProp_BackgroundAttachment        = 'backgroundAttachment';
  StyleProp_BackgroundColor             = 'backgroundColor';
  StyleProp_BackgroundImage             = 'backgroundImage';
  StyleProp_BackgroundPosition          = 'backgroundPosition';
  StyleProp_BackgroundPositionX         = 'backgroundPositionX';
  StyleProp_BackgroundPositionY         = 'backgroundPositionY';
  StyleProp_BackgroundRepeat            = 'backgroundRepeat';
  StyleProp_Behavior                    = 'behavior';
  StyleProp_Border                      = 'border';
  StyleProp_BorderBottom                = 'borderBottom';
  StyleProp_BorderBottomColor           = 'borderBottomColor';
  StyleProp_BorderBottomStyle           = 'borderBottomStyle';
  StyleProp_BorderBottomWidth           = 'borderBottomWidth';
  StyleProp_BorderCollapse              = 'borderCollapse';
  StyleProp_BorderColor                 = 'borderColor';
  StyleProp_BorderLeft                  = 'borderLeft';
  StyleProp_BorderLeftColor             = 'borderLeftColor';
  StyleProp_BorderLeftStyle             = 'borderLeftStyle';
  StyleProp_BorderLeftWidth             = 'borderLeftWidth';
  StyleProp_BorderRight                 = 'borderRight';
  StyleProp_BorderRightColor            = 'borderRightColor';
  StyleProp_BorderRightStyle            = 'borderRightStyle';
  StyleProp_BorderRightWidth            = 'borderRightWidth';
  StyleProp_BorderSpacing               = 'borderSpacing';
  StyleProp_BorderStyle                 = 'borderStyle';
  StyleProp_BorderTop                   = 'borderTop';
  StyleProp_BorderTopColor              = 'borderTopColor';
  StyleProp_BorderTopStyle              = 'borderTopStyle';
  StyleProp_BorderTopWidth              = 'borderTopWidth';
  StyleProp_BorderWidth                 = 'borderWidth';
  StyleProp_Bottom                      = 'bottom';
  StyleProp_BoxSizing                   = 'boxSizing';
  StyleProp_CaptionSide                 = 'captionSide';
  StyleProp_Clear                       = 'clear';
  StyleProp_Clip                        = 'clip';
  StyleProp_Color                       = 'color';
  StyleProp_Content                     = 'content';
  StyleProp_CounterIncrement            = 'counterIncrement';
  StyleProp_CounterReset                = 'counterReset';
  StyleProp_CSSText                     = 'cssText';
  StyleProp_Cursor                      = 'cursor';
  StyleProp_Direction                   = 'direction';
  StyleProp_Display                     = 'display';
  StyleProp_EmptyCells                  = 'emptyCells';
  StyleProp_Filter                      = 'filter';
  StyleProp_Float                       = 'float';
  StyleProp_Font                        = 'font';
  StyleProp_FontFamily                  = 'fontFamily';
  StyleProp_FontSize                    = 'fontSize';
  StyleProp_FontStyle                   = 'fontStyle';
  StyleProp_FontVariant                 = 'fontVariant';
  StyleProp_FontWeight                  = 'fontWeight';
  StyleProp_Height                      = 'height';
  StyleProp_ImeMode                     = 'imeMode';
  StyleProp_LayoutFlow                  = 'layoutFlow';
  StyleProp_LayoutGrid                  = 'layoutGrid';
  StyleProp_LayoutGridChar              = 'layoutGridChar';
  StyleProp_LayoutGridLine              = 'layoutGridLine';
  StyleProp_LayoutGridMode              = 'layoutGridMode';
  StyleProp_LayoutGridType              = 'layoutGridType';
  StyleProp_Left                        = 'left';
  StyleProp_LetterSpacing               = 'letterSpacing';
  StyleProp_LineBreak                   = 'lineBreak';
  StyleProp_LineHeight                  = 'lineHeight';
  StyleProp_ListStyle                   = 'listStyle';
  StyleProp_ListStyleImage              = 'listStyleImage';
  StyleProp_ListStylePosition           = 'listStylePosition';
  StyleProp_ListStyleType               = 'listStyleType';
  StyleProp_Margin                      = 'margin';
  StyleProp_MarginBottom                = 'marginBottom';
  StyleProp_MarginLeft                  = 'marginLeft';
  StyleProp_MarginRight                 = 'marginRight';
  StyleProp_MarginTop                   = 'marginTop';
  StyleProp_MaxHeight                   = 'maxHeight';
  StyleProp_MaxWidth                    = 'maxWidth';
  StyleProp_MinHeight                   = 'minHeight';
  StyleProp_MinWidth                    = 'minWidth';
  StyleProp_MsBlockProgression          = 'msBlockProgression';
  StyleProp_MsInterpolationMode         = 'msInterpolationMode';
  StyleProp_Opacity                     = 'opacity';
  StyleProp_Orphans                     = 'orphans';
  StyleProp_Outline                     = 'outline';
  StyleProp_OutlineColor                = 'outlineColor';
  StyleProp_OutlineStyle                = 'outlineStyle';
  StyleProp_OutlineWidth                = 'outlineWidth';
  StyleProp_Overflow                    = 'overflow';
  StyleProp_OverflowX                   = 'overflowX';
  StyleProp_OverflowY                   = 'overflowY';
  StyleProp_Padding                     = 'padding';
  StyleProp_PaddingBottom               = 'paddingBottom';
  StyleProp_PaddingLeft                 = 'paddingLeft';
  StyleProp_PaddingRight                = 'paddingRight';
  StyleProp_PaddingTop                  = 'paddingTop';
  StyleProp_PageBreakAfter              = 'pageBreakAfter';
  StyleProp_PageBreakBefore             = 'pageBreakBefore';
  StyleProp_PageBreakInside             = 'pageBreakInside';
  StyleProp_PosBottom                   = 'posBottom';
  StyleProp_PosHeight                   = 'posHeight';
  StyleProp_Position                    = 'position';
  StyleProp_PosLeft                     = 'posLeft';
  StyleProp_PosRight                    = 'posRight';
  StyleProp_PosTop                      = 'posTop';
  StyleProp_PosWidth                    = 'posWidth';
  StyleProp_Quotes                      = 'quotes';
  StyleProp_Right                       = 'right';
  StyleProp_RubyAlign                   = 'rubyAlign';
  StyleProp_RubyOverhang                = 'rubyOverhang';
  StyleProp_RubyPosition                = 'rubyPosition';
  StyleProp_Scrollbar3dLightColor       = 'scrollbar3dLightColor';
  StyleProp_ScrollbarArrowColor         = 'scrollbarArrowColor';
  StyleProp_ScrollbarBaseColor          = 'scrollbarBaseColor';
  StyleProp_ScrollbarDarkShadowColor    = 'scrollbarDarkShadowColor';
  StyleProp_ScrollbarFaceColor          = 'scrollbarFaceColor';
  StyleProp_ScrollbarHighlightColor     = 'scrollbarHighlightColor';
  StyleProp_ScrollbarShadowColor        = 'scrollbarShadowColor';
  StyleProp_ScrollbarTrackColor         = 'scrollbarTrackColor';
  StyleProp_StyleFloat                  = 'styleFloat';
  StyleProp_TableLayout                 = 'tableLayout';
  StyleProp_TextAlign                   = 'textAlign';
  StyleProp_TextAlignLast               = 'textAlignLast';
  StyleProp_TextAutospace               = 'textAutospace';
  StyleProp_TextDecoration              = 'textDecoration';
  StyleProp_TextDecorationBlink         = 'textDecorationBlink';
  StyleProp_TextDecorationLineThrough   = 'textDecorationLineThrough';
  StyleProp_TextDecorationNone          = 'textDecorationNone';
  StyleProp_TextDecorationOverline      = 'textDecorationOverline';
  StyleProp_TextDecorationUnderline     = 'textDecorationUnderline';
  StyleProp_TextIndent                  = 'textIndent';
  StyleProp_TextJustify                 = 'textJustify';
  StyleProp_TextJustifyTrim             = 'textJustifyTrim';
  StyleProp_TextKashida                 = 'textKashida';
  StyleProp_TextKashidaSpace            = 'textKashidaSpace';
  StyleProp_TextOverflow                = 'textOverflow';
  StyleProp_TextTransform               = 'textTransform';
  StyleProp_TextUnderlinePosition       = 'textUnderlinePosition';
  StyleProp_Top                         = 'top';
  StyleProp_UnicodeBidi                 = 'unicodeBidi';
  StyleProp_VerticalAlign               = 'verticalAlign';
  StyleProp_Visibility                  = 'visibility';
  StyleProp_WhiteSpace                  = 'whiteSpace';
  StyleProp_Widows                      = 'widows';
  StyleProp_Width                       = 'width';
  StyleProp_WordBreak                   = 'wordBreak';
  StyleProp_WordSpacing                 = 'wordSpacing';
  StyleProp_WordWrap                    = 'wordWrap';
  StyleProp_WritingMode                 = 'writingMode';
  StyleProp_ZIndex                      = 'zIndex';
  StyleProp_Zoom                        = 'zoom';

type
  TDivNode = class;
  TDocument = class;
  TNode = class;
  TScriptNode = class;
  TTextNode = class;
  TStyle = class;

  TDOMNode = class(TDispObject)
  private
    FAttributes: TDOMNode;
    FChildNodes: TDOMNode;
    FFirstChild: TDOMNode;
    FLastChild: TDOMNode;
    FNextSibling: TDOMNode;
    FOwnerDocument: TDocument;
    FParentNode: TDOMNode;
    FRemoveChild: TDOMNode;
    FPreviousSibling: TDOMNode;
    procedure SetNodeValue(Value: String);
    function GetAttributes: TDOMNode;
    function GetChildNodes: TDOMNode;
    function GetFirstChild: TDOMNode;
    function GetLastChild: TDOMNode;
    function GetNextSibling: TDOMNode;
    function GetNodeName: String;
    function GetNodeType: Integer;
    function GetNodeValue: String;
    function GetOwnerDocument: TDocument;
    function GetParentNode: TDOMNode;
    function GetPreviousSibling: TDOMNode;
  public
    destructor Destroy; override;
    function AppendChild(NewChild: TDOMNode): TDOMNode;
    function CloneNode(Deep: Boolean): TDOMNode;
    function HasChildNodes: Boolean;
    function InsertBefore(NewChild, RefChild: TDOMNode): TDOMNode;
    function RemoveChild(ChildNode: TDOMNode): TDOMNode;
    function ReplaceChild(NewChild, OldChild: TDOMNode): TDOMNode;
    property Attributes: TDOMNode read GetAttributes;
    property ChildNodes: TDOMNode read GetChildNodes;
    property FirstChild: TDOMNode read GetFirstChild;
    property LastChild: TDOMNode read GetLastChild;
    property NextSibling: TDOMNode read GetNextSibling;
    property NodeName: String read GetNodeName;
    property NodeType: Integer read GetNodeType;
    property NodeValue: String read GetNodeValue write SetNodeValue;
    property OwnerDocument: TDocument read GetOwnerDocument;
    property ParentNode: TDOMNode read GetParentNode;
    property PreviousSibling: TDOMNode read GetPreviousSibling;
  end;

  TDocument = class(TDOMNode)
  private
    FBody: TNode;
    FHead: TNode;
    function GetBody: TNode;
    function GetHead: TNode;
  protected
    function NewElement(ElementType: String): IDispatch;
  public
    destructor Destroy; override;
    function CreateElement(ElementType: String): TNode;
    function CreateDivNode: TDivNode;
    function CreateDocumentFragment: TNode;
    function CreateScriptNode: TScriptNode;
    function CreateTextNode(Text: String): TTextNode;
    function GetElementByID(ID: String): TNode;
    property Body: TNode read GetBody;
    property Head: TNode read GetHead;
  end;

  TEvent = class(TDispObject)
  private
    function GetAltKey: Boolean;
    function GetButton: Integer;
    function GetClientX: Integer;
    function GetClientY: Integer;
    function GetCtrlKey: Boolean;
    function GetKeyCode: Integer;
    function GetOffsetX: Integer;
    function GetOffsetY: Integer;
    function GetShiftKey: Boolean;
    function GetX: Integer;
    function GetY: Integer;
  public
    //Alt-Taste gedrckt:
    property AltKey: Boolean read GetAltKey;
    //Maustasten: 1 fr die linke Taste, 2 fr die rechte Taste und 4 fr die mittlere Taste:
    property Button: Integer read GetButton;
    //Anzahl der horizontalen Pixel der Mauszeiger-Position relativ zur oberen linken
    //Ecke des Anzeigebereichs des Fensters, in dem das aktuelle Dokument dargestellt wird:
    property ClientX: Integer read GetClientX;
    //Anzahl der vertikalen Pixel der Mauszeiger-Position relativ zur oberen linken
    //Ecke des Anzeigebereichs des Fensters, in dem das aktuelle Dokument dargestellt wird:
    property ClientY: Integer read GetClientY;
    //Strg-Taste gedrckt:
    property CtrlKey: Boolean read GetCtrlKey;
    //Tastatur-Scancode der gedrckten Taste:
    property KeyCode: Integer read GetKeyCode;
    //Anzahl der horizontalen Pixel der Mauszeiger-Position relativ zur oberen linken
    //Ecke des Elements, das ein Ereignis ausgelst hat:
    property OffsetX: Integer read GetOffsetX;
    //Anzahl der vertikalen Pixel der Mauszeiger-Position relativ zur oberen linken
    //Ecke des Elements, das ein Ereignis ausgelst hat:
    property OffsetY: Integer read GetOffsetY;
    //Shift-Taste gedrckt:
    property ShiftKey: Boolean read GetShiftKey;
    //Anzahl der horizontalen Pixel der Mauszeiger-Position relativ zur oberen linken
    //Ecke des relativ positionierten Elternelements von dem Element, das ein Ereignis
    //ausgelst hat. Wenn das auslsende Element kein relativ positioniertes Elternelement
    //besitzt, gilt die linke obere Ecke des Dokuments als Bezug:
    property X: Integer read GetX;
    //Anzahl der vertikalen Pixel der Mauszeiger-Position relativ zur oberen linken
    //Ecke des relativ positionierten Elternelements von dem Element, das ein Ereignis
    //ausgelst hat. Wenn das auslsende Element kein relativ positioniertes Elternelement
    //besitzt, gilt die linke obere Ecke des Dokuments als Bezug:
    property Y: Integer read GetY;
  end;

  TGeolocation = class(TDispObject)
  private
  public
//ToDo    function GetCurrentPosition()
  end;

  TNavigator = class(TDispObject)
  private
    FGeolocation: TGeolocation;
    procedure SetAppCodeName(Value: String);
    procedure SetAppMinorVersion(Value: String);
    procedure SetAppName(Value: String);
    procedure SetAppVersion(Value: String);
    procedure SetCookieEnabled(Value: Boolean);
    procedure SetCPUClass(Value: String);
    procedure SetMimeTypes(Value: IDispatch{Ex});
    procedure SetOnLine(Value: Boolean);
    procedure SetOpsProfile(Value: IDispatch);
    procedure SetPlatform(Value: String);
    procedure SetPlugins(Value: IDispatch{Ex});
    procedure SetSystemLanguage(Value: String);
    procedure SetUserAgent(Value: String);
    procedure SetUserLanguage(Value: String);
    procedure SetUserProfile(Value: IDispatch);
    function GetAppCodeName: String;
    function GetAppMinorVersion: String;
    function GetAppName: String;
    function GetAppVersion: String;
    function GetCookieEnabled: Boolean;
    function GetCPUClass: String;
    function GetGeolocation: TGeolocation;
    function GetMimeTypes: IDispatch{Ex};
    function GetOnLine: Boolean;
    function GetOpsProfile: IDispatch;
    function GetPlatform: String;
    function GetPlugins: IDispatch{Ex};
    function GetSystemLanguage: String;
    function GetUserAgent: String;
    function GetUserLanguage: String;
    function GetUserProfile: IDispatch;
  public
    destructor Destroy; override;
    property AppCodeName: String read GetAppCodeName write SetAppCodeName;
    property AppMinorVersion: String read GetAppMinorVersion write SetAppMinorVersion;
    property AppName: String read GetAppName write SetAppName;
    property AppVersion: String read GetAppVersion write SetAppVersion;
    property CookieEnabled: Boolean read GetCookieEnabled write SetCookieEnabled;
    property CPUClass: String read GetCPUClass write SetCPUClass;
    property Geolocation: TGeolocation read GetGeolocation;
    property MimeTypes: IDispatch{Ex} read GetMimeTypes write SetMimeTypes;
    property OnLine: Boolean read GetOnLine write SetOnLine;
    property OpsProfile: IDispatch read GetOpsProfile write SetOpsProfile;
    property Platform: String read GetPlatform write SetPlatform;
    property Plugins: IDispatch{Ex} read GetPlugins write SetPlugins;
    property SystemLanguage: String read GetSystemLanguage write SetSystemLanguage;
    property UserAgent: String read GetUserAgent write SetUserAgent;
    property UserLanguage: String read GetUserLanguage write SetUserLanguage;
    property UserProfile: IDispatch read GetUserProfile write SetUserProfile;
  end;

  TNode = class(TDOMNode)
  private
    FAlign: TAlign;
    FHeight: Integer;
    FLeft: Integer;
    FStyle: TStyle;
    FTop: Integer;
    FWidth: Integer;
    procedure SetAccessKey(Value: String);
    procedure SetAlign(Value: TAlign);
    procedure SetAll(Value: IDispatch);
    procedure SetAria_activedescendant(Value: String);
    procedure SetAria_busy(Value: String);
    procedure SetAria_checked(Value: String);
    procedure SetAria_controls(Value: String);
    procedure SetAria_describedby(Value: String);
    procedure SetAria_disabled(Value: String);
    procedure SetAria_expanded(Value: String);
    procedure SetAria_flowto(Value: String);
    procedure SetAria_haspopup(Value: String);
    procedure SetAria_hidden(Value: String);
    procedure SetAria_invalid(Value: String);
    procedure SetAria_labelledby(Value: String);
    procedure SetAria_level(Value: SmallInt);
    procedure SetAria_live(Value: String);
    procedure SetAria_multiselectable(Value: String);
    procedure SetAria_owns(Value: String);
    procedure SetAria_posinset(Value: SmallInt);
    procedure SetAria_pressed(Value: String);
    procedure SetAria_readonly(Value: String);
    procedure SetAria_relevant(Value: String);
    procedure SetAria_required(Value: String);
    procedure SetAria_secret(Value: String);
    procedure SetAria_selected(Value: String);
    procedure SetAria_setsize(Value: SmallInt);
    procedure SetAria_valuemax(Value: String);
    procedure SetAria_valuemin(Value: String);
    procedure SetAria_valuenow(Value: String);
    procedure SetAttributes(Value: IDispatch);
    procedure SetBehaviorUrns(Value: IDispatch);
    procedure SetCanHaveChildren(Value: Boolean);
    procedure SetCanHaveHTML(Value: Boolean);
    procedure SetChildNodes(Value: IDispatch);
    procedure SetChildren(Value: IDispatch);
    procedure SetClassName(Value: String);
    procedure SetClientHeight(Value: Integer);
    procedure SetClientLeft(Value: Integer);
    procedure SetClientTop(Value: Integer);
    procedure SetClientWidth(Value: Integer);
    procedure SetContentEditable(Value: String);
    procedure SetCurrentStyle(Value: IDispatch);
    procedure SetDataFld(Value: String);
    procedure SetDataFormatAs(Value: String);
    procedure SetDataSrc(Value: String);
    procedure SetDir(Value: String);
    procedure SetDisabled(Value: Boolean);
    procedure SetDocument(Value: IDispatch);
    procedure SetFilters(Value: IDispatch);
//    procedure SetFirstChild(Value: IDispatch);
    procedure SetHideFocus(Value: Boolean);
    procedure SetID(Value: String);
    procedure SetInnerHTML(Value: String);
    procedure SetInnerText(Value: String);
    procedure SetIsContentEditable(Value: Boolean);
    procedure SetIsDisabled(Value: Boolean);
    procedure SetIsMultiLine(Value: Boolean);
    procedure SetIsTextEdit(Value: Boolean);
    procedure SetLang(Value: String);
    procedure SetLanguage(Value: String);
    procedure SetLastChild(Value: IDispatch);
    procedure SetNextSibling(Value: IDispatch);
    procedure SetNodeName(Value: String);
    procedure SetNodeType(Value: Integer);
    procedure SetNodeValue(Value: IDispatch);
    procedure SetNoWrap(Value: Boolean);
    procedure SetOffsetHeight(Value: Integer);
    procedure SetOffsetLeft(Value: Integer);
    procedure SetOffsetParent(Value: IDispatch);
    procedure SetOffsetTop(Value: Integer);
    procedure SetOffsetWidth(Value: Integer);
    procedure SetOnactivate(Value: IDispatch);
    procedure SetOnafterupdate(Value: IDispatch);
    procedure SetOnbeforeactivate(Value: IDispatch);
    procedure SetOnbeforecopy(Value: IDispatch);
    procedure SetOnbeforecut(Value: IDispatch);
    procedure SetOnbeforedeactivate(Value: IDispatch);
    procedure SetOnbeforeeditfocus(Value: IDispatch);
    procedure SetOnbeforepaste(Value: IDispatch);
    procedure SetOnbeforeupdate(Value: IDispatch);
    procedure SetOnblur(Value: IDispatch);
    procedure SetOncellchange(Value: IDispatch);
    procedure SetOnclick(Value: IDispatch);
    procedure SetOncontextmenu(Value: IDispatch);
    procedure SetOncontrolselect(Value: IDispatch);
    procedure SetOncopy(Value: IDispatch);
    procedure SetOncut(Value: IDispatch);
    procedure SetOndataavailable(Value: IDispatch);
    procedure SetOndatasetchanged(Value: IDispatch);
    procedure SetOndatasetcomplete(Value: IDispatch);
    procedure SetOndblclick(Value: IDispatch);
    procedure SetOndeactivate(Value: IDispatch);
    procedure SetOndrag(Value: IDispatch);
    procedure SetOndragend(Value: IDispatch);
    procedure SetOndragenter(Value: IDispatch);
    procedure SetOndragleave(Value: IDispatch);
    procedure SetOndragover(Value: IDispatch);
    procedure SetOndragstart(Value: IDispatch);
    procedure SetOndrop(Value: IDispatch);
    procedure SetOnerrorupdate(Value: IDispatch);
    procedure SetOnfilterchange(Value: IDispatch);
    procedure SetOnfocus(Value: IDispatch);
    procedure SetOnfocusin(Value: IDispatch);
    procedure SetOnfocusout(Value: IDispatch);
    procedure SetOnhelp(Value: IDispatch);
    procedure SetOnkeydown(Value: IDispatch);
    procedure SetOnkeypress(Value: IDispatch);
    procedure SetOnkeyup(Value: IDispatch);
    procedure SetOnlayoutcomplete(Value: IDispatch);
    procedure SetOnlosecapture(Value: IDispatch);
    procedure SetOnmousedown(Value: IDispatch);
    procedure SetOnmouseenter(Value: IDispatch);
    procedure SetOnmouseleave(Value: IDispatch);
    procedure SetOnmousemove(Value: IDispatch);
    procedure SetOnmouseout(Value: IDispatch);
    procedure SetOnmouseover(Value: IDispatch);
    procedure SetOnmouseup(Value: IDispatch);
    procedure SetOnmousewheel(Value: IDispatch);
    procedure SetOnmove(Value: IDispatch);
    procedure SetOnmoveend(Value: IDispatch);
    procedure SetOnmovestart(Value: IDispatch);
    procedure SetOnpage(Value: IDispatch);
    procedure SetOnpaste(Value: IDispatch);
    procedure SetOnpropertychange(Value: IDispatch);
    procedure SetOnreadystatechange(Value: IDispatch);
    procedure SetOnresize(Value: IDispatch);
    procedure SetOnresizeend(Value: IDispatch);
    procedure SetOnresizestart(Value: IDispatch);
    procedure SetOnrowenter(Value: IDispatch);
    procedure SetOnrowexit(Value: IDispatch);
    procedure SetOnrowsdelete(Value: IDispatch);
    procedure SetOnrowsinserted(Value: IDispatch);
    procedure SetOnscroll(Value: IDispatch);
    procedure SetOnselectstart(Value: IDispatch);
    procedure SetOuterHTML(Value: String);
    procedure SetOuterText(Value: String);
    procedure SetOwnerDocument(Value: IDispatch);
    procedure SetParentElement(Value: IDispatch);
    procedure SetParentNode(Value: IDispatch);
    procedure SetParentTextEdit(Value: IDispatch);
    procedure SetPreviousSibling(Value: IDispatch);
    procedure SetReadyState(Value: String);
    procedure SetRecordNumber(Value: IDispatch);
    procedure SetRole(Value: String);
    procedure SetRuntimeStyle(Value: IDispatch);
    procedure SetScopeName(Value: String);
    procedure SetScrollHeight(Value: Integer);
    procedure SetScrollLeft(Value: Integer);
    procedure SetScrollTop(Value: Integer);
    procedure SetScrollWidth(Value: Integer);
    procedure SetSourceIndex(Value: Integer);
    procedure SetStyle(Value: TStyle);
    procedure SetTabIndex(Value: SmallInt);
    procedure SetTagName(Value: String);
    procedure SetTagUrn(Value: String);
    procedure SetTitle(Value: String);
    procedure SetHeight(Value: Integer);
    procedure SetLeft(Value: Integer);
    procedure SetTop(Value: Integer);
    procedure SetWidth(Value: Integer);
    function GetAccessKey: String;
//    function GetAlign: String;
    function GetAll: IDispatch;
    function GetAria_activedescendant: String;
    function GetAria_busy: String;
    function GetAria_checked: String;
    function GetAria_controls: String;
    function GetAria_describedby: String;
    function GetAria_disabled: String;
    function GetAria_expanded: String;
    function GetAria_flowto: String;
    function GetAria_haspopup: String;
    function GetAria_hidden: String;
    function GetAria_invalid: String;
    function GetAria_labelledby: String;
    function GetAria_level: SmallInt;
    function GetAria_live: String;
    function GetAria_multiselectable: String;
    function GetAria_owns: String;
    function GetAria_posinset: SmallInt;
    function GetAria_pressed: String;
    function GetAria_readonly: String;
    function GetAria_relevant: String;
    function GetAria_required: String;
    function GetAria_secret: String;
    function GetAria_selected: String;
    function GetAria_setsize: SmallInt;
    function GetAria_valuemax: String;
    function GetAria_valuemin: String;
    function GetAria_valuenow: String;
    function GetAttributes: IDispatch;
    function GetBehaviorUrns: IDispatch;
    function GetCanHaveChildren: Boolean;
    function GetCanHaveHTML: Boolean;
    function GetChildNodes: IDispatch;
    function GetChildren: IDispatch;
    function GetClassName: String;
    function GetClientHeight: Integer;
    function GetClientLeft: Integer;
    function GetClientTop: Integer;
    function GetClientWidth: Integer;
    function GetContentEditable: String;
    function GetCurrentStyle: IDispatch;
    function GetDataFld: String;
    function GetDataFormatAs: String;
    function GetDataSrc: String;
    function GetDir: String;
    function GetDisabled: Boolean;
    function GetDocument: IDispatch;
    function GetFilters: IDispatch;
//    function GetFirstChild: IDispatch;
    function GetHideFocus: Boolean;
    function GetID: String;
    function GetInnerHTML: String;
    function GetInnerText: String;
    function GetIsContentEditable: Boolean;
    function GetIsDisabled: Boolean;
    function GetIsMultiLine: Boolean;
    function GetIsTextEdit: Boolean;
    function GetLang: String;
    function GetLanguage: String;
    function GetLastChild: IDispatch;
    function GetNextSibling: IDispatch;
    function GetNodeName: String;
    function GetNodeType: Integer;
    function GetNodeValue: IDispatch;
    function GetNoWrap: Boolean;
    function GetOffsetHeight: Integer;
    function GetOffsetLeft: Integer;
    function GetOffsetParent: IDispatch;
    function GetOffsetTop: Integer;
    function GetOffsetWidth: Integer;
    function GetOnactivate: IDispatch;
    function GetOnafterupdate: IDispatch;
    function GetOnbeforeactivate: IDispatch;
    function GetOnbeforecopy: IDispatch;
    function GetOnbeforecut: IDispatch;
    function GetOnbeforedeactivate: IDispatch;
    function GetOnbeforeeditfocus: IDispatch;
    function GetOnbeforepaste: IDispatch;
    function GetOnbeforeupdate: IDispatch;
    function GetOnblur: IDispatch;
    function GetOncellchange: IDispatch;
    function GetOnclick: IDispatch;
    function GetOncontextmenu: IDispatch;
    function GetOncontrolselect: IDispatch;
    function GetOncopy: IDispatch;
    function GetOncut: IDispatch;
    function GetOndataavailable: IDispatch;
    function GetOndatasetchanged: IDispatch;
    function GetOndatasetcomplete: IDispatch;
    function GetOndblclick: IDispatch;
    function GetOndeactivate: IDispatch;
    function GetOndrag: IDispatch;
    function GetOndragend: IDispatch;
    function GetOndragenter: IDispatch;
    function GetOndragleave: IDispatch;
    function GetOndragover: IDispatch;
    function GetOndragstart: IDispatch;
    function GetOndrop: IDispatch;
    function GetOnerrorupdate: IDispatch;
    function GetOnfilterchange: IDispatch;
    function GetOnfocus: IDispatch;
    function GetOnfocusin: IDispatch;
    function GetOnfocusout: IDispatch;
    function GetOnhelp: IDispatch;
    function GetOnkeydown: IDispatch;
    function GetOnkeypress: IDispatch;
    function GetOnkeyup: IDispatch;
    function GetOnlayoutcomplete: IDispatch;
    function GetOnlosecapture: IDispatch;
    function GetOnmousedown: IDispatch;
    function GetOnmouseenter: IDispatch;
    function GetOnmouseleave: IDispatch;
    function GetOnmousemove: IDispatch;
    function GetOnmouseout: IDispatch;
    function GetOnmouseover: IDispatch;
    function GetOnmouseup: IDispatch;
    function GetOnmousewheel: IDispatch;
    function GetOnmove: IDispatch;
    function GetOnmoveend: IDispatch;
    function GetOnmovestart: IDispatch;
    function GetOnpage: IDispatch;
    function GetOnpaste: IDispatch;
    function GetOnpropertychange: IDispatch;
    function GetOnreadystatechange: IDispatch;
    function GetOnresize: IDispatch;
    function GetOnresizeend: IDispatch;
    function GetOnresizestart: IDispatch;
    function GetOnrowenter: IDispatch;
    function GetOnrowexit: IDispatch;
    function GetOnrowsdelete: IDispatch;
    function GetOnrowsinserted: IDispatch;
    function GetOnscroll: IDispatch;
    function GetOnselectstart: IDispatch;
    function GetOuterHTML: String;
    function GetOuterText: String;
    function GetOwnerDocument: IDispatch;
    function GetParentElement: IDispatch;
    function GetParentNode: IDispatch;
    function GetParentTextEdit: IDispatch;
    function GetPreviousSibling: IDispatch;
    function GetReadyState: String;
    function GetRecordNumber: IDispatch;
    function GetRole: String;
    function GetRuntimeStyle: IDispatch;
    function GetScopeName: String;
    function GetScrollHeight: Integer;
    function GetScrollLeft: Integer;
    function GetScrollTop: Integer;
    function GetScrollWidth: Integer;
    function GetSourceIndex: Integer;
    function GetStyle: TStyle;
    function GetTabIndex: SmallInt;
    function GetTagName: String;
    function GetTagUrn: String;
    function GetTitle: String;
    function GetHeight: Integer;
    function GetLeft: Integer;
    function GetTop: Integer;
    function GetWidth: Integer;
  public
    destructor Destroy; override;
    property AccessKey: String read GetAccessKey write SetAccessKey;
    property Align: TAlign read FAlign write SetAlign;
    property All: IDispatch read GetAll write SetAll;
    property Aria_activedescendant: String read GetAria_activedescendant write SetAria_activedescendant;
    property Aria_busy: String read GetAria_busy write SetAria_busy;
    property Aria_checked: String read GetAria_checked write SetAria_checked;
    property Aria_controls: String read GetAria_controls write SetAria_controls;
    property Aria_describedby: String read GetAria_describedby write SetAria_describedby;
    property Aria_disabled: String read GetAria_disabled write SetAria_disabled;
    property Aria_expanded: String read GetAria_expanded write SetAria_expanded;
    property Aria_flowto: String read GetAria_flowto write SetAria_flowto;
    property Aria_haspopup: String read GetAria_haspopup write SetAria_haspopup;
    property Aria_hidden: String read GetAria_hidden write SetAria_hidden;
    property Aria_invalid: String read GetAria_invalid write SetAria_invalid;
    property Aria_labelledby: String read GetAria_labelledby write SetAria_labelledby;
    property Aria_level: SmallInt read GetAria_level write SetAria_level;
    property Aria_live: String read GetAria_live write SetAria_live;
    property Aria_multiselectable: String read GetAria_multiselectable write SetAria_multiselectable;
    property Aria_owns: String read GetAria_owns write SetAria_owns;
    property Aria_posinset: SmallInt read GetAria_posinset write SetAria_posinset;
    property Aria_pressed: String read GetAria_pressed write SetAria_pressed;
    property Aria_readonly: String read GetAria_readonly write SetAria_readonly;
    property Aria_relevant: String read GetAria_relevant write SetAria_relevant;
    property Aria_required: String read GetAria_required write SetAria_required;
    property Aria_secret: String read GetAria_secret write SetAria_secret;
    property Aria_selected: String read GetAria_selected write SetAria_selected;
    property Aria_setsize: SmallInt read GetAria_setsize write SetAria_setsize;
    property Aria_valuemax: String read GetAria_valuemax write SetAria_valuemax;
    property Aria_valuemin: String read GetAria_valuemin write SetAria_valuemin;
    property Aria_valuenow: String read GetAria_valuenow write SetAria_valuenow;
    property Attributes: IDispatch read GetAttributes write SetAttributes;
    property BehaviorUrns: IDispatch read GetBehaviorUrns write SetBehaviorUrns;
    property CanHaveChildren: Boolean read GetCanHaveChildren write SetCanHaveChildren;
    property CanHaveHTML: Boolean read GetCanHaveHTML write SetCanHaveHTML;
    property ChildNodes: IDispatch read GetChildNodes write SetChildNodes;
    property Children: IDispatch read GetChildren write SetChildren;
    property ClassName_: String read GetClassName write SetClassName;
    property ClientHeight: Integer read GetClientHeight write SetClientHeight;
    property ClientLeft: Integer read GetClientLeft write SetClientLeft;
    property ClientTop: Integer read GetClientTop write SetClientTop;
    property ClientWidth: Integer read GetClientWidth write SetClientWidth;
    property ContentEditable: String read GetContentEditable write SetContentEditable;
    property CurrentStyle: IDispatch read GetCurrentStyle write SetCurrentStyle;
    property DataFld: String read GetDataFld write SetDataFld;
    property DataFormatAs: String read GetDataFormatAs write SetDataFormatAs;
    property DataSrc: String read GetDataSrc write SetDataSrc;
    property Dir: String read GetDir write SetDir;
    property Disabled: Boolean read GetDisabled write SetDisabled;
    property Document: IDispatch read GetDocument write SetDocument;
    property Filters: IDispatch read GetFilters write SetFilters;
//    property FirstChild: IDispatch read GetFirstChild write SetFirstChild;
    property HideFocus: Boolean read GetHideFocus write SetHideFocus;
    property Height: Integer read GetHeight write SetHeight;
    property ID: String read GetID write SetID;
    property InnerHTML: String read GetInnerHTML write SetInnerHTML;
    property InnerText: String read GetInnerText write SetInnerText;
    property IsContentEditable: Boolean read GetIsContentEditable write SetIsContentEditable;
    property IsDisabled: Boolean read GetIsDisabled write SetIsDisabled;
    property IsMultiLine: Boolean read GetIsMultiLine write SetIsMultiLine;
    property IsTextEdit: Boolean read GetIsTextEdit write SetIsTextEdit;
    property Lang: String read GetLang write SetLang;
    property Language: String read GetLanguage write SetLanguage;
    property LastChild: IDispatch read GetLastChild write SetLastChild;
    property Left: Integer read GetLeft write SetLeft;
    property NextSibling: IDispatch read GetNextSibling write SetNextSibling;
    property NodeName: String read GetNodeName write SetNodeName;
    property NodeType: Integer read GetNodeType write SetNodeType;
    property NodeValue: IDispatch read GetNodeValue write SetNodeValue;
    property NoWrap: Boolean read GetNoWrap write SetNoWrap;
    property OffsetHeight: Integer read GetOffsetHeight write SetOffsetHeight;
    property OffsetLeft: Integer read GetOffsetLeft write SetOffsetLeft;
    property OffsetParent: IDispatch read GetOffsetParent write SetOffsetParent;
    property OffsetTop: Integer read GetOffsetTop write SetOffsetTop;
    property OffsetWidth: Integer read GetOffsetWidth write SetOffsetWidth;
    property OnActivate: IDispatch read GetOnactivate write SetOnactivate;
    property OnAfterUpdate: IDispatch read GetOnafterupdate write SetOnafterupdate;
    property OnBeforeActivate: IDispatch read GetOnbeforeactivate write SetOnbeforeactivate;
    property OnBeforeCopy: IDispatch read GetOnbeforecopy write SetOnbeforecopy;
    property OnBeforeCut: IDispatch read GetOnbeforecut write SetOnbeforecut;
    property OnBeforeDeactivate: IDispatch read GetOnbeforedeactivate write SetOnbeforedeactivate;
    property OnBeforeEditFocus: IDispatch read GetOnbeforeeditfocus write SetOnbeforeeditfocus;
    property OnBeforePaste: IDispatch read GetOnbeforepaste write SetOnbeforepaste;
    property OnBeforeUpdate: IDispatch read GetOnbeforeupdate write SetOnbeforeupdate;
    property OnBlur: IDispatch read GetOnblur write SetOnblur;
    property OnCellChange: IDispatch read GetOncellchange write SetOncellchange;
    property OnClick: IDispatch read GetOnclick write SetOnclick;
    property OnContextmenu: IDispatch read GetOncontextmenu write SetOncontextmenu;
    property OnControlSelect: IDispatch read GetOncontrolselect write SetOncontrolselect;
    property OnCopy: IDispatch read GetOncopy write SetOncopy;
    property OnCut: IDispatch read GetOncut write SetOncut;
    property OnDataAvailable: IDispatch read GetOndataavailable write SetOndataavailable;
    property OnDatasetChanged: IDispatch read GetOndatasetchanged write SetOndatasetchanged;
    property OnDatasetComplete: IDispatch read GetOndatasetcomplete write SetOndatasetcomplete;
    property OnDblClick: IDispatch read GetOndblclick write SetOndblclick;
    property OnDeactivate: IDispatch read GetOndeactivate write SetOndeactivate;
    property OnDrag: IDispatch read GetOndrag write SetOndrag;
    property OnDragEnd: IDispatch read GetOndragend write SetOndragend;
    property OnDragEnter: IDispatch read GetOndragenter write SetOndragenter;
    property OnDragLeave: IDispatch read GetOndragleave write SetOndragleave;
    property OnDragOver: IDispatch read GetOndragover write SetOndragover;
    property OnDragStart: IDispatch read GetOndragstart write SetOndragstart;
    property OnDrop: IDispatch read GetOndrop write SetOndrop;
    property OnErrorUpdate: IDispatch read GetOnerrorupdate write SetOnerrorupdate;
    property OnFilterChange: IDispatch read GetOnfilterchange write SetOnfilterchange;
    property OnFocus: IDispatch read GetOnfocus write SetOnfocus;
    property OnFocusIn: IDispatch read GetOnfocusin write SetOnfocusin;
    property OnFocusOut: IDispatch read GetOnfocusout write SetOnfocusout;
    property OnHelp: IDispatch read GetOnhelp write SetOnhelp;
    property OnKeyDown: IDispatch read GetOnkeydown write SetOnkeydown;
    property OnKeyPress: IDispatch read GetOnkeypress write SetOnkeypress;
    property OnKeyUp: IDispatch read GetOnkeyup write SetOnkeyup;
    property OnLayoutComplete: IDispatch read GetOnlayoutcomplete write SetOnlayoutcomplete;
    property OnLoseCapture: IDispatch read GetOnlosecapture write SetOnlosecapture;
    property OnMouseDown: IDispatch read GetOnmousedown write SetOnmousedown;
    property OnMouseEnter: IDispatch read GetOnmouseenter write SetOnmouseenter;
    property OnMouseLeave: IDispatch read GetOnmouseleave write SetOnmouseleave;
    property OnMouseMove: IDispatch read GetOnmousemove write SetOnmousemove;
    property OnMouseOut: IDispatch read GetOnmouseout write SetOnmouseout;
    property OnMouseOver: IDispatch read GetOnmouseover write SetOnmouseover;
    property OnMouseUp: IDispatch read GetOnmouseup write SetOnmouseup;
    property OnMouseWheel: IDispatch read GetOnmousewheel write SetOnmousewheel;
    property OnMove: IDispatch read GetOnmove write SetOnmove;
    property OnMoveEnd: IDispatch read GetOnmoveend write SetOnmoveend;
    property OnMoveStart: IDispatch read GetOnmovestart write SetOnmovestart;
    property OnPage: IDispatch read GetOnpage write SetOnpage;
    property OnPaste: IDispatch read GetOnpaste write SetOnpaste;
    property OnPropertyChange: IDispatch read GetOnpropertychange write SetOnpropertychange;
    property OnReadyStateChange: IDispatch read GetOnreadystatechange write SetOnreadystatechange;
    property OnResize: IDispatch read GetOnresize write SetOnresize;
    property OnResizeEnd: IDispatch read GetOnresizeend write SetOnresizeend;
    property OnResizeStart: IDispatch read GetOnresizestart write SetOnresizestart;
    property OnRowEnter: IDispatch read GetOnrowenter write SetOnrowenter;
    property OnRowExit: IDispatch read GetOnrowexit write SetOnrowexit;
    property OnRowsDelete: IDispatch read GetOnrowsdelete write SetOnrowsdelete;
    property OnRowsInserted: IDispatch read GetOnrowsinserted write SetOnrowsinserted;
    property OnScroll: IDispatch read GetOnscroll write SetOnscroll;
    property OnSelectStart: IDispatch read GetOnselectstart write SetOnselectstart;
    property OuterHTML: String read GetOuterHTML write SetOuterHTML;
    property OuterText: String read GetOuterText write SetOuterText;
    property OwnerDocument: IDispatch read GetOwnerDocument write SetOwnerDocument;
    property ParentElement: IDispatch read GetParentElement write SetParentElement;
    property ParentNode: IDispatch read GetParentNode write SetParentNode;
    property ParentTextEdit: IDispatch read GetParentTextEdit write SetParentTextEdit;
    property PreviousSibling: IDispatch read GetPreviousSibling write SetPreviousSibling;
    property ReadyState: String read GetReadyState write SetReadyState;
    property RecordNumber: IDispatch read GetRecordNumber write SetRecordNumber;
    property Role: String read GetRole write SetRole;
    property RuntimeStyle: IDispatch read GetRuntimeStyle write SetRuntimeStyle;
    property ScopeName: String read GetScopeName write SetScopeName;
    property ScrollHeight: Integer read GetScrollHeight write SetScrollHeight;
    property ScrollLeft: Integer read GetScrollLeft write SetScrollLeft;
    property ScrollTop: Integer read GetScrollTop write SetScrollTop;
    property ScrollWidth: Integer read GetScrollWidth write SetScrollWidth;
    property SourceIndex: Integer read GetSourceIndex write SetSourceIndex;
    property Style: TStyle read GetStyle write SetStyle;
    property TabIndex: SmallInt read GetTabIndex write SetTabIndex;
    property TagName: String read GetTagName write SetTagName;
    property TagUrn: String read GetTagUrn write SetTagUrn;
    property Title: String read GetTitle write SetTitle;
    property Top: Integer read GetTop write SetTop;
    property Width: Integer read GetWidth write SetWidth;
{    //Kindknoten hinzufgen:
    function AppendChild(Node: TNode): TNode;
    appendData() (Zeichendaten hinzufgen)
    deleteData() (Zeichendaten lschen)
    getAttribute() (Wert eines Attributknotens ermitteln)
    getAttributeNode() (Attributknoten ermitteln)
    getElementsByTagName() (Zugriff auf Kindelemente ber den Elementnamen)
    insertData() (Zeichendaten einfgen)
    removeAttribute() (Attribut lschen)
    removeAttributeNode() (Attributknoten lschen)
    replaceData() (Zeichendaten ersetzen)
    setAttribute() (Wert eines Attributknotens setzen)
    setAttributeNode() (Attributknoten erzeugen)
    function AppendChild(NewChild: TDOMNode): TDOMNode;
    property Attributes: TDOMNode read GetAttributes;
    property ChildNodes: TDOMNode read GetChildNodes;
    property FirstChild: TDOMNode read GetFirstChild;
    property LastChild: TDOMNode read GetLastChild;
    property NextSibling: TDOMNode read GetNextSibling;
    property NodeName: String read GetNodeName;
    property NodeType: Integer read GetNodeType;
    property NodeValue: String read GetNodeValue write SetNodeValue;
    property OwnerDocument: TDocument read GetOwnerDocument;
    property ParentNode: TDOMNode read GetParentNode;
    property PreviousSibling: TDOMNode read GetPreviousSibling;
    property Attributes: TJScriptArray
    property ChildNodes (Kindknoten)
    property Data (Zeichendaten)
    property FirstChild (erster Kindknoten)
    property LastChild (letzter Kindknoten)
    property NextSibling (nchster Knoten auf derselben Ebene)
    property NodeName (Name des Knotens)
    property NodeType (Knotentyp)
    property NodeValue (Wert/Inhalt des Knotens)
    property ParentNode (Elternknoten)
    property PreviousSibling (vorheriger Knoten auf derselben Ebene) }
 end;

  TDivNode = class(TNode)
  end;

  TTextNode = class(TNode)
  end;

  TScriptNode = class(TNode)
  private
    procedure SetCharset(Value: String);
    procedure SetDefer(Value: Boolean);
    procedure SetEvent(Value: String);
    procedure SetHTMLFor(Value: String);
    procedure SetSrc(Value: String);
    procedure SetText(Value: String);
    procedure SetType(Value: String);
    function GetCharset: String;
    function GetDefer: Boolean;
    function GetEvent: String;
    function GetHTMLFor: String;
    function GetSrc: String;
    function GetText: String;
    function GetType: String;
  public
    property Charset: String read GetCharset write SetCharset;
    property Defer: Boolean read GetDefer write SetDefer;
    property Event: String read GetEvent write SetEvent;
    property HTMLFor: String read GetHTMLFor write SetHTMLFor;
    property Src: String read GetSrc write SetSrc;
    property Text: String read GetText write SetText;
    property Type_: String read GetType write SetType;
  end;

  THTMLInputElement = class(TNode)
  private
    procedure SetAccept(Value: String);
    procedure SetAccessKey(Value: String);
    procedure SetAlign(Value: String);
    procedure SetAlt(Value: String);
    procedure SetChecked(Value: Boolean);
    procedure SetDefaultChecked(Value: Boolean);
    procedure SetDefaultValue(Value: String);
    procedure SetDisabled(Value: Boolean);
    procedure SetMaxLength(Value: Integer);
    procedure SetName(Value: String);
    procedure SetOptions(Value: String);
    procedure SetReadOnly(Value: Boolean);
    procedure SetSelectedIndex(Value: Integer);
    procedure SetSize(Value: String);
    procedure SetTabIndex(Value: Integer);
    procedure SetType(Value: String);
    procedure SetUseMap(Value: String);
    procedure SetValue(Value: String);
    procedure SetOnChange(Value: IDispatch);
    procedure SetOnClick(Value: IDispatch);
    function GetAccept: String;
    function GetAccessKey: String;
    function GetAlign: String;
    function GetAlt: String;
    function GetChecked: Boolean;
    function GetDefaultChecked: Boolean;
    function GetDefaultValue: String;
    function GetDisabled: Boolean;
    function GetForm: IDispatch;
    function GetMaxLength: Integer;
    function GetName: String;
    function GetOptions: String;
    function GetReadOnly: Boolean;
    function GetSelectedIndex: Integer;
    function GetSize: String;
    function GetTabIndex: Integer;
    function GetType: String;
    function GetUseMap: String;
    function GetValue: String;
    function GetOnChange: IDispatch;
    function GetOnClick: IDispatch;
  public
    property Accept: String read GetAccept write SetAccept;
    property AccessKey: String read GetAccessKey write SetAccessKey;
    property Align: String read GetAlign write SetAlign;
    property Alt: String read GetAlt write SetAlt;
    property Checked: Boolean read GetChecked write SetChecked;
    property DefaultChecked: Boolean read GetDefaultChecked write SetDefaultChecked;
    property DefaultValue: String read GetDefaultValue write SetDefaultValue;
    property Disabled: Boolean read GetDisabled write SetDisabled;
    property Form: IDispatch read GetForm;
    property MaxLength: Integer read GetMaxLength write SetMaxLength;
    property Name: String read GetName write SetName;
    property Options: String read GetOptions write SetOptions;
    property ReadOnly: Boolean read GetReadOnly write SetReadOnly;
    property SelectedIndex: Integer read GetSelectedIndex write SetSelectedIndex;
    property Size: String read GetSize write SetSize;
    property TabIndex: Integer read GetTabIndex write SetTabIndex;
    property {$IFDEF AND_OP}&Type{$ELSE}Type_{$ENDIF}: String read GetType write SetType;
    property UseMap: String read GetUseMap write SetUseMap;
    property Value: String read GetValue write SetValue;
    property OnChange: IDispatch read GetOnChange write SetOnChange;
    property OnClick: IDispatch read GetOnClick write SetOnClick;
  end;

  TStyle = class(TDispObject)
    procedure SetAccelerator(Value: String);
    procedure SetBackground(Value: String);
    procedure SetBackgroundAttachment(Value: String);
    procedure SetBackgroundColor(Value: TColor);
    procedure SetBackgroundImage(Value: String);
    procedure SetBackgroundPosition(Value: String);
    procedure SetBackgroundPositionX(Value: String);
    procedure SetBackgroundPositionY(Value: String);
    procedure SetBackgroundRepeat(Value: String);
    procedure SetBehavior(Value: String);
    procedure SetBorder(Value: String);
    procedure SetBorderBottom(Value: String);
    procedure SetBorderBottomColor(Value: TColor);
    procedure SetBorderBottomStyle(Value: String);
    procedure SetBorderBottomWidth(Value: String);
    procedure SetBorderCollapse(Value: String);
    procedure SetBorderColor(Value: TColor);
    procedure SetBorderLeft(Value: String);
    procedure SetBorderLeftColor(Value: TColor);
    procedure SetBorderLeftStyle(Value: String);
    procedure SetBorderLeftWidth(Value: String);
    procedure SetBorderRight(Value: String);
    procedure SetBorderRightColor(Value: TColor);
    procedure SetBorderRightStyle(Value: String);
    procedure SetBorderRightWidth(Value: String);
    procedure SetBorderSpacing(Value: String);
    procedure SetBorderStyle(Value: String);
    procedure SetBorderTop(Value: String);
    procedure SetBorderTopColor(Value: TColor);
    procedure SetBorderTopStyle(Value: String);
    procedure SetBorderTopWidth(Value: String);
    procedure SetBorderWidth(Value: String);
    procedure SetBottom(Value: String);
    procedure SetBoxSizing(Value: String);
    procedure SetCaptionSide(Value: String);
    procedure SetClear(Value: String);
    procedure SetClip(Value: String);
    procedure SetColor(Value: TColor);
    procedure SetContent(Value: String);
    procedure SetCounterIncrement(Value: String);
    procedure SetCounterReset(Value: String);
    procedure SetCSSText(Value: String);
    procedure SetCursor(Value: String);
    procedure SetDirection(Value: String);
    procedure SetDisplay(Value: String);
    procedure SetEmptyCells(Value: String);
    procedure SetFilter(Value: String);
    procedure SetFloat(Value: String);
    procedure SetFont(Value: String);
    procedure SetFontFamily(Value: String);
    procedure SetFontSize(Value: String);
    procedure SetFontStyle(Value: String);
    procedure SetFontVariant(Value: String);
    procedure SetFontWeight(Value: String);
    procedure SetHeight(Value: String);
    procedure SetImeMode(Value: String);
    procedure SetLayoutFlow(Value: String);
    procedure SetLayoutGrid(Value: String);
    procedure SetLayoutGridChar(Value: String);
    procedure SetLayoutGridLine(Value: String);
    procedure SetLayoutGridMode(Value: String);
    procedure SetLayoutGridType(Value: String);
    procedure SetLeft(Value: String);
    procedure SetLetterSpacing(Value: String);
    procedure SetLineBreak(Value: String);
    procedure SetLineHeight(Value: String);
    procedure SetListStyle(Value: String);
    procedure SetListStyleImage(Value: String);
    procedure SetListStylePosition(Value: String);
    procedure SetListStyleType(Value: String);
    procedure SetMargin(Value: String);
    procedure SetMarginBottom(Value: String);
    procedure SetMarginLeft(Value: String);
    procedure SetMarginRight(Value: String);
    procedure SetMarginTop(Value: String);
    procedure SetMaxHeight(Value: String);
    procedure SetMaxWidth(Value: String);
    procedure SetMinHeight(Value: String);
    procedure SetMinWidth(Value: String);
    procedure SetMsBlockProgression(Value: String);
    procedure SetMsInterpolationMode(Value: String);
    procedure SetOpacity(Value: Double);
    procedure SetOrphans(Value: String);
    procedure SetOutline(Value: String);
    procedure SetOutlineColor(Value: TColor);
    procedure SetOutlineStyle(Value: String);
    procedure SetOutlineWidth(Value: String);
    procedure SetOverflow(Value: String);
    procedure SetOverflowX(Value: String);
    procedure SetOverflowY(Value: String);
    procedure SetPadding(Value: String);
    procedure SetPaddingBottom(Value: String);
    procedure SetPaddingLeft(Value: String);
    procedure SetPaddingRight(Value: String);
    procedure SetPaddingTop(Value: String);
    procedure SetPageBreakAfter(Value: String);
    procedure SetPageBreakBefore(Value: String);
    procedure SetPageBreakInside(Value: String);
    procedure SetPosBottom(Value: Single);
    procedure SetPosHeight(Value: Single);
    procedure SetPosition(Value: String);
    procedure SetPosLeft(Value: Single);
    procedure SetPosRight(Value: Single);
    procedure SetPosTop(Value: Single);
    procedure SetPosWidth(Value: Single);
    procedure SetQuotes(Value: String);
    procedure SetRight(Value: String);
    procedure SetRubyAlign(Value: String);
    procedure SetRubyOverhang(Value: String);
    procedure SetRubyPosition(Value: String);
    procedure SetScrollbar3dLightColor(Value: TColor);
    procedure SetScrollbarArrowColor(Value: TColor);
    procedure SetScrollbarBaseColor(Value: TColor);
    procedure SetScrollbarDarkShadowColor(Value: TColor);
    procedure SetScrollbarFaceColor(Value: TColor);
    procedure SetScrollbarHighlightColor(Value: TColor);
    procedure SetScrollbarShadowColor(Value: TColor);
    procedure SetScrollbarTrackColor(Value: TColor);
    procedure SetStyleFloat(Value: String);
    procedure SetTableLayout(Value: String);
    procedure SetTextAlign(Value: String);
    procedure SetTextAlignLast(Value: String);
    procedure SetTextAutospace(Value: String);
    procedure SetTextDecoration(Value: String);
    procedure SetTextDecorationBlink(Value: Boolean);
    procedure SetTextDecorationLineThrough(Value: Boolean);
    procedure SetTextDecorationNone(Value: Boolean);
    procedure SetTextDecorationOverline(Value: Boolean);
    procedure SetTextDecorationUnderline(Value: Boolean);
    procedure SetTextIndent(Value: String);
    procedure SetTextJustify(Value: String);
    procedure SetTextJustifyTrim(Value: String);
    procedure SetTextKashida(Value: String);
    procedure SetTextKashidaSpace(Value: String);
    procedure SetTextOverflow(Value: String);
    procedure SetTextTransform(Value: String);
    procedure SetTextUnderlinePosition(Value: String);
    procedure SetTop(Value: String);
    procedure SetUnicodeBiDi(Value: String);
    procedure SetVerticalAlign(Value: String);
    procedure SetVisibility(Value: String);
    procedure SetWhiteSpace(Value: String);
    procedure SetWidows(Value: String);
    procedure SetWidth(Value: String);
    procedure SetWordBreak(Value: String);
    procedure SetWordSpacing(Value: String);
    procedure SetWordWrap(Value: String);
    procedure SetWritingMode(Value: String);
    procedure SetZIndex(Value: Integer);
    procedure SetZoom(Value: String);
    function GetAccelerator: String;
    function GetBackground: String;
    function GetBackgroundAttachment: String;
    function GetBackgroundColor: TColor;
    function GetBackgroundImage: String;
    function GetBackgroundPosition: String;
    function GetBackgroundPositionX: String;
    function GetBackgroundPositionY: String;
    function GetBackgroundRepeat: String;
    function GetBehavior: String;
    function GetBorder: String;
    function GetBorderBottom: String;
    function GetBorderBottomColor: TColor;
    function GetBorderBottomStyle: String;
    function GetBorderBottomWidth: String;
    function GetBorderCollapse: String;
    function GetBorderColor: TColor;
    function GetBorderLeft: String;
    function GetBorderLeftColor: TColor;
    function GetBorderLeftStyle: String;
    function GetBorderLeftWidth: String;
    function GetBorderRight: String;
    function GetBorderRightColor: TColor;
    function GetBorderRightStyle: String;
    function GetBorderRightWidth: String;
    function GetBorderSpacing: String;
    function GetBorderStyle: String;
    function GetBorderTop: String;
    function GetBorderTopColor: TColor;
    function GetBorderTopStyle: String;
    function GetBorderTopWidth: String;
    function GetBorderWidth: String;
    function GetBottom: String;
    function GetBoxSizing: String;
    function GetCaptionSide: String;
    function GetClear: String;
    function GetClip: String;
    function GetColor: TColor;
    function GetContent: String;
    function GetCounterIncrement: String;
    function GetCounterReset: String;
    function GetCSSText: String;
    function GetCursor: String;
    function GetDirection: String;
    function GetDisplay: String;
    function GetEmptyCells: String;
    function GetFilter: String;
    function GetFloat: String;
    function GetFont: String;
    function GetFontFamily: String;
    function GetFontSize: String;
    function GetFontStyle: String;
    function GetFontVariant: String;
    function GetFontWeight: String;
    function GetHeight: String;
    function GetImeMode: String;
    function GetLayoutFlow: String;
    function GetLayoutGrid: String;
    function GetLayoutGridChar: String;
    function GetLayoutGridLine: String;
    function GetLayoutGridMode: String;
    function GetLayoutGridType: String;
    function GetLeft: String;
    function GetLetterSpacing: String;
    function GetLineBreak: String;
    function GetLineHeight: String;
    function GetListStyle: String;
    function GetListStyleImage: String;
    function GetListStylePosition: String;
    function GetListStyleType: String;
    function GetMargin: String;
    function GetMarginBottom: String;
    function GetMarginLeft: String;
    function GetMarginRight: String;
    function GetMarginTop: String;
    function GetMaxHeight: String;
    function GetMaxWidth: String;
    function GetMinHeight: String;
    function GetMinWidth: String;
    function GetMsBlockProgression: String;
    function GetMsInterpolationMode: String;
    function GetOpacity: Double;
    function GetOrphans: String;
    function GetOutline: String;
    function GetOutlineColor: TColor;
    function GetOutlineStyle: String;
    function GetOutlineWidth: String;
    function GetOverflow: String;
    function GetOverflowX: String;
    function GetOverflowY: String;
    function GetPadding: String;
    function GetPaddingBottom: String;
    function GetPaddingLeft: String;
    function GetPaddingRight: String;
    function GetPaddingTop: String;
    function GetPageBreakAfter: String;
    function GetPageBreakBefore: String;
    function GetPageBreakInside: String;
    function GetPosBottom: Single;
    function GetPosHeight: Single;
    function GetPosition: String;
    function GetPosLeft: Single;
    function GetPosRight: Single;
    function GetPosTop: Single;
    function GetPosWidth: Single;
    function GetQuotes: String;
    function GetRight: String;
    function GetRubyAlign: String;
    function GetRubyOverhang: String;
    function GetRubyPosition: String;
    function GetScrollbar3dLightColor: TColor;
    function GetScrollbarArrowColor: TColor;
    function GetScrollbarBaseColor: TColor;
    function GetScrollbarDarkShadowColor: TColor;
    function GetScrollbarFaceColor: TColor;
    function GetScrollbarHighlightColor: TColor;
    function GetScrollbarShadowColor: TColor;
    function GetScrollbarTrackColor: TColor;
    function GetStyleFloat: String;
    function GetTableLayout: String;
    function GetTextAlign: String;
    function GetTextAlignLast: String;
    function GetTextAutospace: String;
    function GetTextDecoration: String;
    function GetTextDecorationBlink: Boolean;
    function GetTextDecorationLineThrough: Boolean;
    function GetTextDecorationNone: Boolean;
    function GetTextDecorationOverline: Boolean;
    function GetTextDecorationUnderline: Boolean;
    function GetTextIndent: String;
    function GetTextJustify: String;
    function GetTextJustifyTrim: String;
    function GetTextKashida: String;
    function GetTextKashidaSpace: String;
    function GetTextOverflow: String;
    function GetTextTransform: String;
    function GetTextUnderlinePosition: String;
    function GetTop: String;
    function GetUnicodeBiDi: String;
    function GetVerticalAlign: String;
    function GetVisibility: String;
    function GetWhiteSpace: String;
    function GetWidows: String;
    function GetWidth: String;
    function GetWordBreak: String;
    function GetWordSpacing: String;
    function GetWordWrap: String;
    function GetWritingMode: String;
    function GetZIndex: Integer;
    function GetZoom: String;
  public
    property Accelerator: String read GetAccelerator write SetAccelerator;
    property Background: String read GetBackground write SetBackground;
    property BackgroundAttachment: String read GetBackgroundAttachment write SetBackgroundAttachment;
    property BackgroundColor: TColor read GetBackgroundColor write SetBackgroundColor;
    property BackgroundImage: String read GetBackgroundImage write SetBackgroundImage;
    property BackgroundPosition: String read GetBackgroundPosition write SetBackgroundPosition;
    property BackgroundPositionX: String read GetBackgroundPositionX write SetBackgroundPositionX;
    property BackgroundPositionY: String read GetBackgroundPositionY write SetBackgroundPositionY;
    property BackgroundRepeat: String read GetBackgroundRepeat write SetBackgroundRepeat;
    property Behavior: String read GetBehavior write SetBehavior;
    property Border: String read GetBorder write SetBorder;
    property BorderBottom: String read GetBorderBottom write SetBorderBottom;
    property BorderBottomColor: TColor read GetBorderBottomColor write SetBorderBottomColor;
    property BorderBottomStyle: String read GetBorderBottomStyle write SetBorderBottomStyle;
    property BorderBottomWidth: String read GetBorderBottomWidth write SetBorderBottomWidth;
    property BorderCollapse: String read GetBorderCollapse write SetBorderCollapse;
    property BorderColor: TColor read GetBorderColor write SetBorderColor;
    property BorderLeft: String read GetBorderLeft write SetBorderLeft;
    property BorderLeftColor: TColor read GetBorderLeftColor write SetBorderLeftColor;
    property BorderLeftStyle: String read GetBorderLeftStyle write SetBorderLeftStyle;
    property BorderLeftWidth: String read GetBorderLeftWidth write SetBorderLeftWidth;
    property BorderRight: String read GetBorderRight write SetBorderRight;
    property BorderRightColor: TColor read GetBorderRightColor write SetBorderRightColor;
    property BorderRightStyle: String read GetBorderRightStyle write SetBorderRightStyle;
    property BorderRightWidth: String read GetBorderRightWidth write SetBorderRightWidth;
    property BorderSpacing: String read GetBorderSpacing write SetBorderSpacing;
    property BorderStyle: String read GetBorderStyle write SetBorderStyle;
    property BorderTop: String read GetBorderTop write SetBorderTop;
    property BorderTopColor: TColor read GetBorderTopColor write SetBorderTopColor;
    property BorderTopStyle: String read GetBorderTopStyle write SetBorderTopStyle;
    property BorderTopWidth: String read GetBorderTopWidth write SetBorderTopWidth;
    property BorderWidth: String read GetBorderWidth write SetBorderWidth;
    property Bottom: String read GetBottom write SetBottom;
    property BoxSizing: String read GetBoxSizing write SetBoxSizing;
    property CaptionSide: String read GetCaptionSide write SetCaptionSide;
    property Clear: String read GetClear write SetClear;
    property Clip: String read GetClip write SetClip;
    property Color: TColor read GetColor write SetColor;
    property Content: String read GetContent write SetContent;
    property CounterIncrement: String read GetCounterIncrement write SetCounterIncrement;
    property CounterReset: String read GetCounterReset write SetCounterReset;
    property CSSText: String read GetCSSText write SetCSSText;
    property Cursor: String read GetCursor write SetCursor;
    property Direction: String read GetDirection write SetDirection;
    property Display: String read GetDisplay write SetDisplay;
    property EmptyCells: String read GetEmptyCells write SetEmptyCells;
    property Filter: String read GetFilter write SetFilter;
    property Float: String read GetFloat write SetFloat;
    property Font: String read GetFont write SetFont;
    property FontFamily: String read GetFontFamily write SetFontFamily;
    property FontSize: String read GetFontSize write SetFontSize;
    property FontStyle: String read GetFontStyle write SetFontStyle;
    property FontVariant: String read GetFontVariant write SetFontVariant;
    property FontWeight: String read GetFontWeight write SetFontWeight;
    property Height: String read GetHeight write SetHeight;
    property ImeMode: String read GetImeMode write SetImeMode;
    property LayoutFlow: String read GetLayoutFlow write SetLayoutFlow;
    property LayoutGrid: String read GetLayoutGrid write SetLayoutGrid;
    property LayoutGridChar: String read GetLayoutGridChar write SetLayoutGridChar;
    property LayoutGridLine: String read GetLayoutGridLine write SetLayoutGridLine;
    property LayoutGridMode: String read GetLayoutGridMode write SetLayoutGridMode;
    property LayoutGridType: String read GetLayoutGridType write SetLayoutGridType;
    property Left: String read GetLeft write SetLeft;
    property LetterSpacing: String read GetLetterSpacing write SetLetterSpacing;
    property LineBreak: String read GetLineBreak write SetLineBreak;
    property LineHeight: String read GetLineHeight write SetLineHeight;
    property ListStyle: String read GetListStyle write SetListStyle;
    property ListStyleImage: String read GetListStyleImage write SetListStyleImage;
    property ListStylePosition: String read GetListStylePosition write SetListStylePosition;
    property ListStyleType: String read GetListStyleType write SetListStyleType;
    property Margin: String read GetMargin write SetMargin;
    property MarginBottom: String read GetMarginBottom write SetMarginBottom;
    property MarginLeft: String read GetMarginLeft write SetMarginLeft;
    property MarginRight: String read GetMarginRight write SetMarginRight;
    property MarginTop: String read GetMarginTop write SetMarginTop;
    property MaxHeight: String read GetMaxHeight write SetMaxHeight;
    property MaxWidth: String read GetMaxWidth write SetMaxWidth;
    property MinHeight: String read GetMinHeight write SetMinHeight;
    property MinWidth: String read GetMinWidth write SetMinWidth;
    property MsBlockProgression: String read GetMsBlockProgression write SetMsBlockProgression;
    property MsInterpolationMode: String read GetMsInterpolationMode write SetMsInterpolationMode;
    property Opacity: Double read GetOpacity write SetOpacity;
    property Orphans: String read GetOrphans write SetOrphans;
    property Outline: String read GetOutline write SetOutline;
    property OutlineColor: TColor read GetOutlineColor write SetOutlineColor;
    property OutlineStyle: String read GetOutlineStyle write SetOutlineStyle;
    property OutlineWidth: String read GetOutlineWidth write SetOutlineWidth;
    property Overflow: String read GetOverflow write SetOverflow;
    property OverflowX: String read GetOverflowX write SetOverflowX;
    property OverflowY: String read GetOverflowY write SetOverflowY;
    property Padding: String read GetPadding write SetPadding;
    property PaddingBottom: String read GetPaddingBottom write SetPaddingBottom;
    property PaddingLeft: String read GetPaddingLeft write SetPaddingLeft;
    property PaddingRight: String read GetPaddingRight write SetPaddingRight;
    property PaddingTop: String read GetPaddingTop write SetPaddingTop;
    property PageBreakAfter: String read GetPageBreakAfter write SetPageBreakAfter;
    property PageBreakBefore: String read GetPageBreakBefore write SetPageBreakBefore;
    property PageBreakInside: String read GetPageBreakInside write SetPageBreakInside;
    property PosBottom: Single read GetPosBottom write SetPosBottom;
    property PosHeight: Single read GetPosHeight write SetPosHeight;
    property Position: String read GetPosition write SetPosition;
    property PosLeft: Single read GetPosLeft write SetPosLeft;
    property PosRight: Single read GetPosRight write SetPosRight;
    property PosTop: Single read GetPosTop write SetPosTop;
    property PosWidth: Single read GetPosWidth write SetPosWidth;
    property Quotes: String read GetQuotes write SetQuotes;
    property Right: String read GetRight write SetRight;
    property RubyAlign: String read GetRubyAlign write SetRubyAlign;
    property RubyOverhang: String read GetRubyOverhang write SetRubyOverhang;
    property RubyPosition: String read GetRubyPosition write SetRubyPosition;
    property Scrollbar3dLightColor: TColor read GetScrollbar3dLightColor write SetScrollbar3dLightColor;
    property ScrollbarArrowColor: TColor read GetScrollbarArrowColor write SetScrollbarArrowColor;
    property ScrollbarBaseColor: TColor read GetScrollbarBaseColor write SetScrollbarBaseColor;
    property ScrollbarDarkShadowColor: TColor read GetScrollbarDarkShadowColor write SetScrollbarDarkShadowColor;
    property ScrollbarFaceColor: TColor read GetScrollbarFaceColor write SetScrollbarFaceColor;
    property ScrollbarHighlightColor: TColor read GetScrollbarHighlightColor write SetScrollbarHighlightColor;
    property ScrollbarShadowColor: TColor read GetScrollbarShadowColor write SetScrollbarShadowColor;
    property ScrollbarTrackColor: TColor read GetScrollbarTrackColor write SetScrollbarTrackColor;
    property StyleFloat: String read GetStyleFloat write SetStyleFloat;
    property TableLayout: String read GetTableLayout write SetTableLayout;
    property TextAlign: String read GetTextAlign write SetTextAlign;
    property TextAlignLast: String read GetTextAlignLast write SetTextAlignLast;
    property TextAutospace: String read GetTextAutospace write SetTextAutospace;
    property TextDecoration: String read GetTextDecoration write SetTextDecoration;
    property TextDecorationBlink: Boolean read GetTextDecorationBlink write SetTextDecorationBlink;
    property TextDecorationLineThrough: Boolean read GetTextDecorationLineThrough write SetTextDecorationLineThrough;
    property TextDecorationNone: Boolean read GetTextDecorationNone write SetTextDecorationNone;
    property TextDecorationOverline: Boolean read GetTextDecorationOverline write SetTextDecorationOverline;
    property TextDecorationUnderline: Boolean read GetTextDecorationUnderline write SetTextDecorationUnderline;
    property TextIndent: String read GetTextIndent write SetTextIndent;
    property TextJustify: String read GetTextJustify write SetTextJustify;
    property TextJustifyTrim: String read GetTextJustifyTrim write SetTextJustifyTrim;
    property TextKashida: String read GetTextKashida write SetTextKashida;
    property TextKashidaSpace: String read GetTextKashidaSpace write SetTextKashidaSpace;
    property TextOverflow: String read GetTextOverflow write SetTextOverflow;
    property TextTransform: String read GetTextTransform write SetTextTransform;
    property TextUnderlinePosition: String read GetTextUnderlinePosition write SetTextUnderlinePosition;
    property Top: String read GetTop write SetTop;
    property UnicodeBiDi: String read GetUnicodeBidi write SetUnicodeBidi;
    property VerticalAlign: String read GetVerticalAlign write SetVerticalAlign;
    property Visibility: String read GetVisibility write SetVisibility;
    property WhiteSpace: String read GetWhiteSpace write SetWhiteSpace;
    property Widows: String read GetWidows write SetWidows;
    property Width: String read GetWidth write SetWidth;
    property WordBreak: String read GetWordBreak write SetWordBreak;
    property WordSpacing: String read GetWordSpacing write SetWordSpacing;
    property WordWrap: String read GetWordWrap write SetWordWrap;
    property WritingMode: String read GetWritingMode write SetWritingMode;
    property ZIndex: Integer read GetZIndex write SetZIndex;
    property Zoom: String read GetZoom write SetZoom;
  end;

implementation

const
  PixelStr   = 'px';
  PercentStr = '%';

function HTMLToInt(Value, UnitStr: String; Default: Integer): Integer;
var
  Index: Integer;
begin
  Index:=Pos(UnitStr,Value);
  if Index>0
    then Value:=Copy(Value,1,Index-1);
  try
    Result:=StrToInt(Value);
  except
    Result:=Default;
  end;
end;

function IntToHTML(Value: Integer; UnitStr: String): String;
begin
  Result:=IntToStr(Value)+UnitStr;
end;

//------------------------------------------------------------------------------
//TDocument

destructor TDocument.Destroy;
begin
  FBody.Free;
  FHead.Free;
  inherited;
end;

function TDocument.GetBody: TNode;
begin
  Result:=TNode(GetPropAsObject(DocumentProp_Body,TNode,FBody));
end;

function TDocument.GetHead: TNode;
var
  Elements, Head: OleVariant;
begin
  Result:=nil;
  Elements:=Exec(DocumentMethod_GetElementsByTagName,['head']); //liefert ein Array
  if VarIsValidDispatch(Elements) then
  begin
    Head:=BrowserTools.GetProp(Elements,'0',false);             //erstes Element des Arrays
    if VarIsValidDispatch(Head) then
    begin
      if assigned(FHead)
        then FHead.Disp:=Head
        else FHead:=TNode.Create(Head);
      Result:=FHead;
    end;
  end;
end;

function TDocument.NewElement(ElementType: String): IDispatch;
begin
  Result:=Exec(DocumentMethod_CreateElement,[ElementType]);
end;

function TDocument.CreateDocumentFragment: TNode;
begin
  Result:=TNode.Create(Exec(DocumentMethod_CreateDocumentFragment));
end;

function TDocument.CreateElement(ElementType: String): TNode;
begin
  Result:=TNode.Create(NewElement(ElementType));
end;

function TDocument.CreateDivNode: TDivNode;
begin
  Result:=TDivNode.Create(NewElement('div'));
end;

function TDocument.CreateScriptNode: TScriptNode;
begin
  Result:=TScriptNode.Create(NewElement('script'));
end;

function TDocument.CreateTextNode(Text: String): TTextNode;
begin
  Result:=TTextNode.Create(Exec(DocumentMethod_CreateTextNode,[Text]));
end;

function TDocument.GetElementByID(ID: String): TNode;
var
  Element: OleVariant;
begin
  Result:=nil;
  Element:=Exec(DocumentMethod_GetElementByID,[ID]);
  if VarIsValidDispatch(Element)
    then Result:=TNode.Create(Element);
end;

//------------------------------------------------------------------------------
//TDOMNode

destructor TDOMNode.Destroy;
begin
  FAttributes.Free;
  FChildNodes.Free;
  FFirstChild.Free;
  FLastChild.Free;
  FNextSibling.Free;
  FOwnerDocument.Free;
  FParentNode.Free;
  FRemoveChild.Free;
  FPreviousSibling.Free;
  inherited;
end;

function TDOMNode.AppendChild(NewChild: TDOMNode): TDOMNode;
begin
  Exec(DOMNodeMethod_AppendChild,NewChild);
  Result:=NewChild;
end;

function TDOMNode.CloneNode(Deep: Boolean): TDOMNode;
begin
  Result:=TDOMNode.Create(Exec(DOMNodeMethod_CloneNode,[Deep]));
end;

function TDOMNode.HasChildNodes: Boolean;
begin
  Result:=VarAsBoolean(Exec(DOMNodeMethod_HasChildNodes));
end;

function TDOMNode.InsertBefore(NewChild, RefChild: TDOMNode): TDOMNode;
var
  NewChildVar, RefChildVar: OleVariant;
begin
  if assigned(NewChild)
    then NewChildVar:=NewChild.Disp
    else NewChildVar:=Null;
  if assigned(RefChild)
    then RefChildVar:=RefChild.Disp
    else RefChildVar:=Null;
  Exec(DOMNodeMethod_InsertBefore,[NewChildVar,RefChildVar]);
  Result:=NewChild;
end;

function TDOMNode.RemoveChild(ChildNode: TDOMNode): TDOMNode;
var
  RemoveChild: OleVariant;
begin
  Result:=nil;
  RemoveChild:=Exec(DOMNodeMethod_RemoveChild,ChildNode);
  if VarIsValidDispatch(RemoveChild) then
  begin
    if assigned(FRemoveChild)
      then FRemoveChild.Disp:=RemoveChild
      else FRemoveChild:=TDOMNode.Create(RemoveChild);
    Result:=FRemoveChild;
  end;
end;

function TDOMNode.ReplaceChild(NewChild, OldChild: TDOMNode): TDOMNode;
var
  NewChildVar, OldChildVar: OleVariant;
begin
  if assigned(NewChild)
    then NewChildVar:=NewChild.Disp
    else NewChildVar:=Null;
  if assigned(OldChild)
    then OldChildVar:=OldChild.Disp
    else OldChildVar:=Null;
  Exec(DOMNodeMethod_ReplaceChild,[NewChildVar,OldChildVar]);
  Result:=OldChild;
end;

function TDOMNode.GetAttributes: TDOMNode;
begin
  Result:=TDOMNode(GetPropAsObject(DOMNodeProp_Attributes,TDOMNode,FAttributes));
end;

function TDOMNode.GetChildNodes: TDOMNode;
begin
  Result:=TDOMNode(GetPropAsObject(DOMNodeProp_ChildNodes,TDOMNode,FChildNodes));
end;

function TDOMNode.GetFirstChild: TDOMNode;
begin
  Result:=TDOMNode(GetPropAsObject(DOMNodeProp_FirstChild,TDOMNode,FFirstChild));
end;

function TDOMNode.GetLastChild: TDOMNode;
begin
  Result:=TDOMNode(GetPropAsObject(DOMNodeProp_LastChild,TDOMNode,FLastChild));
end;

function TDOMNode.GetNextSibling: TDOMNode;
begin
  Result:=TDOMNode(GetPropAsObject(DOMNodeProp_NextSibling,TDOMNode,FNextSibling));
end;

function TDOMNode.GetNodeName: String;
begin
  Result:=GetPropAsString(DOMNodeProp_NodeName);
end;

function TDOMNode.GetNodeType: Integer;
begin
  Result:=GetPropAsInteger(DOMNodeProp_NodeType);
end;

function TDOMNode.GetNodeValue: String;
begin
  Result:=GetPropAsString(DOMNodeProp_NodeValue);
end;

procedure TDOMNode.SetNodeValue(Value: String);
begin
  SetProp(DOMNodeProp_NodeValue,Value);
end;

function TDOMNode.GetOwnerDocument: TDocument;
begin
  Result:=TDocument(GetPropAsObject(DOMNodeProp_OwnerDocument,TDocument,FOwnerDocument));
end;

function TDOMNode.GetParentNode: TDOMNode;
begin
  Result:=TDOMNode(GetPropAsObject(DOMNodeProp_ParentNode,TDOMNode,FParentNode));
end;

function TDOMNode.GetPreviousSibling: TDOMNode;
begin
  Result:=TDOMNode(GetPropAsObject(DOMNodeProp_PreviousSibling,TDOMNode,FPreviousSibling));
end;

//------------------------------------------------------------------------------
//TEvent

function TEvent.GetAltKey: Boolean;
begin
  Result:=GetPropAsBoolean(EventProp_AltKey);
end;

function TEvent.GetButton: Integer;
begin
  Result:=GetPropAsInteger(EventProp_Button);
end;

function TEvent.GetClientX: Integer;
begin
  Result:=GetPropAsInteger(EventProp_ClientX);
end;

function TEvent.GetClientY: Integer;
begin
  Result:=GetPropAsInteger(EventProp_ClientY);
end;

function TEvent.GetCtrlKey: Boolean;
begin
  Result:=GetPropAsBoolean(EventProp_CtrlKey);
end;

function TEvent.GetKeyCode: Integer;
begin
  Result:=GetPropAsInteger(EventProp_KeyCode);
end;

function TEvent.GetOffsetX: Integer;
begin
  Result:=GetPropAsInteger(EventProp_OffsetX);
end;

function TEvent.GetOffsetY: Integer;
begin
  Result:=GetPropAsInteger(EventProp_OffsetY);
end;

function TEvent.GetShiftKey: Boolean;
begin
  Result:=GetPropAsBoolean(EventProp_ShiftKey);
end;

function TEvent.GetX: Integer;
begin
  Result:=GetPropAsInteger(EventProp_X);
end;

function TEvent.GetY: Integer;
begin
  Result:=GetPropAsInteger(EventProp_Y);
end;

//------------------------------------------------------------------------------
//TNavigator

destructor TNavigator.Destroy;
begin
  FGeolocation.Free;
  inherited;
end;

function TNavigator.GetAppCodeName: String;
begin
  Result:=GetProp(NavigatorProp_AppCodeName);
end;

procedure TNavigator.SetAppCodeName(Value: String);
begin
  SetProp(NavigatorProp_AppCodeName,Value);
end;

function TNavigator.GetAppMinorVersion: String;
begin
  Result:=GetProp(NavigatorProp_AppMinorVersion);
end;

procedure TNavigator.SetAppMinorVersion(Value: String);
begin
  SetProp(NavigatorProp_AppMinorVersion,Value);
end;

function TNavigator.GetAppName: String;
begin
  Result:=GetProp(NavigatorProp_AppName);
end;

procedure TNavigator.SetAppName(Value: String);
begin
  SetProp(NavigatorProp_AppName,Value);
end;

function TNavigator.GetAppVersion: String;
begin
  Result:=GetProp(NavigatorProp_AppVersion);
end;

procedure TNavigator.SetAppVersion(Value: String);
begin
  SetProp(NavigatorProp_AppVersion,Value);
end;

function TNavigator.GetCookieEnabled: Boolean;
begin
  Result:=GetProp(NavigatorProp_CookieEnabled);
end;

procedure TNavigator.SetCookieEnabled(Value: Boolean);
begin
  SetProp(NavigatorProp_CookieEnabled,Value);
end;

function TNavigator.GetCPUClass: String;
begin
  Result:=GetProp(NavigatorProp_CPUClass);
end;

procedure TNavigator.SetCPUClass(Value: String);
begin
  SetProp(NavigatorProp_CPUClass,Value);
end;

function TNavigator.GetGeolocation: TGeolocation;
begin
  Result:=nil;
  //ToDo: Result:=TGeolocation(GetPropAsObject(NavigatorProp_Geolocation,TGeolocation,FGeolocation));
end;

function TNavigator.GetMimeTypes: IDispatch{Ex};
begin
  Result:=GetProp(NavigatorProp_MimeTypes);
end;

procedure TNavigator.SetMimeTypes(Value: IDispatch{Ex});
begin
  SetProp(NavigatorProp_MimeTypes,Value);
end;

function TNavigator.GetOnLine: Boolean;
begin
  Result:=GetProp(NavigatorProp_OnLine);
end;

procedure TNavigator.SetOnLine(Value: Boolean);
begin
  SetProp(NavigatorProp_OnLine,Value);
end;

function TNavigator.GetOpsProfile: IDispatch;
begin
  Result:=GetProp(NavigatorProp_OpsProfile);
end;

procedure TNavigator.SetOpsProfile(Value: IDispatch);
begin
  SetProp(NavigatorProp_OpsProfile,Value);
end;

function TNavigator.GetPlatform: String;
begin
  Result:=GetProp(NavigatorProp_Platform);
end;

procedure TNavigator.SetPlatform(Value: String);
begin
  SetProp(NavigatorProp_Platform,Value);
end;

function TNavigator.GetPlugins: IDispatch{Ex};
begin
  Result:=GetProp(NavigatorProp_Plugins);
end;

procedure TNavigator.SetPlugins(Value: IDispatch{Ex});
begin
  SetProp(NavigatorProp_Plugins,Value);
end;

function TNavigator.GetSystemLanguage: String;
begin
  Result:=GetProp(NavigatorProp_SystemLanguage);
end;

procedure TNavigator.SetSystemLanguage(Value: String);
begin
  SetProp(NavigatorProp_SystemLanguage,Value);
end;

function TNavigator.GetUserAgent: String;
begin
  Result:=GetProp(NavigatorProp_UserAgent);
end;

procedure TNavigator.SetUserAgent(Value: String);
begin
  SetProp(NavigatorProp_UserAgent,Value);
end;

function TNavigator.GetUserLanguage: String;
begin
  Result:=GetProp(NavigatorProp_UserLanguage);
end;

procedure TNavigator.SetUserLanguage(Value: String);
begin
  SetProp(NavigatorProp_UserLanguage,Value);
end;

function TNavigator.GetUserProfile: IDispatch;
begin
  Result:=GetProp(NavigatorProp_UserProfile);
end;

procedure TNavigator.SetUserProfile(Value: IDispatch);
begin
  SetProp(NavigatorProp_UserProfile,Value);
end;

//------------------------------------------------------------------------------
//TNode

destructor TNode.Destroy;
begin
  FStyle.Free;
  inherited;
end;

function TNode.GetAccessKey: String;
begin
  Result:=GetProp('accessKey');
end;

procedure TNode.SetAccessKey(Value: String);
begin
  SetProp('accessKey',Value);
end;

procedure TNode.SetAlign(Value: TAlign);
begin
  if FAlign<>Value then
  begin
    FAlign:=Value;
    case FAlign of
      alNone{$IFDEF DELPHI6_UP}, alCustom{$ENDIF}:
      begin
        Style.Left:=IntToHTML(FLeft,PixelStr);
        Style.Top:=IntToHTML(FTop,PixelStr);
        Style.Width:=IntToHTML(FWidth,PixelStr);
        Style.Height:=IntToHTML(FHeight,PixelStr);
      end;
      alTop:
      begin
        Style.Left:=IntToHTML(0,PixelStr);
        Style.Top:=IntToHTML(0,PixelStr);
        Style.Width:=IntToHTML(100,PercentStr);
        Style.Height:=IntToHTML(FHeight,PixelStr);
      end;
      alBottom:
      begin
        Style.Left:=IntToHTML(0,PixelStr);
        Style.Bottom:=IntToHTML(0,PixelStr);
        Style.Top:='';
        Style.Width:=IntToHTML(100,PercentStr);
        Style.Height:=IntToHTML(FHeight,PixelStr);
      end;
      alLeft:
      begin
        Style.Left:=IntToHTML(0,PixelStr);
        Style.Top:=IntToHTML(0,PixelStr);
        Style.Width:=IntToHTML(FWidth,PixelStr);
        Style.Height:=IntToHTML(100,PercentStr);
      end;
      alRight:
      begin
        Style.Left:='';
        Style.Right:=IntToHTML(0,PixelStr);
        Style.Top:=IntToHTML(0,PixelStr);
        Style.Width:=IntToHTML(FWidth,PixelStr);
        Style.Height:=IntToHTML(100,PercentStr);
      end;
      alClient:
      begin
        Style.Left:=IntToHTML(0,PixelStr);
        Style.Top:=IntToHTML(0,PixelStr);
        Style.Width:=IntToHTML(100,PercentStr);
        Style.Height:=IntToHTML(100,PercentStr);
      end;
    end;
  end;
end;

function TNode.GetAll: IDispatch;
begin
  Result:=GetProp('all');
end;

procedure TNode.SetAll(Value: IDispatch);
begin
  SetProp('all',Value);
end;

function TNode.GetAria_activedescendant: String;
begin
  Result:=GetProp('aria-activedescendant');
end;

procedure TNode.SetAria_activedescendant(Value: String);
begin
  SetProp('aria-activedescendant',Value);
end;

function TNode.GetAria_busy: String;
begin
  Result:=GetProp('aria-busy');
end;

procedure TNode.SetAria_busy(Value: String);
begin
  SetProp('aria-busy',Value);
end;

function TNode.GetAria_checked: String;
begin
  Result:=GetProp('aria-checked');
end;

procedure TNode.SetAria_checked(Value: String);
begin
  SetProp('aria-checked',Value);
end;

function TNode.GetAria_controls: String;
begin
  Result:=GetProp('aria-controls');
end;

procedure TNode.SetAria_controls(Value: String);
begin
  SetProp('aria-controls',Value);
end;

function TNode.GetAria_describedby: String;
begin
  Result:=GetProp('aria-describedby');
end;

procedure TNode.SetAria_describedby(Value: String);
begin
  SetProp('aria-describedby',Value);
end;

function TNode.GetAria_disabled: String;
begin
  Result:=GetProp('aria-disabled');
end;

procedure TNode.SetAria_disabled(Value: String);
begin
  SetProp('aria-disabled',Value);
end;

function TNode.GetAria_expanded: String;
begin
  Result:=GetProp('aria-expanded');
end;

procedure TNode.SetAria_expanded(Value: String);
begin
  SetProp('aria-expanded',Value);
end;

function TNode.GetAria_flowto: String;
begin
  Result:=GetProp('aria-flowto');
end;

procedure TNode.SetAria_flowto(Value: String);
begin
  SetProp('aria-flowto',Value);
end;

function TNode.GetAria_haspopup: String;
begin
  Result:=GetProp('aria-haspopup');
end;

procedure TNode.SetAria_haspopup(Value: String);
begin
  SetProp('aria-haspopup',Value);
end;

function TNode.GetAria_hidden: String;
begin
  Result:=GetProp('aria-hidden');
end;

procedure TNode.SetAria_hidden(Value: String);
begin
  SetProp('aria-hidden',Value);
end;

function TNode.GetAria_invalid: String;
begin
  Result:=GetProp('aria-invalid');
end;

procedure TNode.SetAria_invalid(Value: String);
begin
  SetProp('aria-invalid',Value);
end;

function TNode.GetAria_labelledby: String;
begin
  Result:=GetProp('aria-labelledby');
end;

procedure TNode.SetAria_labelledby(Value: String);
begin
  SetProp('aria-labelledby',Value);
end;

function TNode.GetAria_level: SmallInt;
begin
  Result:=GetProp('aria-level');
end;

procedure TNode.SetAria_level(Value: SmallInt);
begin
  SetProp('aria-level',Value);
end;

function TNode.GetAria_live: String;
begin
  Result:=GetProp('aria-live');
end;

procedure TNode.SetAria_live(Value: String);
begin
  SetProp('aria-live',Value);
end;

function TNode.GetAria_multiselectable: String;
begin
  Result:=GetProp('aria-multiselectable');
end;

procedure TNode.SetAria_multiselectable(Value: String);
begin
  SetProp('aria-multiselectable',Value);
end;

function TNode.GetAria_owns: String;
begin
  Result:=GetProp('aria-owns');
end;

procedure TNode.SetAria_owns(Value: String);
begin
  SetProp('aria-owns',Value);
end;

function TNode.GetAria_posinset: SmallInt;
begin
  Result:=GetProp('aria-posinset');
end;

procedure TNode.SetAria_posinset(Value: SmallInt);
begin
  SetProp('aria-posinset',Value);
end;

function TNode.GetAria_pressed: String;
begin
  Result:=GetProp('aria-pressed');
end;

procedure TNode.SetAria_pressed(Value: String);
begin
  SetProp('aria-pressed',Value);
end;

function TNode.GetAria_readonly: String;
begin
  Result:=GetProp('aria-readonly');
end;

procedure TNode.SetAria_readonly(Value: String);
begin
  SetProp('aria-readonly',Value);
end;

function TNode.GetAria_relevant: String;
begin
  Result:=GetProp('aria-relevant');
end;

procedure TNode.SetAria_relevant(Value: String);
begin
  SetProp('aria-relevant',Value);
end;

function TNode.GetAria_required: String;
begin
  Result:=GetProp('aria-required');
end;

procedure TNode.SetAria_required(Value: String);
begin
  SetProp('aria-required',Value);
end;

function TNode.GetAria_secret: String;
begin
  Result:=GetProp('aria-secret');
end;

procedure TNode.SetAria_secret(Value: String);
begin
  SetProp('aria-secret',Value);
end;

function TNode.GetAria_selected: String;
begin
  Result:=GetProp('aria-selected');
end;

procedure TNode.SetAria_selected(Value: String);
begin
  SetProp('aria-selected',Value);
end;

function TNode.GetAria_setsize: SmallInt;
begin
  Result:=GetProp('aria-setsize');
end;

procedure TNode.SetAria_setsize(Value: SmallInt);
begin
  SetProp('aria-setsize',Value);
end;

function TNode.GetAria_valuemax: String;
begin
  Result:=GetProp('aria-valuemax');
end;

procedure TNode.SetAria_valuemax(Value: String);
begin
  SetProp('aria-valuemax',Value);
end;

function TNode.GetAria_valuemin: String;
begin
  Result:=GetProp('aria-valuemin');
end;

procedure TNode.SetAria_valuemin(Value: String);
begin
  SetProp('aria-valuemin',Value);
end;

function TNode.GetAria_valuenow: String;
begin
  Result:=GetProp('aria-valuenow');
end;

procedure TNode.SetAria_valuenow(Value: String);
begin
  SetProp('aria-valuenow',Value);
end;

function TNode.GetAttributes: IDispatch;
begin
  Result:=GetProp('attributes');
end;

procedure TNode.SetAttributes(Value: IDispatch);
begin
  SetProp('attributes',Value);
end;

function TNode.GetBehaviorUrns: IDispatch;
begin
  Result:=GetProp('behaviorUrns');
end;

procedure TNode.SetBehaviorUrns(Value: IDispatch);
begin
  SetProp('behaviorUrns',Value);
end;

function TNode.GetCanHaveChildren: Boolean;
begin
  Result:=GetProp('canHaveChildren');
end;

procedure TNode.SetCanHaveChildren(Value: Boolean);
begin
  SetProp('canHaveChildren',Value);
end;

function TNode.GetCanHaveHTML: Boolean;
begin
  Result:=GetProp('canHaveHTML');
end;

procedure TNode.SetCanHaveHTML(Value: Boolean);
begin
  SetProp('canHaveHTML',Value);
end;

function TNode.GetChildNodes: IDispatch;
begin
  Result:=GetProp('childNodes');
end;

procedure TNode.SetChildNodes(Value: IDispatch);
begin
  SetProp('childNodes',Value);
end;

function TNode.GetChildren: IDispatch;
begin
  Result:=GetProp('children');
end;

procedure TNode.SetChildren(Value: IDispatch);
begin
  SetProp('children',Value);
end;

function TNode.GetClassName: String;
begin
  Result:=GetProp('className');
end;

procedure TNode.SetClassName(Value: String);
begin
  SetProp('className',Value);
end;

function TNode.GetClientHeight: Integer;
begin
  Result:=GetProp('clientHeight');
end;

procedure TNode.SetClientHeight(Value: Integer);
begin
  SetProp('clientHeight',Value);
end;

function TNode.GetClientLeft: Integer;
begin
  Result:=GetProp('clientLeft');
end;

procedure TNode.SetClientLeft(Value: Integer);
begin
  SetProp('clientLeft',Value);
end;

function TNode.GetClientTop: Integer;
begin
  Result:=GetProp('clientTop');
end;

procedure TNode.SetClientTop(Value: Integer);
begin
  SetProp('clientTop',Value);
end;

function TNode.GetClientWidth: Integer;
begin
  Result:=GetProp('clientWidth');
end;

procedure TNode.SetClientWidth(Value: Integer);
begin
  SetProp('clientWidth',Value);
end;

function TNode.GetContentEditable: String;
begin
  Result:=GetProp('contentEditable');
end;

procedure TNode.SetContentEditable(Value: String);
begin
  SetProp('contentEditable',Value);
end;

function TNode.GetCurrentStyle: IDispatch;
begin
  Result:=GetProp('currentStyle');
end;

procedure TNode.SetCurrentStyle(Value: IDispatch);
begin
  SetProp('currentStyle',Value);
end;

function TNode.GetDataFld: String;
begin
  Result:=GetProp('dataFld');
end;

procedure TNode.SetDataFld(Value: String);
begin
  SetProp('dataFld',Value);
end;

function TNode.GetDataFormatAs: String;
begin
  Result:=GetProp('dataFormatAs');
end;

procedure TNode.SetDataFormatAs(Value: String);
begin
  SetProp('dataFormatAs',Value);
end;

function TNode.GetDataSrc: String;
begin
  Result:=GetProp('dataSrc');
end;

procedure TNode.SetDataSrc(Value: String);
begin
  SetProp('dataSrc',Value);
end;

function TNode.GetDir: String;
begin
  Result:=GetProp('dir');
end;

procedure TNode.SetDir(Value: String);
begin
  SetProp('dir',Value);
end;

function TNode.GetDisabled: Boolean;
begin
  Result:=GetProp('disabled');
end;

procedure TNode.SetDisabled(Value: Boolean);
begin
  SetProp('disabled',Value);
end;

function TNode.GetDocument: IDispatch;
begin
  Result:=GetProp('document');
end;

procedure TNode.SetDocument(Value: IDispatch);
begin
  SetProp('document',Value);
end;

function TNode.GetFilters: IDispatch;
begin
  Result:=GetProp('filters');
end;

procedure TNode.SetFilters(Value: IDispatch);
begin
  SetProp('filters',Value);
end;
{
function TNode.GetFirstChild: IDispatch;
begin
  Result:=GetProp('firstChild');
end;

procedure TNode.SetFirstChild(Value: IDispatch);
begin
  SetProp('firstChild',Value);
end;
}
function TNode.GetHeight: Integer;
begin
  case FAlign of
    alNone, alTop, alBottom{$IFDEF DELPHI6_UP}, alCustom{$ENDIF}:
    begin
      FHeight:=HTMLToInt(Style.Height,PixelStr,FHeight);
      Result:=FHeight;
    end;
    alLeft, alRight, alClient:
      Result:=ClientWidth; //PixelWidth;  Script.DocHostUIHandler.Browser.ClientHeight;
    else Result:=FHeight;
  end;
end;

procedure TNode.SetHeight(Value: Integer);
begin
  if FHeight<>Value then
  begin
    FHeight:=Value;
    case FAlign of
      alNone, alTop, alBottom{$IFDEF DELPHI6_UP}, alCustom{$ENDIF}:
        Style.Height:=IntToHTML(FHeight,PixelStr);
    end;
  end;
end;

function TNode.GetHideFocus: Boolean;
begin
  Result:=GetProp('hideFocus');
end;

procedure TNode.SetHideFocus(Value: Boolean);
begin
  SetProp('hideFocus',Value);
end;

function TNode.GetID: String;
begin
  Result:=GetProp('id');
end;

procedure TNode.SetID(Value: String);
begin
  SetProp('id',Value);
end;

function TNode.GetInnerHTML: String;
begin
  Result:=GetProp('innerHTML');
end;

procedure TNode.SetInnerHTML(Value: String);
begin
  SetProp('innerHTML',Value);
end;

function TNode.GetInnerText: String;
begin
  Result:=GetProp('innerText');
end;

procedure TNode.SetInnerText(Value: String);
begin
  SetProp('innerText',Value);
end;

function TNode.GetIsContentEditable: Boolean;
begin
  Result:=GetProp('isContentEditable');
end;

procedure TNode.SetIsContentEditable(Value: Boolean);
begin
  SetProp('isContentEditable',Value);
end;

function TNode.GetIsDisabled: Boolean;
begin
  Result:=GetProp('isDisabled');
end;

procedure TNode.SetIsDisabled(Value: Boolean);
begin
  SetProp('isDisabled',Value);
end;

function TNode.GetIsMultiLine: Boolean;
begin
  Result:=GetProp('isMultiLine');
end;

procedure TNode.SetIsMultiLine(Value: Boolean);
begin
  SetProp('isMultiLine',Value);
end;

function TNode.GetIsTextEdit: Boolean;
begin
  Result:=GetProp('isTextEdit');
end;

procedure TNode.SetIsTextEdit(Value: Boolean);
begin
  SetProp('isTextEdit',Value);
end;

function TNode.GetLang: String;
begin
  Result:=GetProp('lang');
end;

procedure TNode.SetLang(Value: String);
begin
  SetProp('lang',Value);
end;

function TNode.GetLanguage: String;
begin
  Result:=GetProp('language');
end;

procedure TNode.SetLanguage(Value: String);
begin
  SetProp('language',Value);
end;

function TNode.GetLastChild: IDispatch;
begin
  Result:=GetProp('lastChild');
end;

procedure TNode.SetLastChild(Value: IDispatch);
begin
  SetProp('lastChild',Value);
end;

function TNode.GetLeft: Integer;
begin
  case FAlign of
    alNone{$IFDEF DELPHI6_UP}, alCustom{$ENDIF}:
    begin
      FLeft:=HTMLToInt(Style.Left,PixelStr,FLeft);
      Result:=FLeft;
    end;
    alLeft, alTop, alBottom, alClient:
      Result:=0;
    alRight:
//      Result:=Script.DocHostUIHandler.Browser.ClientWidth-
//              HTMLToInt(FNode.Style.Width,PixelStr,FWidth);
      Result:=ClientLeft;
    else Result:=FLeft;
  end;
end;

procedure TNode.SetLeft(Value: Integer);
begin
  if FLeft<>Value then
  begin
    FLeft:=Value;
    case FAlign of
      alNone{$IFDEF DELPHI6_UP}, alCustom{$ENDIF}:
        Style.Left:=IntToHTML(FLeft,PixelStr);
    end;
  end;
end;

function TNode.GetNextSibling: IDispatch;
begin
  Result:=GetProp('nextSibling');
end;

procedure TNode.SetNextSibling(Value: IDispatch);
begin
  SetProp('nextSibling',Value);
end;

function TNode.GetNodeName: String;
begin
  Result:=GetProp('nodeName');
end;

procedure TNode.SetNodeName(Value: String);
begin
  SetProp('nodeName',Value);
end;

function TNode.GetNodeType: Integer;
begin
  Result:=GetProp('nodeType');
end;

procedure TNode.SetNodeType(Value: Integer);
begin
  SetProp('nodeType',Value);
end;

function TNode.GetNodeValue: IDispatch;
begin
  Result:=nil; //GetProp('nodeValue');
end;

procedure TNode.SetNodeValue(Value: IDispatch);
begin
  SetProp('nodeValue',Value);
end;

function TNode.GetNoWrap: Boolean;
begin
  Result:=GetProp('noWrap');
end;

procedure TNode.SetNoWrap(Value: Boolean);
begin
  SetProp('noWrap',Value);
end;

function TNode.GetOffsetHeight: Integer;
begin
  Result:=GetProp('offsetHeight');
end;

procedure TNode.SetOffsetHeight(Value: Integer);
begin
  SetProp('offsetHeight',Value);
end;

function TNode.GetOffsetLeft: Integer;
begin
  Result:=GetProp('offsetLeft');
end;

procedure TNode.SetOffsetLeft(Value: Integer);
begin
  SetProp('offsetLeft',Value);
end;

function TNode.GetOffsetParent: IDispatch;
begin
  Result:=GetProp('offsetParent');
end;

procedure TNode.SetOffsetParent(Value: IDispatch);
begin
  SetProp('offsetParent',Value);
end;

function TNode.GetOffsetTop: Integer;
begin
  Result:=GetProp('offsetTop');
end;

procedure TNode.SetOffsetTop(Value: Integer);
begin
  SetProp('offsetTop',Value);
end;

function TNode.GetOffsetWidth: Integer;
begin
  Result:=GetProp('offsetWidth');
end;

procedure TNode.SetOffsetWidth(Value: Integer);
begin
  SetProp('offsetWidth',Value);
end;

function TNode.GetOnactivate: IDispatch;
begin
  Result:=nil; //GetProp('onactivate');
end;

procedure TNode.SetOnactivate(Value: IDispatch);
begin
  SetProp('onactivate',Value);
end;

function TNode.GetOnafterupdate: IDispatch;
begin
  Result:=nil; //GetProp('onafterupdate');
end;

procedure TNode.SetOnafterupdate(Value: IDispatch);
begin
  SetProp('onafterupdate',Value);
end;

function TNode.GetOnbeforeactivate: IDispatch;
begin
  Result:=nil; //GetProp('onbeforeactivate');
end;

procedure TNode.SetOnbeforeactivate(Value: IDispatch);
begin
  SetProp('onbeforeactivate',Value);
end;

function TNode.GetOnbeforecopy: IDispatch;
begin
  Result:=nil; //GetProp('onbeforecopy');
end;

procedure TNode.SetOnbeforecopy(Value: IDispatch);
begin
  SetProp('onbeforecopy',Value);
end;

function TNode.GetOnbeforecut: IDispatch;
begin
  Result:=nil; //GetProp('onbeforecut');
end;

procedure TNode.SetOnbeforecut(Value: IDispatch);
begin
  SetProp('onbeforecut',Value);
end;

function TNode.GetOnbeforedeactivate: IDispatch;
begin
  Result:=nil; //GetProp('onbeforedeactivate');
end;

procedure TNode.SetOnbeforedeactivate(Value: IDispatch);
begin
  SetProp('onbeforedeactivate',Value);
end;

function TNode.GetOnbeforeeditfocus: IDispatch;
begin
  Result:=nil; //GetProp('onbeforeeditfocus');
end;

procedure TNode.SetOnbeforeeditfocus(Value: IDispatch);
begin
  SetProp('onbeforeeditfocus',Value);
end;

function TNode.GetOnbeforepaste: IDispatch;
begin
  Result:=nil; //GetProp('onbeforepaste');
end;

procedure TNode.SetOnbeforepaste(Value: IDispatch);
begin
  SetProp('onbeforepaste',Value);
end;

function TNode.GetOnbeforeupdate: IDispatch;
begin
  Result:=nil; //GetProp('onbeforeupdate');
end;

procedure TNode.SetOnbeforeupdate(Value: IDispatch);
begin
  SetProp('onbeforeupdate',Value);
end;

function TNode.GetOnblur: IDispatch;
begin
  Result:=nil; //GetProp('onblur');
end;

procedure TNode.SetOnblur(Value: IDispatch);
begin
  SetProp('onblur',Value);
end;

function TNode.GetOncellchange: IDispatch;
begin
  Result:=nil; //GetProp('oncellchange');
end;

procedure TNode.SetOncellchange(Value: IDispatch);
begin
  SetProp('oncellchange',Value);
end;

function TNode.GetOnclick: IDispatch;
begin
  Result:=nil; //GetProp('onclick');
end;

procedure TNode.SetOnclick(Value: IDispatch);
begin
  SetProp('onclick',Value);
end;

function TNode.GetOncontextmenu: IDispatch;
begin
  Result:=nil; //GetProp('oncontextmenu');
end;

procedure TNode.SetOncontextmenu(Value: IDispatch);
begin
  SetProp('oncontextmenu',Value);
end;

function TNode.GetOncontrolselect: IDispatch;
begin
  Result:=nil; //GetProp('oncontrolselect');
end;

procedure TNode.SetOncontrolselect(Value: IDispatch);
begin
  SetProp('oncontrolselect',Value);
end;

function TNode.GetOncopy: IDispatch;
begin
  Result:=nil; //GetProp('oncopy');
end;

procedure TNode.SetOncopy(Value: IDispatch);
begin
  SetProp('oncopy',Value);
end;

function TNode.GetOncut: IDispatch;
begin
  Result:=nil; //GetProp('oncut');
end;

procedure TNode.SetOncut(Value: IDispatch);
begin
  SetProp('oncut',Value);
end;

function TNode.GetOndataavailable: IDispatch;
begin
  Result:=nil; //GetProp('ondataavailable');
end;

procedure TNode.SetOndataavailable(Value: IDispatch);
begin
  SetProp('ondataavailable',Value);
end;

function TNode.GetOndatasetchanged: IDispatch;
begin
  Result:=nil; //GetProp('ondatasetchanged');
end;

procedure TNode.SetOndatasetchanged(Value: IDispatch);
begin
  SetProp('ondatasetchanged',Value);
end;

function TNode.GetOndatasetcomplete: IDispatch;
begin
  Result:=nil; //GetProp('ondatasetcomplete');
end;

procedure TNode.SetOndatasetcomplete(Value: IDispatch);
begin
  SetProp('ondatasetcomplete',Value);
end;

function TNode.GetOndblclick: IDispatch;
begin
  Result:=nil; //GetProp('ondblclick');
end;

procedure TNode.SetOndblclick(Value: IDispatch);
begin
  SetProp('ondblclick',Value);
end;

function TNode.GetOndeactivate: IDispatch;
begin
  Result:=nil; //GetProp('ondeactivate');
end;

procedure TNode.SetOndeactivate(Value: IDispatch);
begin
  SetProp('ondeactivate',Value);
end;

function TNode.GetOndrag: IDispatch;
begin
  Result:=nil; //GetProp('ondrag');
end;

procedure TNode.SetOndrag(Value: IDispatch);
begin
  SetProp('ondrag',Value);
end;

function TNode.GetOndragend: IDispatch;
begin
  Result:=nil; //GetProp('ondragend');
end;

procedure TNode.SetOndragend(Value: IDispatch);
begin
  SetProp('ondragend',Value);
end;

function TNode.GetOndragenter: IDispatch;
begin
  Result:=nil; //GetProp('ondragenter');
end;

procedure TNode.SetOndragenter(Value: IDispatch);
begin
  SetProp('ondragenter',Value);
end;

function TNode.GetOndragleave: IDispatch;
begin
  Result:=nil; //GetProp('ondragleave');
end;

procedure TNode.SetOndragleave(Value: IDispatch);
begin
  SetProp('ondragleave',Value);
end;

function TNode.GetOndragover: IDispatch;
begin
  Result:=nil; //GetProp('ondragover');
end;

procedure TNode.SetOndragover(Value: IDispatch);
begin
  SetProp('ondragover',Value);
end;

function TNode.GetOndragstart: IDispatch;
begin
  Result:=nil; //GetProp('ondragstart');
end;

procedure TNode.SetOndragstart(Value: IDispatch);
begin
  SetProp('ondragstart',Value);
end;

function TNode.GetOndrop: IDispatch;
begin
  Result:=nil; //GetProp('ondrop');
end;

procedure TNode.SetOndrop(Value: IDispatch);
begin
  SetProp('ondrop',Value);
end;

function TNode.GetOnerrorupdate: IDispatch;
begin
  Result:=nil; //GetProp('onerrorupdate');
end;

procedure TNode.SetOnerrorupdate(Value: IDispatch);
begin
  SetProp('onerrorupdate',Value);
end;

function TNode.GetOnfilterchange: IDispatch;
begin
  Result:=nil; //GetProp('onfilterchange');
end;

procedure TNode.SetOnfilterchange(Value: IDispatch);
begin
  SetProp('onfilterchange',Value);
end;

function TNode.GetOnfocus: IDispatch;
begin
  Result:=nil; //GetProp('onfocus');
end;

procedure TNode.SetOnfocus(Value: IDispatch);
begin
  SetProp('onfocus',Value);
end;

function TNode.GetOnfocusin: IDispatch;
begin
  Result:=nil; //GetProp('onfocusin');
end;

procedure TNode.SetOnfocusin(Value: IDispatch);
begin
  SetProp('onfocusin',Value);
end;

function TNode.GetOnfocusout: IDispatch;
begin
  Result:=nil; //GetProp('onfocusout');
end;

procedure TNode.SetOnfocusout(Value: IDispatch);
begin
  SetProp('onfocusout',Value);
end;

function TNode.GetOnhelp: IDispatch;
begin
  Result:=nil; //GetProp('onhelp');
end;

procedure TNode.SetOnhelp(Value: IDispatch);
begin
  SetProp('onhelp',Value);
end;

function TNode.GetOnkeydown: IDispatch;
begin
  Result:=nil; //GetProp('onkeydown');
end;

procedure TNode.SetOnkeydown(Value: IDispatch);
begin
  SetProp('onkeydown',Value);
end;

function TNode.GetOnkeypress: IDispatch;
begin
  Result:=nil; //GetProp('onkeypress');
end;

procedure TNode.SetOnkeypress(Value: IDispatch);
begin
  SetProp('onkeypress',Value);
end;

function TNode.GetOnkeyup: IDispatch;
begin
  Result:=nil; //GetProp('onkeyup');
end;

procedure TNode.SetOnkeyup(Value: IDispatch);
begin
  SetProp('onkeyup',Value);
end;

function TNode.GetOnlayoutcomplete: IDispatch;
begin
  Result:=nil; //GetProp('onlayoutcomplete');
end;

procedure TNode.SetOnlayoutcomplete(Value: IDispatch);
begin
  SetProp('onlayoutcomplete',Value);
end;

function TNode.GetOnlosecapture: IDispatch;
begin
  Result:=nil; //GetProp('onlosecapture');
end;

procedure TNode.SetOnlosecapture(Value: IDispatch);
begin
  SetProp('onlosecapture',Value);
end;

function TNode.GetOnmousedown: IDispatch;
begin
  Result:=nil; //GetProp('onmousedown');
end;

procedure TNode.SetOnmousedown(Value: IDispatch);
begin
  SetProp('onmousedown',Value);
end;

function TNode.GetOnmouseenter: IDispatch;
begin
  Result:=nil; //GetProp('onmouseenter');
end;

procedure TNode.SetOnmouseenter(Value: IDispatch);
begin
  SetProp('onmouseenter',Value);
end;

function TNode.GetOnmouseleave: IDispatch;
begin
  Result:=nil; //GetProp('onmouseleave');
end;

procedure TNode.SetOnmouseleave(Value: IDispatch);
begin
  SetProp('onmouseleave',Value);
end;

function TNode.GetOnmousemove: IDispatch;
begin
  Result:=nil; //GetProp('onmousemove');
end;

procedure TNode.SetOnmousemove(Value: IDispatch);
begin
  SetProp('onmousemove',Value);
end;

function TNode.GetOnmouseout: IDispatch;
begin
  Result:=nil; //GetProp('onmouseout');
end;

procedure TNode.SetOnmouseout(Value: IDispatch);
begin
  SetProp('onmouseout',Value);
end;

function TNode.GetOnmouseover: IDispatch;
begin
  Result:=nil; //GetProp('onmouseover');
end;

procedure TNode.SetOnmouseover(Value: IDispatch);
begin
  SetProp('onmouseover',Value);
end;

function TNode.GetOnmouseup: IDispatch;
begin
  Result:=nil; //GetProp('onmouseup');
end;

procedure TNode.SetOnmouseup(Value: IDispatch);
begin
  SetProp('onmouseup',Value);
end;

function TNode.GetOnmousewheel: IDispatch;
begin
  Result:=nil; //GetProp('onmousewheel');
end;

procedure TNode.SetOnmousewheel(Value: IDispatch);
begin
  SetProp('onmousewheel',Value);
end;

function TNode.GetOnmove: IDispatch;
begin
  Result:=nil; //GetProp('onmove');
end;

procedure TNode.SetOnmove(Value: IDispatch);
begin
  SetProp('onmove',Value);
end;

function TNode.GetOnmoveend: IDispatch;
begin
  Result:=nil; //GetProp('onmoveend');
end;

procedure TNode.SetOnmoveend(Value: IDispatch);
begin
  SetProp('onmoveend',Value);
end;

function TNode.GetOnmovestart: IDispatch;
begin
  Result:=nil; //GetProp('onmovestart');
end;

procedure TNode.SetOnmovestart(Value: IDispatch);
begin
  SetProp('onmovestart',Value);
end;

function TNode.GetOnpage: IDispatch;
begin
  Result:=nil; //GetProp('onpage');
end;

procedure TNode.SetOnpage(Value: IDispatch);
begin
  SetProp('onpage',Value);
end;

function TNode.GetOnpaste: IDispatch;
begin
  Result:=nil; //GetProp('onpaste');
end;

procedure TNode.SetOnpaste(Value: IDispatch);
begin
  SetProp('onpaste',Value);
end;

function TNode.GetOnpropertychange: IDispatch;
begin
  Result:=nil; //GetProp('onpropertychange');
end;

procedure TNode.SetOnpropertychange(Value: IDispatch);
begin
  SetProp('onpropertychange',Value);
end;

function TNode.GetOnreadystatechange: IDispatch;
begin
  Result:=nil; //GetProp('onreadystatechange');
end;

procedure TNode.SetOnreadystatechange(Value: IDispatch);
begin
  SetProp('onreadystatechange',Value);
end;

function TNode.GetOnresize: IDispatch;
begin
  Result:=nil; //GetProp('onresize');
end;

procedure TNode.SetOnresize(Value: IDispatch);
begin
  SetProp('onresize',Value);
end;

function TNode.GetOnresizeend: IDispatch;
begin
  Result:=nil; //GetProp('onresizeend');
end;

procedure TNode.SetOnresizeend(Value: IDispatch);
begin
  SetProp('onresizeend',Value);
end;

function TNode.GetOnresizestart: IDispatch;
begin
  Result:=nil; //GetProp('onresizestart');
end;

procedure TNode.SetOnresizestart(Value: IDispatch);
begin
  SetProp('onresizestart',Value);
end;

function TNode.GetOnrowenter: IDispatch;
begin
  Result:=nil; //GetProp('onrowenter');
end;

procedure TNode.SetOnrowenter(Value: IDispatch);
begin
  SetProp('onrowenter',Value);
end;

function TNode.GetOnrowexit: IDispatch;
begin
  Result:=nil; //GetProp('onrowexit');
end;

procedure TNode.SetOnrowexit(Value: IDispatch);
begin
  SetProp('onrowexit',Value);
end;

function TNode.GetOnrowsdelete: IDispatch;
begin
  Result:=nil; //GetProp('onrowsdelete');
end;

procedure TNode.SetOnrowsdelete(Value: IDispatch);
begin
  SetProp('onrowsdelete',Value);
end;

function TNode.GetOnrowsinserted: IDispatch;
begin
  Result:=nil; //GetProp('onrowsinserted');
end;

procedure TNode.SetOnrowsinserted(Value: IDispatch);
begin
  SetProp('onrowsinserted',Value);
end;

function TNode.GetOnscroll: IDispatch;
begin
  Result:=nil; //GetProp('onscroll');
end;

procedure TNode.SetOnscroll(Value: IDispatch);
begin
  SetProp('onscroll',Value);
end;

function TNode.GetOnselectstart: IDispatch;
begin
  Result:=nil; //GetProp('onselectstart');
end;

procedure TNode.SetOnselectstart(Value: IDispatch);
begin
  SetProp('onselectstart',Value);
end;

function TNode.GetOuterHTML: String;
begin
  Result:=GetProp('outerHTML');
end;

procedure TNode.SetOuterHTML(Value: String);
begin
  SetProp('outerHTML',Value);
end;

function TNode.GetOuterText: String;
begin
  Result:=GetProp('outerText');
end;

procedure TNode.SetOuterText(Value: String);
begin
  SetProp('outerText',Value);
end;

function TNode.GetOwnerDocument: IDispatch;
begin
  Result:=GetProp('ownerDocument');
end;

procedure TNode.SetOwnerDocument(Value: IDispatch);
begin
  SetProp('ownerDocument',Value);
end;

function TNode.GetParentElement: IDispatch;
begin
  Result:=GetProp('parentElement');
end;

procedure TNode.SetParentElement(Value: IDispatch);
begin
  SetProp('parentElement',Value);
end;

function TNode.GetParentNode: IDispatch;
begin
  Result:=GetProp('parentNode');
end;

procedure TNode.SetParentNode(Value: IDispatch);
begin
  SetProp('parentNode',Value);
end;

function TNode.GetParentTextEdit: IDispatch;
begin
  Result:=GetProp('parentTextEdit');
end;

procedure TNode.SetParentTextEdit(Value: IDispatch);
begin
  SetProp('parentTextEdit',Value);
end;

function TNode.GetPreviousSibling: IDispatch;
begin
  Result:=GetProp('previousSibling');
end;

procedure TNode.SetPreviousSibling(Value: IDispatch);
begin
  SetProp('previousSibling',Value);
end;

function TNode.GetReadyState: String;
begin
  Result:=GetProp('readyState');
end;

procedure TNode.SetReadyState(Value: String);
begin
  SetProp('readyState',Value);
end;

function TNode.GetRecordNumber: IDispatch;
begin
  Result:=nil; //GetProp('recordNumber');
end;

procedure TNode.SetRecordNumber(Value: IDispatch);
begin
  SetProp('recordNumber',Value);
end;

function TNode.GetRole: String;
begin
  Result:=GetProp('role');
end;

procedure TNode.SetRole(Value: String);
begin
  SetProp('role',Value);
end;

function TNode.GetRuntimeStyle: IDispatch;
begin
  Result:=GetProp('runtimeStyle');
end;

procedure TNode.SetRuntimeStyle(Value: IDispatch);
begin
  SetProp('runtimeStyle',Value);
end;

function TNode.GetScopeName: String;
begin
  Result:=GetProp('scopeName');
end;

procedure TNode.SetScopeName(Value: String);
begin
  SetProp('scopeName',Value);
end;

function TNode.GetScrollHeight: Integer;
begin
  Result:=GetProp('scrollHeight');
end;

procedure TNode.SetScrollHeight(Value: Integer);
begin
  SetProp('scrollHeight',Value);
end;

function TNode.GetScrollLeft: Integer;
begin
  Result:=GetProp('scrollLeft');
end;

procedure TNode.SetScrollLeft(Value: Integer);
begin
  SetProp('scrollLeft',Value);
end;

function TNode.GetScrollTop: Integer;
begin
  Result:=GetProp('scrollTop');
end;

procedure TNode.SetScrollTop(Value: Integer);
begin
  SetProp('scrollTop',Value);
end;

function TNode.GetScrollWidth: Integer;
begin
  Result:=GetProp('scrollWidth');
end;

procedure TNode.SetScrollWidth(Value: Integer);
begin
  SetProp('scrollWidth',Value);
end;

function TNode.GetSourceIndex: Integer;
begin
  Result:=GetProp('sourceIndex');
end;

procedure TNode.SetSourceIndex(Value: Integer);
begin
  SetProp('sourceIndex',Value);
end;

function TNode.GetStyle: TStyle;
begin
  Result:=TStyle(GetPropAsObject('style',TStyle,FStyle));
end;

procedure TNode.SetStyle(Value: TStyle);
begin
  SetProp('style',Value);
end;

function TNode.GetTabIndex: SmallInt;
begin
  Result:=GetProp('tabIndex');
end;

procedure TNode.SetTabIndex(Value: SmallInt);
begin
  SetProp('tabIndex',Value);
end;

function TNode.GetTagName: String;
begin
  Result:=GetProp('tagName');
end;

procedure TNode.SetTagName(Value: String);
begin
  SetProp('tagName',Value);
end;

function TNode.GetTagUrn: String;
begin
  Result:=GetProp('tagUrn');
end;

procedure TNode.SetTagUrn(Value: String);
begin
  SetProp('tagUrn',Value);
end;

function TNode.GetTitle: String;
begin
  Result:=GetProp('title');
end;

procedure TNode.SetTitle(Value: String);
begin
  SetProp('title',Value);
end;

function TNode.GetTop: Integer;
begin
  case FAlign of
    alNone{$IFDEF DELPHI6_UP}, alCustom{$ENDIF}:
    begin
      FTop:=HTMLToInt(Style.Top,PixelStr,FTop);
      Result:=FTop;
    end;
    alLeft, alTop, alRight, alClient:
      Result:=0;
    alBottom:
//      Result:=Script.DocHostUIHandler.Browser.ClientHeight-
//              HTMLToInt(FNode.Style.Height,PixelStr,FHeight);
      Result:=OffsetTop;
    else Result:=FTop;
  end;
end;

procedure TNode.SetTop(Value: Integer);
begin
  if FTop<>Value then
  begin
    FTop:=Value;
    case FAlign of
      alNone{$IFDEF DELPHI6_UP}, alCustom{$ENDIF}:
        Style.Top:=IntToHTML(FTop,PixelStr);
    end;
  end;
end;

function TNode.GetWidth: Integer;
begin
  case FAlign of
    alNone{$IFDEF DELPHI6_UP}, alCustom{$ENDIF}, alLeft, alRight:
    begin
      FWidth:=HTMLToInt(Style.Width,PixelStr,FWidth);
      Result:=FWidth;
    end;
    alTop, alBottom, alClient:
      Result:=ClientWidth; //Script.DocHostUIHandler.Browser.ClientWidth;
    else Result:=FWidth;
  end;
end;

procedure TNode.SetWidth(Value: Integer);
begin
  if FWidth<>Value then
  begin
    FWidth:=Value;
    case FAlign of
      alNone{$IFDEF DELPHI6_UP}, alCustom{$ENDIF}, alLeft, alRight:
        Style.Width:=IntToHTML(FWidth,PixelStr);
    end;
  end;
end;

//------------------------------------------------------------------------------
//TScriptNode

function TScriptNode.GetCharset: String;
begin
  Result:=GetPropAsString(ScriptNodeProp_Charset);
end;

procedure TScriptNode.SetCharset(Value: String);
begin
  SetProp(ScriptNodeProp_Charset,Value,true);
end;

function TScriptNode.GetDefer: Boolean;
begin
  Result:=GetPropAsBoolean(ScriptNodeProp_Defer);
end;

procedure TScriptNode.SetDefer(Value: Boolean);
begin
  SetProp(ScriptNodeProp_Defer,Value,true);
end;

function TScriptNode.GetEvent: String;
begin
  Result:=GetPropAsString(ScriptNodeProp_Event);
end;

procedure TScriptNode.SetEvent(Value: String);
begin
  SetProp(ScriptNodeProp_Event,Value,true);
end;

function TScriptNode.GetHTMLFor: String;
begin
  Result:=GetPropAsString(ScriptNodeProp_HTMLFor);
end;

procedure TScriptNode.SetHTMLFor(Value: String);
begin
  SetProp(ScriptNodeProp_HTMLFor,Value,true);
end;

function TScriptNode.GetSrc: String;
begin
  Result:=GetPropAsString(ScriptNodeProp_Src);
end;

procedure TScriptNode.SetSrc(Value: String);
begin
  SetProp(ScriptNodeProp_Src,Value,true);
end;

function TScriptNode.GetText: String;
begin
  Result:=GetPropAsString(ScriptNodeProp_Text);
end;

procedure TScriptNode.SetText(Value: String);
begin
  SetProp(ScriptNodeProp_Text,Value,true);
end;

function TScriptNode.GetType: String;
begin
  Result:=GetPropAsString(ScriptNodeProp_Type);
end;

procedure TScriptNode.SetType(Value: String);
begin
  SetProp(ScriptNodeProp_Type,Value,true);
end;

//------------------------------------------------------------------------------
//TStyle

function TStyle.GetAccelerator: String;
begin
  Result:=GetPropAsString(StyleProp_Accelerator);
end;

procedure TStyle.SetAccelerator(Value: String);
begin
  SetProp(StyleProp_Accelerator,Value,true);
end;

function TStyle.GetBackground: String;
begin
  Result:=GetPropAsString(StyleProp_Background);
end;

procedure TStyle.SetBackground(Value: String);
begin
  SetProp(StyleProp_Background,Value,true);
end;

function TStyle.GetBackgroundAttachment: String;
begin
  Result:=GetPropAsString(StyleProp_BackgroundAttachment);
end;

procedure TStyle.SetBackgroundAttachment(Value: String);
begin
  SetProp(StyleProp_BackgroundAttachment,Value,true);
end;

function TStyle.GetBackgroundColor: TColor;
begin
  Result:=WebColorStrToColor(GetPropAsString(StyleProp_BackgroundColor));
end;

procedure TStyle.SetBackgroundColor(Value: TColor);
begin
  SetProp(StyleProp_BackgroundColor,ColorToWebColorStr(Value),true);
end;

function TStyle.GetBackgroundImage: String;
begin
  Result:=GetPropAsString(StyleProp_BackgroundImage);
end;

procedure TStyle.SetBackgroundImage(Value: String);
begin
  SetProp(StyleProp_BackgroundImage,Value,true);
end;

function TStyle.GetBackgroundPosition: String;
begin
  Result:=GetPropAsString(StyleProp_BackgroundPosition);
end;

procedure TStyle.SetBackgroundPosition(Value: String);
begin
  SetProp(StyleProp_BackgroundPosition,Value,true);
end;

function TStyle.GetBackgroundPositionX: String;
begin
  Result:=GetPropAsString(StyleProp_BackgroundPositionX);
end;

procedure TStyle.SetBackgroundPositionX(Value: String);
begin
  SetProp(StyleProp_BackgroundPositionX,Value,true);
end;

function TStyle.GetBackgroundPositionY: String;
begin
  Result:=GetPropAsString(StyleProp_BackgroundPositionY);
end;

procedure TStyle.SetBackgroundPositionY(Value: String);
begin
  SetProp(StyleProp_BackgroundPositionY,Value,true);
end;

function TStyle.GetBackgroundRepeat: String;
begin
  Result:=GetPropAsString(StyleProp_BackgroundRepeat);
end;

procedure TStyle.SetBackgroundRepeat(Value: String);
begin
  SetProp(StyleProp_BackgroundRepeat,Value,true);
end;

function TStyle.GetBehavior: String;
begin
  Result:=GetPropAsString(StyleProp_Behavior);
end;

procedure TStyle.SetBehavior(Value: String);
begin
  SetProp(StyleProp_Behavior,Value,true);
end;

function TStyle.GetBorder: String;
begin
  Result:=GetPropAsString(StyleProp_Border);
end;

procedure TStyle.SetBorder(Value: String);
begin
  SetProp(StyleProp_Border,Value,true);
end;

function TStyle.GetBorderBottom: String;
begin
  Result:=GetPropAsString(StyleProp_BorderBottom);
end;

procedure TStyle.SetBorderBottom(Value: String);
begin
  SetProp(StyleProp_BorderBottom,Value,true);
end;

function TStyle.GetBorderBottomColor: TColor;
begin
  Result:=WebColorStrToColor(GetPropAsString(StyleProp_BorderBottomColor));
end;

procedure TStyle.SetBorderBottomColor(Value: TColor);
begin
  SetProp(StyleProp_BorderBottomColor,ColorToWebColorStr(Value),true);
end;

function TStyle.GetBorderBottomStyle: String;
begin
  Result:=GetPropAsString(StyleProp_BorderBottomStyle);
end;

procedure TStyle.SetBorderBottomStyle(Value: String);
begin
  SetProp(StyleProp_BorderBottomStyle,Value,true);
end;

function TStyle.GetBorderBottomWidth: String;
begin
  Result:=GetPropAsString(StyleProp_BorderBottomWidth);
end;

procedure TStyle.SetBorderBottomWidth(Value: String);
begin
  SetProp(StyleProp_BorderBottomWidth,Value,true);
end;

function TStyle.GetBorderCollapse: String;
begin
  Result:=GetPropAsString(StyleProp_BorderCollapse);
end;

procedure TStyle.SetBorderCollapse(Value: String);
begin
  SetProp(StyleProp_BorderCollapse,Value,true);
end;

function TStyle.GetBorderColor: TColor;
begin
  Result:=WebColorStrToColor(GetPropAsString(StyleProp_BorderColor));
end;

procedure TStyle.SetBorderColor(Value: TColor);
begin
  SetProp(StyleProp_BorderColor,ColorToWebColorStr(Value),true);
end;

function TStyle.GetBorderLeft: String;
begin
  Result:=GetPropAsString(StyleProp_BorderLeft);
end;

procedure TStyle.SetBorderLeft(Value: String);
begin
  SetProp(StyleProp_BorderLeft,Value,true);
end;

function TStyle.GetBorderLeftColor: TColor;
begin
  Result:=WebColorStrToColor(GetPropAsString(StyleProp_BorderLeftColor));
end;

procedure TStyle.SetBorderLeftColor(Value: TColor);
begin
  SetProp(StyleProp_BorderLeftColor,ColorToWebColorStr(Value),true);
end;

function TStyle.GetBorderLeftStyle: String;
begin
  Result:=GetPropAsString(StyleProp_BorderLeftStyle);
end;

procedure TStyle.SetBorderLeftStyle(Value: String);
begin
  SetProp(StyleProp_BorderLeftStyle,Value,true);
end;

function TStyle.GetBorderLeftWidth: String;
begin
  Result:=GetPropAsString(StyleProp_BorderLeftWidth);
end;

procedure TStyle.SetBorderLeftWidth(Value: String);
begin
  SetProp(StyleProp_BorderLeftWidth,Value,true);
end;

function TStyle.GetBorderRight: String;
begin
  Result:=GetPropAsString(StyleProp_BorderRight);
end;

procedure TStyle.SetBorderRight(Value: String);
begin
  SetProp(StyleProp_BorderRight,Value,true);
end;

function TStyle.GetBorderRightColor: TColor;
begin
  Result:=WebColorStrToColor(GetPropAsString(StyleProp_BorderRightColor));
end;

procedure TStyle.SetBorderRightColor(Value: TColor);
begin
  SetProp(StyleProp_BorderRightColor,ColorToWebColorStr(Value),true);
end;

function TStyle.GetBorderRightStyle: String;
begin
  Result:=GetPropAsString(StyleProp_BorderRightStyle);
end;

procedure TStyle.SetBorderRightStyle(Value: String);
begin
  SetProp(StyleProp_BorderRightStyle,Value,true);
end;

function TStyle.GetBorderRightWidth: String;
begin
  Result:=GetPropAsString(StyleProp_BorderRightWidth);
end;

procedure TStyle.SetBorderRightWidth(Value: String);
begin
  SetProp(StyleProp_BorderRightWidth,Value,true);
end;

function TStyle.GetBorderSpacing: String;
begin
  Result:=GetPropAsString(StyleProp_BorderSpacing);
end;

procedure TStyle.SetBorderSpacing(Value: String);
begin
  SetProp(StyleProp_BorderSpacing,Value,true);
end;

function TStyle.GetBorderStyle: String;
begin
  Result:=GetPropAsString(StyleProp_BorderStyle);
end;

procedure TStyle.SetBorderStyle(Value: String);
begin
  SetProp(StyleProp_BorderStyle,Value,true);
end;

function TStyle.GetBorderTop: String;
begin
  Result:=GetPropAsString(StyleProp_BorderTop);
end;

procedure TStyle.SetBorderTop(Value: String);
begin
  SetProp(StyleProp_BorderTop,Value,true);
end;

function TStyle.GetBorderTopColor: TColor;
begin
  Result:=WebColorStrToColor(GetPropAsString(StyleProp_BorderTopColor));
end;

procedure TStyle.SetBorderTopColor(Value: TColor);
begin
  SetProp(StyleProp_BorderTopColor,ColorToWebColorStr(Value),true);
end;

function TStyle.GetBorderTopStyle: String;
begin
  Result:=GetPropAsString(StyleProp_BorderTopStyle);
end;

procedure TStyle.SetBorderTopStyle(Value: String);
begin
  SetProp(StyleProp_BorderTopStyle,Value,true);
end;

function TStyle.GetBorderTopWidth: String;
begin
  Result:=GetPropAsString(StyleProp_BorderTopWidth);
end;

procedure TStyle.SetBorderTopWidth(Value: String);
begin
  SetProp(StyleProp_BorderTopWidth,Value,true);
end;

function TStyle.GetBorderWidth: String;
begin
  Result:=GetPropAsString(StyleProp_BorderWidth);
end;

procedure TStyle.SetBorderWidth(Value: String);
begin
  SetProp(StyleProp_BorderWidth,Value,true);
end;

function TStyle.GetBottom: String;
begin
  Result:=GetPropAsString(StyleProp_Bottom);
end;

procedure TStyle.SetBottom(Value: String);
begin
  SetProp(StyleProp_Bottom,Value,true);
end;

function TStyle.GetBoxSizing: String;
begin
  Result:=GetPropAsString(StyleProp_BoxSizing);
end;

procedure TStyle.SetBoxSizing(Value: String);
begin
  SetProp(StyleProp_BoxSizing,Value,true);
end;

function TStyle.GetCaptionSide: String;
begin
  Result:=GetPropAsString(StyleProp_CaptionSide);
end;

procedure TStyle.SetCaptionSide(Value: String);
begin
  SetProp(StyleProp_CaptionSide,Value,true);
end;

function TStyle.GetClear: String;
begin
  Result:=GetPropAsString(StyleProp_Clear);
end;

procedure TStyle.SetClear(Value: String);
begin
  SetProp(StyleProp_Clear,Value,true);
end;

function TStyle.GetClip: String;
begin
  Result:=GetPropAsString(StyleProp_Clip);
end;

procedure TStyle.SetClip(Value: String);
begin
  SetProp(StyleProp_Clip,Value,true);
end;

function TStyle.GetColor: TColor;
begin
  Result:=WebColorStrToColor(GetPropAsString(StyleProp_Color));
end;

procedure TStyle.SetColor(Value: TColor);
begin
  SetProp(StyleProp_Color,ColorToWebColorStr(Value),true);
end;

function TStyle.GetContent: String;
begin
  Result:=GetPropAsString(StyleProp_Content);
end;

procedure TStyle.SetContent(Value: String);
begin
  SetProp(StyleProp_Content,Value,true);
end;

function TStyle.GetCounterIncrement: String;
begin
  Result:=GetPropAsString(StyleProp_CounterIncrement);
end;

procedure TStyle.SetCounterIncrement(Value: String);
begin
  SetProp(StyleProp_CounterIncrement,Value,true);
end;

function TStyle.GetCounterReset: String;
begin
  Result:=GetPropAsString(StyleProp_CounterReset);
end;

procedure TStyle.SetCounterReset(Value: String);
begin
  SetProp(StyleProp_CounterReset,Value,true);
end;

function TStyle.GetCSSText: String;
begin
  Result:=GetPropAsString(StyleProp_CSSText);
end;

procedure TStyle.SetCSSText(Value: String);
begin
  SetProp(StyleProp_CSSText,Value,true);
end;

function TStyle.GetCursor: String;
begin
  Result:=GetPropAsString(StyleProp_Cursor);
end;

procedure TStyle.SetCursor(Value: String);
begin
  SetProp(StyleProp_Cursor,Value,true);
end;

function TStyle.GetDirection: String;
begin
  Result:=GetPropAsString(StyleProp_Direction);
end;

procedure TStyle.SetDirection(Value: String);
begin
  SetProp(StyleProp_Direction,Value,true);
end;

function TStyle.GetDisplay: String;
begin
  Result:=GetPropAsString(StyleProp_Display);
end;

procedure TStyle.SetDisplay(Value: String);
begin
  SetProp(StyleProp_Display,Value,true);
end;

function TStyle.GetEmptyCells: String;
begin
  Result:=GetPropAsString(StyleProp_EmptyCells);
end;

procedure TStyle.SetEmptyCells(Value: String);
begin
  SetProp(StyleProp_EmptyCells,Value,true);
end;

function TStyle.GetFilter: String;
begin
  Result:=GetPropAsString(StyleProp_Filter);
end;

procedure TStyle.SetFilter(Value: String);
begin
  SetProp(StyleProp_Filter,Value,true);
end;

function TStyle.GetFloat: String;
begin
  Result:=GetPropAsString(StyleProp_Float);
end;

procedure TStyle.SetFloat(Value: String);
begin
  SetProp(StyleProp_Float,Value,true);
end;

function TStyle.GetFont: String;
begin
  Result:=GetPropAsString(StyleProp_Font);
end;

procedure TStyle.SetFont(Value: String);
begin
  SetProp(StyleProp_Font,Value,true);
end;

function TStyle.GetFontFamily: String;
begin
  Result:=GetPropAsString(StyleProp_FontFamily);
end;

procedure TStyle.SetFontFamily(Value: String);
begin
  SetProp(StyleProp_FontFamily,Value,true);
end;

function TStyle.GetFontSize: String;
begin
  Result:=GetPropAsString(StyleProp_FontSize);
end;

procedure TStyle.SetFontSize(Value: String);
begin
  SetProp(StyleProp_FontSize,Value,true);
end;

function TStyle.GetFontStyle: String;
begin
  Result:=GetPropAsString(StyleProp_FontStyle);
end;

procedure TStyle.SetFontStyle(Value: String);
begin
  SetProp(StyleProp_FontStyle,Value,true);
end;

function TStyle.GetFontVariant: String;
begin
  Result:=GetPropAsString(StyleProp_FontVariant);
end;

procedure TStyle.SetFontVariant(Value: String);
begin
  SetProp(StyleProp_FontVariant,Value,true);
end;

function TStyle.GetFontWeight: String;
begin
  Result:=GetPropAsString(StyleProp_FontWeight);
end;

procedure TStyle.SetFontWeight(Value: String);
begin
  SetProp(StyleProp_FontWeight,Value,true);
end;

function TStyle.GetHeight: String;
begin
  Result:=GetPropAsString(StyleProp_Height);
end;

procedure TStyle.SetHeight(Value: String);
begin
  SetProp(StyleProp_Height,Value,true);
end;

function TStyle.GetImeMode: String;
begin
  Result:=GetPropAsString(StyleProp_ImeMode);
end;

procedure TStyle.SetImeMode(Value: String);
begin
  SetProp(StyleProp_ImeMode,Value,true);
end;

function TStyle.GetLayoutFlow: String;
begin
  Result:=GetPropAsString(StyleProp_LayoutFlow);
end;

procedure TStyle.SetLayoutFlow(Value: String);
begin
  SetProp(StyleProp_LayoutFlow,Value,true);
end;

function TStyle.GetLayoutGrid: String;
begin
  Result:=GetPropAsString(StyleProp_LayoutGrid);
end;

procedure TStyle.SetLayoutGrid(Value: String);
begin
  SetProp(StyleProp_LayoutGrid,Value,true);
end;

function TStyle.GetLayoutGridChar: String;
begin
  Result:=GetPropAsString(StyleProp_LayoutGridChar);
end;

procedure TStyle.SetLayoutGridChar(Value: String);
begin
  SetProp(StyleProp_LayoutGridChar,Value,true);
end;

function TStyle.GetLayoutGridLine: String;
begin
  Result:=GetPropAsString(StyleProp_LayoutGridLine);
end;

procedure TStyle.SetLayoutGridLine(Value: String);
begin
  SetProp(StyleProp_LayoutGridLine,Value,true);
end;

function TStyle.GetLayoutGridMode: String;
begin
  Result:=GetPropAsString(StyleProp_LayoutGridMode);
end;

procedure TStyle.SetLayoutGridMode(Value: String);
begin
  SetProp(StyleProp_LayoutGridMode,Value,true);
end;

function TStyle.GetLayoutGridType: String;
begin
  Result:=GetPropAsString(StyleProp_LayoutGridType);
end;

procedure TStyle.SetLayoutGridType(Value: String);
begin
  SetProp(StyleProp_LayoutGridType,Value,true);
end;

function TStyle.GetLeft: String;
begin
  Result:=GetPropAsString(StyleProp_Left);
end;

procedure TStyle.SetLeft(Value: String);
begin
  SetProp(StyleProp_Left,Value,true);
end;

function TStyle.GetLetterSpacing: String;
begin
  Result:=GetPropAsString(StyleProp_LetterSpacing);
end;

procedure TStyle.SetLetterSpacing(Value: String);
begin
  SetProp(StyleProp_LetterSpacing,Value,true);
end;

function TStyle.GetLineBreak: String;
begin
  Result:=GetPropAsString(StyleProp_LineBreak);
end;

procedure TStyle.SetLineBreak(Value: String);
begin
  SetProp(StyleProp_LineBreak,Value,true);
end;

function TStyle.GetLineHeight: String;
begin
  Result:=GetPropAsString(StyleProp_LineHeight);
end;

procedure TStyle.SetLineHeight(Value: String);
begin
  SetProp(StyleProp_LineHeight,Value,true);
end;

function TStyle.GetListStyle: String;
begin
  Result:=GetPropAsString(StyleProp_ListStyle);
end;

procedure TStyle.SetListStyle(Value: String);
begin
  SetProp(StyleProp_ListStyle,Value,true);
end;

function TStyle.GetListStyleImage: String;
begin
  Result:=GetPropAsString(StyleProp_ListStyleImage);
end;

procedure TStyle.SetListStyleImage(Value: String);
begin
  SetProp(StyleProp_ListStyleImage,Value,true);
end;

function TStyle.GetListStylePosition: String;
begin
  Result:=GetPropAsString(StyleProp_ListStylePosition);
end;

procedure TStyle.SetListStylePosition(Value: String);
begin
  SetProp(StyleProp_ListStylePosition,Value,true);
end;

function TStyle.GetListStyleType: String;
begin
  Result:=GetPropAsString(StyleProp_ListStyleType);
end;

procedure TStyle.SetListStyleType(Value: String);
begin
  SetProp(StyleProp_ListStyleType,Value,true);
end;

function TStyle.GetMargin: String;
begin
  Result:=GetPropAsString(StyleProp_Margin);
end;

procedure TStyle.SetMargin(Value: String);
begin
  SetProp(StyleProp_Margin,Value,true);
end;

function TStyle.GetMarginBottom: String;
begin
  Result:=GetPropAsString(StyleProp_MarginBottom);
end;

procedure TStyle.SetMarginBottom(Value: String);
begin
  SetProp(StyleProp_MarginBottom,Value,true);
end;

function TStyle.GetMarginLeft: String;
begin
  Result:=GetPropAsString(StyleProp_MarginLeft);
end;

procedure TStyle.SetMarginLeft(Value: String);
begin
  SetProp(StyleProp_MarginLeft,Value,true);
end;

function TStyle.GetMarginRight: String;
begin
  Result:=GetPropAsString(StyleProp_MarginRight);
end;

procedure TStyle.SetMarginRight(Value: String);
begin
  SetProp(StyleProp_MarginRight,Value,true);
end;

function TStyle.GetMarginTop: String;
begin
  Result:=GetPropAsString(StyleProp_MarginTop);
end;

procedure TStyle.SetMarginTop(Value: String);
begin
  SetProp(StyleProp_MarginTop,Value,true);
end;

function TStyle.GetMaxHeight: String;
begin
  Result:=GetPropAsString(StyleProp_MaxHeight);
end;

procedure TStyle.SetMaxHeight(Value: String);
begin
  SetProp(StyleProp_MaxHeight,Value,true);
end;

function TStyle.GetMaxWidth: String;
begin
  Result:=GetPropAsString(StyleProp_MaxWidth);
end;

procedure TStyle.SetMaxWidth(Value: String);
begin
  SetProp(StyleProp_MaxWidth,Value,true);
end;

function TStyle.GetMinHeight: String;
begin
  Result:=GetPropAsString(StyleProp_MinHeight);
end;

procedure TStyle.SetMinHeight(Value: String);
begin
  SetProp(StyleProp_MinHeight,Value,true);
end;

function TStyle.GetMinWidth: String;
begin
  Result:=GetPropAsString(StyleProp_MinWidth);
end;

procedure TStyle.SetMinWidth(Value: String);
begin
  SetProp(StyleProp_MinWidth,Value,true);
end;

function TStyle.GetMsBlockProgression: String;
begin
  Result:=GetPropAsString(StyleProp_MsBlockProgression);
end;

procedure TStyle.SetMsBlockProgression(Value: String);
begin
  SetProp(StyleProp_MsBlockProgression,Value,true);
end;

function TStyle.GetMsInterpolationMode: String;
begin
  Result:=GetPropAsString(StyleProp_MsInterpolationMode);
end;

procedure TStyle.SetMsInterpolationMode(Value: String);
begin
  SetProp(StyleProp_MsInterpolationMode,Value,true);
end;

function TStyle.GetOpacity: Double;
begin
  Result:=GetPropAsDouble(StyleProp_Opacity);
end;

procedure TStyle.SetOpacity(Value: Double);
begin
  SetProp(StyleProp_Opacity,Value,true);
end;

function TStyle.GetOrphans: String;
begin
  Result:=GetPropAsString(StyleProp_Orphans);
end;

procedure TStyle.SetOrphans(Value: String);
begin
  SetProp(StyleProp_Orphans,Value,true);
end;

function TStyle.GetOutline: String;
begin
  Result:=GetPropAsString(StyleProp_Outline);
end;

procedure TStyle.SetOutline(Value: String);
begin
  SetProp(StyleProp_Outline,Value,true);
end;

function TStyle.GetOutlineColor: TColor;
begin
  Result:=WebColorStrToColor(GetPropAsString(StyleProp_OutlineColor));
end;

procedure TStyle.SetOutlineColor(Value: TColor);
begin
  SetProp(StyleProp_OutlineColor,ColorToWebColorStr(Value),true);
end;

function TStyle.GetOutlineStyle: String;
begin
  Result:=GetPropAsString(StyleProp_OutlineStyle);
end;

procedure TStyle.SetOutlineStyle(Value: String);
begin
  SetProp(StyleProp_OutlineStyle,Value,true);
end;

function TStyle.GetOutlineWidth: String;
begin
  Result:=GetPropAsString(StyleProp_OutlineWidth);
end;

procedure TStyle.SetOutlineWidth(Value: String);
begin
  SetProp(StyleProp_OutlineWidth,Value,true);
end;

function TStyle.GetOverflow: String;
begin
  Result:=GetPropAsString(StyleProp_Overflow);
end;

procedure TStyle.SetOverflow(Value: String);
begin
  SetProp(StyleProp_Overflow,Value,true);
end;

function TStyle.GetOverflowX: String;
begin
  Result:=GetPropAsString(StyleProp_OverflowX);
end;

procedure TStyle.SetOverflowX(Value: String);
begin
  SetProp(StyleProp_OverflowX,Value,true);
end;

function TStyle.GetOverflowY: String;
begin
  Result:=GetPropAsString(StyleProp_OverflowY);
end;

procedure TStyle.SetOverflowY(Value: String);
begin
  SetProp(StyleProp_OverflowY,Value,true);
end;

function TStyle.GetPadding: String;
begin
  Result:=GetPropAsString(StyleProp_Padding);
end;

procedure TStyle.SetPadding(Value: String);
begin
  SetProp(StyleProp_Padding,Value,true);
end;

function TStyle.GetPaddingBottom: String;
begin
  Result:=GetPropAsString(StyleProp_PaddingBottom);
end;

procedure TStyle.SetPaddingBottom(Value: String);
begin
  SetProp(StyleProp_PaddingBottom,Value,true);
end;

function TStyle.GetPaddingLeft: String;
begin
  Result:=GetPropAsString(StyleProp_PaddingLeft);
end;

procedure TStyle.SetPaddingLeft(Value: String);
begin
  SetProp(StyleProp_PaddingLeft,Value,true);
end;

function TStyle.GetPaddingRight: String;
begin
  Result:=GetPropAsString(StyleProp_PaddingRight);
end;

procedure TStyle.SetPaddingRight(Value: String);
begin
  SetProp(StyleProp_PaddingRight,Value,true);
end;

function TStyle.GetPaddingTop: String;
begin
  Result:=GetPropAsString(StyleProp_PaddingTop);
end;

procedure TStyle.SetPaddingTop(Value: String);
begin
  SetProp(StyleProp_PaddingTop,Value,true);
end;

function TStyle.GetPageBreakAfter: String;
begin
  Result:=GetPropAsString(StyleProp_PageBreakAfter);
end;

procedure TStyle.SetPageBreakAfter(Value: String);
begin
  SetProp(StyleProp_PageBreakAfter,Value,true);
end;

function TStyle.GetPageBreakBefore: String;
begin
  Result:=GetPropAsString(StyleProp_PageBreakBefore);
end;

procedure TStyle.SetPageBreakBefore(Value: String);
begin
  SetProp(StyleProp_PageBreakBefore,Value,true);
end;

function TStyle.GetPageBreakInside: String;
begin
  Result:=GetPropAsString(StyleProp_PageBreakInside);
end;

procedure TStyle.SetPageBreakInside(Value: String);
begin
  SetProp(StyleProp_PageBreakInside,Value,true);
end;

function TStyle.GetPosBottom: Single;
begin
  Result:=GetPropAsDouble(StyleProp_PosBottom);
end;

procedure TStyle.SetPosBottom(Value: Single);
begin
  SetProp(StyleProp_PosBottom,Value,true);
end;

function TStyle.GetPosHeight: Single;
begin
  Result:=GetPropAsDouble(StyleProp_PosHeight);
end;

procedure TStyle.SetPosHeight(Value: Single);
begin
  SetProp(StyleProp_PosHeight,Value,true);
end;

function TStyle.GetPosition: String;
begin
  Result:=GetPropAsString(StyleProp_Position);
end;

procedure TStyle.SetPosition(Value: String);
begin
  SetProp(StyleProp_Position,Value,true);
end;

function TStyle.GetPosLeft: Single;
begin
  Result:=GetPropAsDouble(StyleProp_PosLeft);
end;

procedure TStyle.SetPosLeft(Value: Single);
begin
  SetProp(StyleProp_PosLeft,Value,true);
end;

function TStyle.GetPosRight: Single;
begin
  Result:=GetPropAsDouble(StyleProp_PosRight);
end;

procedure TStyle.SetPosRight(Value: Single);
begin
  SetProp(StyleProp_PosRight,Value,true);
end;

function TStyle.GetPosTop: Single;
begin
  Result:=GetPropAsDouble(StyleProp_PosTop);
end;

procedure TStyle.SetPosTop(Value: Single);
begin
  SetProp(StyleProp_PosTop,Value,true);
end;

function TStyle.GetPosWidth: Single;
begin
  Result:=GetPropAsDouble(StyleProp_PosWidth);
end;

procedure TStyle.SetPosWidth(Value: Single);
begin
  SetProp(StyleProp_PosWidth,Value,true);
end;

function TStyle.GetQuotes: String;
begin
  Result:=GetPropAsString(StyleProp_Quotes);
end;

procedure TStyle.SetQuotes(Value: String);
begin
  SetProp(StyleProp_Quotes,Value,true);
end;

function TStyle.GetRight: String;
begin
  Result:=GetPropAsString(StyleProp_Right);
end;

procedure TStyle.SetRight(Value: String);
begin
  SetProp(StyleProp_Right,Value,true);
end;

function TStyle.GetRubyAlign: String;
begin
  Result:=GetPropAsString(StyleProp_RubyAlign);
end;

procedure TStyle.SetRubyAlign(Value: String);
begin
  SetProp(StyleProp_RubyAlign,Value,true);
end;

function TStyle.GetRubyOverhang: String;
begin
  Result:=GetPropAsString(StyleProp_RubyOverhang);
end;

procedure TStyle.SetRubyOverhang(Value: String);
begin
  SetProp(StyleProp_RubyOverhang,Value,true);
end;

function TStyle.GetRubyPosition: String;
begin
  Result:=GetPropAsString(StyleProp_RubyPosition);
end;

procedure TStyle.SetRubyPosition(Value: String);
begin
  SetProp(StyleProp_RubyPosition,Value,true);
end;

function TStyle.GetScrollbar3dLightColor: TColor;
begin
  Result:=WebColorStrToColor(GetPropAsString(StyleProp_Scrollbar3dLightColor));
end;

procedure TStyle.SetScrollbar3dLightColor(Value: TColor);
begin
  SetProp(StyleProp_Scrollbar3dLightColor,ColorToWebColorStr(Value),true);
end;

function TStyle.GetScrollbarArrowColor: TColor;
begin
  Result:=WebColorStrToColor(GetPropAsString(StyleProp_ScrollbarArrowColor));
end;

procedure TStyle.SetScrollbarArrowColor(Value: TColor);
begin
  SetProp(StyleProp_ScrollbarArrowColor,ColorToWebColorStr(Value),true);
end;

function TStyle.GetScrollbarBaseColor: TColor;
begin
  Result:=WebColorStrToColor(GetPropAsString(StyleProp_ScrollbarBaseColor));
end;

procedure TStyle.SetScrollbarBaseColor(Value: TColor);
begin
  SetProp(StyleProp_ScrollbarBaseColor,ColorToWebColorStr(Value),true);
end;

function TStyle.GetScrollbarDarkShadowColor: TColor;
begin
  Result:=WebColorStrToColor(GetPropAsString(StyleProp_ScrollbarDarkShadowColor));
end;

procedure TStyle.SetScrollbarDarkShadowColor(Value: TColor);
begin
  SetProp(StyleProp_ScrollbarDarkShadowColor,ColorToWebColorStr(Value),true);
end;

function TStyle.GetScrollbarFaceColor: TColor;
begin
  Result:=WebColorStrToColor(GetPropAsString(StyleProp_ScrollbarFaceColor));
end;

procedure TStyle.SetScrollbarFaceColor(Value: TColor);
begin
  SetProp(StyleProp_ScrollbarFaceColor,ColorToWebColorStr(Value),true);
end;

function TStyle.GetScrollbarHighlightColor: TColor;
begin
  Result:=WebColorStrToColor(GetPropAsString(StyleProp_ScrollbarHighlightColor));
end;

procedure TStyle.SetScrollbarHighlightColor(Value: TColor);
begin
  SetProp(StyleProp_ScrollbarHighlightColor,ColorToWebColorStr(Value),true);
end;

function TStyle.GetScrollbarShadowColor: TColor;
begin
  Result:=WebColorStrToColor(GetPropAsString(StyleProp_ScrollbarShadowColor));
end;

procedure TStyle.SetScrollbarShadowColor(Value: TColor);
begin
  SetProp(StyleProp_ScrollbarShadowColor,ColorToWebColorStr(Value),true);
end;

function TStyle.GetScrollbarTrackColor: TColor;
begin
  Result:=WebColorStrToColor(GetPropAsString(StyleProp_ScrollbarTrackColor));
end;

procedure TStyle.SetScrollbarTrackColor(Value: TColor);
begin
  SetProp(StyleProp_ScrollbarTrackColor,ColorToWebColorStr(Value),true);
end;

function TStyle.GetStyleFloat: String;
begin
  Result:=GetPropAsString(StyleProp_StyleFloat);
end;

procedure TStyle.SetStyleFloat(Value: String);
begin
  SetProp(StyleProp_StyleFloat,Value,true);
end;

function TStyle.GetTableLayout: String;
begin
  Result:=GetPropAsString(StyleProp_TableLayout);
end;

procedure TStyle.SetTableLayout(Value: String);
begin
  SetProp(StyleProp_TableLayout,Value,true);
end;

function TStyle.GetTextAlign: String;
begin
  Result:=GetPropAsString(StyleProp_TextAlign);
end;

procedure TStyle.SetTextAlign(Value: String);
begin
  SetProp(StyleProp_TextAlign,Value,true);
end;

function TStyle.GetTextAlignLast: String;
begin
  Result:=GetPropAsString(StyleProp_TextAlignLast);
end;

procedure TStyle.SetTextAlignLast(Value: String);
begin
  SetProp(StyleProp_TextAlignLast,Value,true);
end;

function TStyle.GetTextAutospace: String;
begin
  Result:=GetPropAsString(StyleProp_TextAutospace);
end;

procedure TStyle.SetTextAutospace(Value: String);
begin
  SetProp(StyleProp_TextAutospace,Value,true);
end;

function TStyle.GetTextDecoration: String;
begin
  Result:=GetPropAsString(StyleProp_TextDecoration);
end;

procedure TStyle.SetTextDecoration(Value: String);
begin
  SetProp(StyleProp_TextDecoration,Value,true);
end;

function TStyle.GetTextDecorationBlink: Boolean;
begin
  Result:=GetPropAsBoolean(StyleProp_TextDecorationBlink);
end;

procedure TStyle.SetTextDecorationBlink(Value: Boolean);
begin
  SetProp(StyleProp_TextDecorationBlink,Value,true);
end;

function TStyle.GetTextDecorationLineThrough: Boolean;
begin
  Result:=GetPropAsBoolean(StyleProp_TextDecorationLineThrough);
end;

procedure TStyle.SetTextDecorationLineThrough(Value: Boolean);
begin
  SetProp(StyleProp_TextDecorationLineThrough,Value,true);
end;

function TStyle.GetTextDecorationNone: Boolean;
begin
  Result:=GetPropAsBoolean(StyleProp_TextDecorationNone);
end;

procedure TStyle.SetTextDecorationNone(Value: Boolean);
begin
  SetProp(StyleProp_TextDecorationNone,Value,true);
end;

function TStyle.GetTextDecorationOverline: Boolean;
begin
  Result:=GetPropAsBoolean(StyleProp_TextDecorationOverline);
end;

procedure TStyle.SetTextDecorationOverline(Value: Boolean);
begin
  SetProp(StyleProp_TextDecorationOverline,Value,true);
end;

function TStyle.GetTextDecorationUnderline: Boolean;
begin
  Result:=GetPropAsBoolean(StyleProp_TextDecorationUnderline);
end;

procedure TStyle.SetTextDecorationUnderline(Value: Boolean);
begin
  SetProp(StyleProp_TextDecorationUnderline,Value,true);
end;

function TStyle.GetTextIndent: String;
begin
  Result:=GetPropAsString(StyleProp_TextIndent);
end;

procedure TStyle.SetTextIndent(Value: String);
begin
  SetProp(StyleProp_TextIndent,Value,true);
end;

function TStyle.GetTextJustify: String;
begin
  Result:=GetPropAsString(StyleProp_TextJustify);
end;

procedure TStyle.SetTextJustify(Value: String);
begin
  SetProp(StyleProp_TextJustify,Value,true);
end;

function TStyle.GetTextJustifyTrim: String;
begin
  Result:=GetPropAsString(StyleProp_TextJustifyTrim);
end;

procedure TStyle.SetTextJustifyTrim(Value: String);
begin
  SetProp(StyleProp_TextJustifyTrim,Value,true);
end;

function TStyle.GetTextKashida: String;
begin
  Result:=GetPropAsString(StyleProp_TextKashida);
end;

procedure TStyle.SetTextKashida(Value: String);
begin
  SetProp(StyleProp_TextKashida,Value,true);
end;

function TStyle.GetTextKashidaSpace: String;
begin
  Result:=GetPropAsString(StyleProp_TextKashidaSpace);
end;

procedure TStyle.SetTextKashidaSpace(Value: String);
begin
  SetProp(StyleProp_TextKashidaSpace,Value,true);
end;

function TStyle.GetTextOverflow: String;
begin
  Result:=GetPropAsString(StyleProp_TextOverflow);
end;

procedure TStyle.SetTextOverflow(Value: String);
begin
  SetProp(StyleProp_TextOverflow,Value,true);
end;

function TStyle.GetTextTransform: String;
begin
  Result:=GetPropAsString(StyleProp_TextTransform);
end;

procedure TStyle.SetTextTransform(Value: String);
begin
  SetProp(StyleProp_TextTransform,Value,true);
end;

function TStyle.GetTextUnderlinePosition: String;
begin
  Result:=GetPropAsString(StyleProp_TextUnderlinePosition);
end;

procedure TStyle.SetTextUnderlinePosition(Value: String);
begin
  SetProp(StyleProp_TextUnderlinePosition,Value,true);
end;

function TStyle.GetTop: String;
begin
  Result:=GetPropAsString(StyleProp_Top);
end;

procedure TStyle.SetTop(Value: String);
begin
  SetProp(StyleProp_Top,Value,true);
end;

function TStyle.GetUnicodeBiDi: String;
begin
  Result:=GetPropAsString(StyleProp_UnicodeBidi);
end;

procedure TStyle.SetUnicodeBiDi(Value: String);
begin
  SetProp(StyleProp_UnicodeBidi,Value,true);
end;

function TStyle.GetVerticalAlign: String;
begin
  Result:=GetPropAsString(StyleProp_VerticalAlign);
end;

procedure TStyle.SetVerticalAlign(Value: String);
begin
  SetProp(StyleProp_VerticalAlign,Value,true);
end;

function TStyle.GetVisibility: String;
begin
  Result:=GetPropAsString(StyleProp_Visibility);
end;

procedure TStyle.SetVisibility(Value: String);
begin
  SetProp(StyleProp_Visibility,Value,true);
end;

function TStyle.GetWhiteSpace: String;
begin
  Result:=GetPropAsString(StyleProp_WhiteSpace);
end;

procedure TStyle.SetWhiteSpace(Value: String);
begin
  SetProp(StyleProp_WhiteSpace,Value,true);
end;

function TStyle.GetWidows: String;
begin
  Result:=GetPropAsString(StyleProp_Widows);
end;

procedure TStyle.SetWidows(Value: String);
begin
  SetProp(StyleProp_Widows,Value,true);
end;

function TStyle.GetWidth: String;
begin
  Result:=GetPropAsString(StyleProp_Width);
end;

procedure TStyle.SetWidth(Value: String);
begin
  SetProp(StyleProp_Width,Value,true);
end;

function TStyle.GetWordBreak: String;
begin
  Result:=GetPropAsString(StyleProp_WordBreak);
end;

procedure TStyle.SetWordBreak(Value: String);
begin
  SetProp(StyleProp_WordBreak,Value,true);
end;

function TStyle.GetWordSpacing: String;
begin
  Result:=GetPropAsString(StyleProp_WordSpacing);
end;

procedure TStyle.SetWordSpacing(Value: String);
begin
  SetProp(StyleProp_WordSpacing,Value,true);
end;

function TStyle.GetWordWrap: String;
begin
  Result:=GetPropAsString(StyleProp_WordWrap);
end;

procedure TStyle.SetWordWrap(Value: String);
begin
  SetProp(StyleProp_WordWrap,Value,true);
end;

function TStyle.GetWritingMode: String;
begin
  Result:=GetPropAsString(StyleProp_WritingMode);
end;

procedure TStyle.SetWritingMode(Value: String);
begin
  SetProp(StyleProp_WritingMode,Value,true);
end;

function TStyle.GetZIndex: Integer;
begin
  Result:=GetPropAsInteger(StyleProp_ZIndex);
end;

procedure TStyle.SetZIndex(Value: Integer);
begin
  SetProp(StyleProp_ZIndex,Value,true);
end;

function TStyle.GetZoom: String;
begin
  Result:=GetPropAsString(StyleProp_Zoom);
end;

procedure TStyle.SetZoom(Value: String);
begin
  SetProp(StyleProp_Zoom,Value,true);
end;

//------------------------------------------------------------------------------
//THTMLInputElement

function THTMLInputElement.GetAccept: String;
begin
  Result:=GetPropAsString(HTMLInputElementProp_Accept);
end;

function THTMLInputElement.GetAccessKey: String;
begin
  Result:=GetPropAsString(HTMLInputElementProp_AccessKey);
end;

function THTMLInputElement.GetAlign: String;
begin
  Result:=GetPropAsString(HTMLInputElementProp_Align);
end;

function THTMLInputElement.GetAlt: String;
begin
  Result:=GetPropAsString(HTMLInputElementProp_Alt);
end;

function THTMLInputElement.GetChecked: Boolean;
begin
  Result:=GetPropAsBoolean(HTMLInputElementProp_Checked);
end;

function THTMLInputElement.GetDefaultChecked: Boolean;
begin
  Result:=GetPropAsBoolean(HTMLInputElementProp_DefaultChecked);
end;

function THTMLInputElement.GetDefaultValue: String;
begin
  Result:=GetPropAsString(HTMLInputElementProp_DefaultValue);
end;

function THTMLInputElement.GetDisabled: Boolean;
begin
  Result:=GetPropAsBoolean(HTMLInputElementProp_Disabled);
end;

function THTMLInputElement.GetForm: IDispatch;
begin
  Result:=GetPropAsDispatch(HTMLInputElementProp_Form);
end;

function THTMLInputElement.GetMaxLength: Integer;
begin
  Result:=GetPropAsInteger(HTMLInputElementProp_MaxLength);
end;

function THTMLInputElement.GetName: String;
begin
  Result:=GetPropAsString(HTMLInputElementProp_Name);
end;

function THTMLInputElement.GetOnChange: IDispatch;
begin
  Result:=GetPropAsDispatch(HTMLInputElementProp_OnChange);
end;

function THTMLInputElement.GetOnClick: IDispatch;
begin
  Result:=GetPropAsDispatch(HTMLInputElementProp_OnClick);
end;

function THTMLInputElement.GetOptions: String;
begin
  Result:=GetPropAsString(HTMLInputElementProp_Options);
end;

function THTMLInputElement.GetReadOnly: Boolean;
begin
  Result:=GetPropAsBoolean(HTMLInputElementProp_ReadOnly);
end;

function THTMLInputElement.GetSelectedIndex: Integer;
begin
  Result:=GetPropAsInteger(HTMLInputElementProp_SelectedIndex);
end;

function THTMLInputElement.GetSize: String;
begin
  Result:=GetPropAsString(HTMLInputElementProp_Size);
end;

function THTMLInputElement.GetTabIndex: Integer;
begin
  Result:=GetPropAsInteger(HTMLInputElementProp_TabIndex);
end;

function THTMLInputElement.GetType: String;
begin
  Result:=GetPropAsString(HTMLInputElementProp_Type);
end;

function THTMLInputElement.GetUseMap: String;
begin
  Result:=GetPropAsString(HTMLInputElementProp_UseMap);
end;

function THTMLInputElement.GetValue: String;
begin
  Result:=GetPropAsString(HTMLInputElementProp_Value);
end;

procedure THTMLInputElement.SetAccept(Value: String);
begin
  SetProp(HTMLInputElementProp_Accept,Value,true);
end;

procedure THTMLInputElement.SetAccessKey(Value: String);
begin
  SetProp(HTMLInputElementProp_AccessKey,Value,true);
end;

procedure THTMLInputElement.SetAlign(Value: String);
begin
  SetProp(HTMLInputElementProp_Align,Value,true);
end;

procedure THTMLInputElement.SetAlt(Value: String);
begin
  SetProp(HTMLInputElementProp_Alt,Value,true);
end;

procedure THTMLInputElement.SetChecked(Value: Boolean);
begin
  SetProp(HTMLInputElementProp_Checked,Value,true);
end;

procedure THTMLInputElement.SetDefaultChecked(Value: Boolean);
begin
  SetProp(HTMLInputElementProp_DefaultChecked,Value,true);
end;

procedure THTMLInputElement.SetDefaultValue(Value: String);
begin
  SetProp(HTMLInputElementProp_DefaultValue,Value,true);
end;

procedure THTMLInputElement.SetDisabled(Value: Boolean);
begin
  SetProp(HTMLInputElementProp_Disabled,Value,true);
end;

procedure THTMLInputElement.SetMaxLength(Value: Integer);
begin
  SetProp(HTMLInputElementProp_MaxLength,Value,true);
end;

procedure THTMLInputElement.SetName(Value: String);
begin
  SetProp(HTMLInputElementProp_Name,Value,true);
end;

procedure THTMLInputElement.SetOnChange(Value: IDispatch);
begin
  SetProp(HTMLInputElementProp_OnChange,Value,true);
end;

procedure THTMLInputElement.SetOnClick(Value: IDispatch);
begin
  SetProp(HTMLInputElementProp_OnClick,Value,true);
end;

procedure THTMLInputElement.SetOptions(Value: String);
begin
  SetProp(HTMLInputElementProp_Options,Value,true);
end;

procedure THTMLInputElement.SetReadOnly(Value: Boolean);
begin
  SetProp(HTMLInputElementProp_ReadOnly,Value,true);
end;

procedure THTMLInputElement.SetSelectedIndex(Value: Integer);
begin
  SetProp(HTMLInputElementProp_SelectedIndex,Value,true);
end;

procedure THTMLInputElement.SetSize(Value: String);
begin
  SetProp(HTMLInputElementProp_Size,Value,true);
end;

procedure THTMLInputElement.SetTabIndex(Value: Integer);
begin
  SetProp(HTMLInputElementProp_TabIndex,Value,true);
end;

procedure THTMLInputElement.SetType(Value: String);
begin
  SetProp(HTMLInputElementProp_Type,Value,true);
end;

procedure THTMLInputElement.SetUseMap(Value: String);
begin
  SetProp(HTMLInputElementProp_UseMap,Value,true);
end;

procedure THTMLInputElement.SetValue(Value: String);
begin
  SetProp(HTMLInputElementProp_Value,Value,true);
end;

end.
